$!	**** DISKSPACE.COM ****
$!
$!  This command file is designed to obtain the disk space being
$!  allocated to each user by his UIC.  This version is designed
$!  to work only with VMS Version 2.0 for the VAX11/780.
$!
$ VER_MODE = 'F$VERIFY()'
!$ SET NOVERIFY
$!
$ DEASSIGN SYS$OUTPUT
$ OPEN FILE_1 'DISK_DIR'DISKSPACE.DAT/ERR=NO_FILE_1
$ CLOSE FILE_1
$ DELETE 'DISK_DIR'DISKSPACE.DAT;*/LOG
$ NO_FILE_1:
$ ASSIGN 'DISK_DIR'DISKSPACE.DAT SYS$OUTPUT
$ RUN SYS$SYSTEM:DISKQUOTA
USE DISK$USER
SHOW [*,*]
EXIT
$ DEASSIGN SYS$OUTPUT
$ SORT 'DISK_DIR'DISKSPACE.DAT -
'DISK_DIR'DISKSPACE.DAT/KEY=(POS:2,SIZE:6,NUMBER:1)-
/KEY=(POS:9,SIZE:6,NUMBER:2)
$ PURGE 'DISK_DIR'DISKSPACE.DAT/LOG
$!
$!  List the current users by UIC
$!
$ OPEN FILE_2 'DISK_DIR'USERNAME.DAT/ERR=NO_FILE_2
$ CLOSE FILE_2
$ DELETE 'DISK_DIR'USERNAME.DAT;*/LOG
$ NO_FILE_2:
$!
$ ASSIGN 'DISK_DIR'USERNAME.DAT SYS$OUTPUT
$ RUN SYS$SYSTEM:WHO
SHOW [*,*]
EXIT
$ DEASSIGN SYS$OUTPUT
$!
$!  Combine two new data files and generate a disk usage by name file
$!
$ SET NOVERIFY
$!
$ OPEN FILE_3 'DISK_DIR'NAMESPACE.DAT/ERR=NO_FILE_3
$ CLOSE FILE_3
$ DELETE 'DISK_DIR'NAMESPACE.DAT;*/LOG
$ NO_FILE_3:
$!
$ OPEN NAME 'DISK_DIR'USERNAME.DAT/ERR=ERR_NO_USER
$ OPEN SPACE 'DISK_DIR'DISKSPACE.DAT/ERR=ERR_NO_DISK
$ OPEN COMBINED 'DISK_DIR'NAMESPACE.DAT/WRITE/ERR=ERR_NO_COMB
$ ON CONTROL_Y THEN GOTO EXIT_ALL
$ ON ERROR THEN GOTO EXIT_ALL
$!
$!  Skip first record in disk space file
$!
$ READ SPACE DUMMY
$!
$!  Cross-reference UIC vs. disk space used
$!
$ NEXT_UIC:
$ READ SPACE SPACE_BUF/END=EOF_SPACE
$ UIC_SPACE := 'F$EXTRACT(0,16,SPACE_BUF)
$ UIC_SP_GR = 'F$EXTRACT(1,6,UIC_SPACE)'
$ IF UIC_SP_GR .LT. 7 THEN GOTO NEXT_UIC
$ UIC_SP_OW = 'F$EXTRACT(8,6,UIC_SPACE)'
$ UIC_BLOCK := 'F$EXTRACT(17,7,SPACE_BUF)
$!
$ NEXT_NAME:
$	READ NAME NAME_BUF/END=ERR_NO_MATCH
$	UIC := 'F$EXTRACT(1,9,NAME_BUF)
$	UIC_GR = 'F$EXTRACT(1,3,UIC)'
$	UIC_OW = 'F$EXTRACT(5,3,UIC)'
$!
$ IF UIC_SP_GR .NE. UIC_GR THEN GOTO NEXT_NAME
$ IF UIC_SP_OW .NE. UIC_OW THEN GOTO NEXT_NAME
$!
$!  UIC match found, write out name vs. space used
$!
$ LEN = 'F$LENGTH(NAME_BUF)'
$ LEN = LEN - 12
$ NAME := 'F$EXTRACT(11,LEN,NAME_BUF)
$ BUF_OUT := "'"'NAME'"' "'UIC_BLOCK'
$ WRITE COMBINED BUF_OUT
$ GOTO NEXT_UIC
$!
$!  No more user names to process
$!
$ EOF_SPACE:
$!
$ EXIT_ALL:
$	SET VERIFY
$	CLOSE NAME
$	CLOSE SPACE
$	CLOSE COMBINED
$	DELETE 'DISK_DIR'DISKSPACE.DAT;*/LOG
$	DELETE 'DISK_DIR'USERNAME.DAT;*/LOG
$	COPY 'DISK_DIR'NAMESPACE.DAT 'DISK_DIR'DSKUSG.DAT/LOG/WR
$	DELETE 'DISK_DIR'NAMESPACE.DAT;*/LOG
$	IF VER_MODE THEN SET VERIFY
$	EXIT
$!
$!  Error Messages
$!
$ ERR_NO_USER:
$ WRITE SYS$OUTPUT "%DISKSPACE-F-NO_USER..no user name file found."
$ GOTO EXIT_ALL
$!
$ ERR_NO_DISK:
$ WRITE SYS$OUTPUT "%DISKSPACE-F-NO_DISK..no disk space file found."
$ GOTO EXIT_ALL
$!
$ ERR_NO_COMB:
$ WRITE SYS$OUTPUT "%DISKSPACE-F-COMB..combined data file not opened."
$ GOTO EXIT_ALL
$!
$ ERR_NO_MATCH:
$ WRITE SYS$OUTPUT "%DISKSPACE-W-NOMATCH..no match found for ''UIC_SPACE'"
$ CLOSE NAME
$ OPEN NAME 'DISK_DIR'USERNAME.DAT/ERR=ERR_NO_USER
$ GOTO NEXT_UIC
