	PROGRAM VAXUSE
C	VAXUSE - THIS PROGRAM TRANSLATES VAX USE STATISTICS GENERATED BY
C		 PROGRAM ACCTINFO INTO RESOURCE UNIT VALUES.  THE REPORT FILE
C		 GENERATED BY ACCTINFO SHOULD BE USED AS THE INPUT FILE.
C
C	THIS PROGRAM WAS MODIFIED TO OBTAIN THE NUMBER OF BLOCKS
C	OF DISK SPACE IN USE BY EACH USER INSTEAD OF ENTERING THE
C	DATA BY HAND.  MODIFIED BY R. OLDS, THIS PROGRAM WAS
C	ORIGINALLY OBTAINED FROM THE FALL 1980 DECUS RELEASE.
C
C	R. OLDS  AF WEAPONS LAB  MAY 27, 1980
C	J. THOMPSON  INTERMETRICS  NOVEMBER 23, 1978
C
	INCLUDE 'VAXUSE.CMM'
C
	CHARACTER*3 DASH
C
	DATA CHG_RATE/100.00/		! $100 PER RESOURCE UNIT
	DATA NUM_ACCTS/100/, ACCT_LIST/100*'        '/
C
	DASH=' - '
C
C	DEFINE DEFAULT RESOURCE UNIT FACTORS (MULTIPLIERS)
C
	FCT=1.0/500.0		!CONNECT TIME
	FCP=1.0			!CPU TIME (APPLIED TO CPU HOURS)
	FPP=1.0/2000.0		!PAGES PRINTED
	FIOB=1.0/750000.0	!BUFFERED IO BLOCKS
	FIOD=1.0/400000. 	!DIRECT IO BLOCKS
	FDB=1.0/175000.0	!DISK BLOCK STORAGE FACTOR
	FSU=1.0/1.0		!SYSTEM UNIT FACTOR (1 S.U. = 1 R.U.)
	SPACEMAX=500000.0	!MAX DISK BLOCK STORAGE PER USER. AFTER THIS
				!MUCH STORAGE IS USED PENALTY IS > ONE.
C
C	OPEN I/O FILES
C
	OPEN (UNIT=1, NAME='INPUT_DATA', TYPE='OLD', READONLY)
	OPEN (UNIT=2, NAME='OUTPUT_DATA', TYPE='NEW')
	OPEN (UNIT=3, NAME='DISK_DATA', TYPE='OLD', READONLY)
	OPEN (UNIT=4, NAME='OUTPUT_DATA2', TYPE='NEW')
	OPEN (UNIT=10, NAME='USERTOT.DAT', TYPE='SCRATCH',
	1	FORM='UNFORMATTED')
C
C	READ UNTIL FIND "USERNAME"
C
300	READ(1,20,END=600) USERNAME
20	FORMAT(' ',A)
	IF(USERNAME.NE.'USERNAME    ') GO TO 300
C
C	WRITE TITLE, ETC. FOR OUTPUT FILE
C
	WRITE(2,30) CHG_RATE
30	FORMAT('1',T25,'***  VAX RESOURCE UNIT USE SUMMARY  ***',//
	1 1X, 'BASE CHARGE RATE IS $', F6.2 '/SYSTEM UNIT', //,
     2	   ' USERNAME',T15,'CONNECT RU',T30,'CPU RU',
     3	   T38,'BUF IO RU',T49,'DIR IO RU',T61,'PRINT RU',
     4	   T73,'DISK RU',T83,'TOTAL SU',T90,'      ACCOUNT',
	5	5X, 'CHARGES', //, 1X, 115(1H-), /)
C
C	ZERO SUMS
C
	SUMCT=0.0
	SUMCP=0.0
	SUMPP=0.0
	SUMIOB=0.0
	SUMIOD=0.0
	SUMBLKS=0.0
	SUMRU=0.0
	SUMSU=0.0
	N_DATA = 0
C
C	MAIN LOOP
C
40	FORMAT(' ',A12,I10,I7,':',I2,':',I2,F12.0,5I10, 7X, A8)
400	READ(1,40,END=500,ERR=500) USERNAME, JUNK, IHRS, IMINS, ISECS,
	1	CPU_SEC, IOB, IOD, LUNK, MUNK, IPAGES, ACCOUNT(1:8)
C
	N_DATA = N_DATA + 1			! Count no. of data records
	IF(USERNAME(1:1).EQ.' ' .AND.		! Check for end of data
	1	N_DATA.GT.1) GOTO 500
C	GET DISK BLOCK USEAGE FOR THIS USER
C
	REWIND 3
410	READ (3, *, END=420) DISK_USER, NUM_BLOCKS
	IF (DISK_USER .NE. USERNAME(1:9)) GOTO 410
	BLOCKS = FLOAT(NUM_BLOCKS)
	GOTO 450
C
C   *** USER HAS NO DISK FILE SPACE ALLOCATED ***
C
420	BLOCKS = 0.0
C
C	USE FACTOR PENALTY WHEN DISK BLOCKS EXCEED SPACEMAX
C
450	PENALTY = (BLOCKS-SPACEMAX) * 4.0
	IF (PENALTY .LT. 0.0) PENALTY = 0.0
C
	CTHRS=IHRS+((IMINS/60.0)+(ISECS/3600.0))
	CPHRS=CPU_SEC/3600.0
	BIO=IOB
	DIO=IOD
	PGS=IPAGES
C
	CTRU=CTHRS*FCT
	CPRU=CPHRS*FCP
	BIORU=BIO*FIOB
	DIORU=DIO*FIOD
	PGSRU=PGS*FPP
	BLKRU=FDB * (BLOCKS + PENALTY)
	RU=CTRU+CPRU+BIORU+DIORU+PGSRU+BLKRU
	SU=RU*FSU
C
	SUMCT=SUMCT+CTRU
	SUMCP=SUMCP+CPRU
	SUMIOB=SUMIOB+BIORU
	SUMIOD=SUMIOD+DIORU
	SUMPP=SUMPP+PGSRU
	SUMBLKS=SUMBLKS+BLKRU
	SUMRU=SUMRU+RU
	SUMSU=SUMSU+SU
C
C   *** CK FOR NO ACCOUNT NUMBER INFO ***
	IF (ACCOUNT(1:1) .EQ. ' ') ACCOUNT = 'UNKNOWN '
	IF (USERNAME .EQ. 'JOB_CONTROL') ACCOUNT = 'SYSTEM'
	IF (USERNAME .EQ. 'SYSTEM') ACCOUNT = 'SYSTEM'
C
C   *** IS THIS A NEW ACCOUNT NUMBER ***
	CALL ACCT_ADD 
C
	WRITE(2,50) USERNAME,CTRU,CPRU,BIORU,DIORU,PGSRU,BLKRU,SU,DASH,
	1	ACCOUNT(1:8), SU*CHG_RATE
50	FORMAT(' ',A12,7(1X,F10.3),A3, 1X, A, 2X, '$',F9.2)
C
C   *** MAKE ENTRY IN USER TOTAL SCRATCH FILE ***
	WRITE (10) USERNAME, IHRS, IMINS, ISECS, CPU_SEC, IPAGES,
	1	BLOCKS, ACCOUNT, SU*CHG_RATE
	GO TO 400	!CONTINUE LOOP
C
C	WRITE SUMMARY
C
500	WRITE(2,60)
60	FORMAT(' ')
	USERNAME='**TOTALS**  '
	WRITE(2, 55) USERNAME,SUMCT,SUMCP,SUMIOB,SUMIOD,SUMPP,SUMBLKS,
	1	SUMSU, SUMSU*CHG_RATE
55	FORMAT(' ',A12,7(1X,F10.3),14X, '$',F9.2)
C
C   *** WRITE OUT TIMES STORED FOR ACCOUNTING DATA ***
	READ (1, 70) RUN_LINE
70	FORMAT (////////, A)
C
	CALL DATE (RUN_DATE)
	CALL TIME (RUN_TIME)
	WRITE (2, 80) RUN_DATE, RUN_TIME
80	FORMAT (1H0, 'Accounting job run on ', A, ' at ', A)
C
	WRITE (2, 90) RUN_LINE
90	FORMAT (A, /)
C
C  *** RUN TOTALS FOR EACH ACCOUNT ***
	CALL ACCT_TOTAL
C
	STOP 'VAXUSE--STOP OK'
C
C	INPUT FILE ERROR
C
600	TYPE *, 'INPUT FILE READ ERROR'
	STOP 'VAXUSE--ERROR, INPUT FILE ERROR'
C
	END

	SUBROUTINE ACCT_ADD 
C
C   *** SEGMENT (CHECK IF THIS IS THE FIRST TIME THIS ACCOUNT NUMBER
C   ***          HAS BEEN ENCOUNTERED, IF SO, ADD IT TO THE TOTAL
C   ***		 ACCOUNT LIST FOR LATER PROCESSING)
C
	INCLUDE 'VAXUSE.CMM'
C
C   *** CK IF THIS ACCOUNT IS ALREADY ON FILE ***
	DO 10 I=1, NUM_ACCTS
C
		INDEX = I
		IF (ACCT_LIST(I) .EQ. '        ') GOTO 20
		IF (ACCOUNT .EQ. ACCT_LIST(I)) GOTO 30
10		CONTINUE
C
C   *** ACCOUNT TABLE FULL, SIZE SHOULD BE INCREASED ***
	TYPE 9000, NUM_ACCTS
	GOTO 30
C
C   *** ADD NEW ACCOUNT ***
20	ACCT_LIST(INDEX) = ACCOUNT
D	TYPE 9010, ACCOUNT, INDEX
C
30	RETURN
C
9000	FORMAT (' ***** WARNING == ACCOUNTING TABLE OVERFLOW', /,
	1	'                  TOTAL ENTRIES = ',I5)
9010	FORMAT (1X, A, ' ADDED TO ACCOUNT FILE, INDEX=', I5)
	END

	SUBROUTINE ACCT_TOTAL 
C
C   *** SEGMENT (PRINT TOTALS OF EACH ACCOUNT NUMBER FOUND)
C
	INCLUDE 'VAXUSE.CMM'
C
	DIMENSION KHAR_CONT(2)
C
	CHARACTER*1 FLAG
C
	DATA KSCR/10/			! SCRATCH FILE IS FOR010
	DATA NCOPY/2/
	DATA KHAR_CONT/0, 1/
C
C   *** SORT ACCOUNT ID LIST ***
	CALL SORT_ACCT
C
C   *** PRINT PAGE EJECT ***
	WRITE (2, 9040)
C
C   *** SET UP FILE NUMBERS FOR OUTPUT ***
	IOUT = 0
C
C   *** MAKE TWO COPIES (1 FOR PROJ. OFF., 1 FOR RECORDS) ***
	DO 1000 J=1, NCOPY
C
	IOUT = IOUT + 2

C	    *** WRITE TOTALS FOR EACH ACCOUNT ***
		DO 30 I=1, NUM_ACCTS
C
			TOT_CHARGE = 0.0
			IFLAG = 0
C
C		    *** IF ACCOUNT IS BLANK, END REACHED ***
			IF (ACCT_LIST(I) .EQ. ' ') GOTO 1000
C
C		    *** PRINT ACCOUNT HEADING ***
			WRITE (IOUT, 9000) KHAR_CONT(J), ACCT_LIST(I),
	1				RUN_LINE, CHG_RATE
C
C		    *** READ DATA TAPE TILL EOF FOUND ***
			REWIND KSCR
10			READ (KSCR, END=20) USERNAME, IHRS, IMINS, 
	1		ISECS, CPU_SEC, IPAGES, BLOCKS, ACCOUNT,
	2		CHARGES
C
C		    *** IF NOT PROPER ACCOUNT, READ NEXT RECORD ***
			IF (ACCOUNT .NE. ACCT_LIST(I)) GOTO 10
C
C		    *** GOOD ENTRY FOUND, ADD TO TOTAL ***
			TOT_CHARGE = TOT_CHARGE + CHARGES
			FLAG = ' '
			IF (BLOCKS .GT. SPACEMAX) FLAG = '*'
			IF (BLOCKS .GT. SPACEMAX) IFLAG = 1
			WRITE (IOUT, 9020) USERNAME, IHRS, IMINS, ISECS,
	1		CPU_SEC, IPAGES, IFIX(BLOCKS), FLAG,
	2		ACCOUNT, CHARGES
			GOTO 10
C
C		    *** END OF INPUT FILE WAS READ ***
20			WRITE (IOUT, 9030) TOT_CHARGE
			IF (IFLAG.GT.0 .AND. J.EQ.2) WRITE (2, 9010)
	1				IFIX(SPACEMAX)
C
30			CONTINUE
C
1000		CONTINUE
C
	RETURN
C
9000	FORMAT (I1,//,
	1	1X, 'ARLO Advanced Data Acquisition System Computer',
	2	' Charges for Account <', A,'>',//,
	3	A, /, 1X, 'Base Charge Rate is $', F6.2,
	3	'/System Unit',//,
	4	1X, 78(1H-),/, 
	5	1X, 'Username     Connect Time CPU-Seconds ',
	6	'Print Pgs Disk Blocks Account   Charges',/,
	7	1X, 78(1H-),/)
9010	FORMAT (1H0,'WARNING === Any user whose disk block counts are'/,
	1	1X, '            flagged with an "*" are exceeding',/,
	2	1X, '            the maximum file allocation of',/,
	3	1X, '            ', I5,' disk blocks.')
9020	FORMAT (1X, A12, 1X, I4, ':', I2,':',I2, 1X,F11.0,
	1	4X,I5, 5X,I6,A1, 4X,A8, '$',F9.2)
9030	FORMAT (/,1X,78(1H-),//,
	1	33X, ' Total Charges for this Account is $', F10.2)
9040	FORMAT (1H1)
	END

	SUBROUTINE SORT_ACCT
C
C   *** SEGMENT (SORT ACCOUNTING IDS)
C
	INCLUDE 'VAXUSE.CMM'
C
	CHARACTER*8 TEMP
C
	DO 100 I=1, NUM_ACCTS
C
		NEND = NUM_ACCTS - I
		DO 100 J=NEND, 1, -1
C
			IF (ACCT_LIST(J+1) .EQ. '        ') GOTO 100
			IF (ACCT_LIST(J+1) .GT. ACCT_LIST(J)) GOTO 100
C
			TEMP = ACCT_LIST(J)
			ACCT_LIST(J) = ACCT_LIST(J+1)
			ACCT_LIST(J+1) = TEMP
C
100			CONTINUE
C
	RETURN
	END
