$!---------------------------------------------------------------------
$!             LF Command -  By Scott B. Sibley   1 Oct 80
$!---------------------------------------------------------------------
$!
$! List Files:  LF [file-spec][-COL|-OUT|-SUM] | -F | -H {current-dir}
$!
$!     This command file processes multiple files by reading file
$!     names from a saved "DIR" list built according to parameter 1.
$!
$!     GLOBAL SYMBOLS used:  UtilityDir, TempDir, HelpDir, Out, it
$!     FILES used:  "TempDir"ZZ.LF, DIR.LIS, "HelpDir"lf.hlp
$!
$!---------------------------------------------------------------------
$      lognam := "XXX"  ! VAX looks up "lognam" even if skipped by "GOTO"
$!---------------------------------------------- Process option
$      spec := ""
$      outfile := "TT:"
$      LFprog := "LF"
$      opt := ""
$      arg = 0
$Next:    arg = arg + 1
$         it := ""
$         IF arg .EQ. 1 THEN it := "''P1'"
$         IF arg .EQ. 2 THEN it := "''P2'"
$         IF arg .EQ. 3 THEN it := "''P3'"
$         IF it .EQS. "" THEN GOTO DelSym
$         IF "''F$EXT(0,1,it)'" .EQS. "-" THEN GOTO TryOpt
$            spec := "''it'"
$            it :== "''it'"
$            GOTO Next
$TryOpt:  opt := 'F$EXT(0,2,it)'
$         IF opt .EQS. "-F" .OR. opt .EQS. "-H" THEN GOTO INFO
$         last = "''F$LOC(":",it)'" + 1
$         IF opt .EQS. "-O" THEN outfile := "''F$EXT(last,99,it)'"
$         IF opt .EQS. "-P" THEN LFprog := "''F$EXT(last,99,it)'"
$         IF opt.EQS."-C".OR.opt.EQS."-O".OR.opt.EQS."-S" THEN GOTO Next
$         IF opt.EQS."-P" THEN GOTO Next
$            Out "       LF - Invalid Option:  ''it'"
$            EXIT
$DelSym:DEL/SYMBOL/LOC arg
$!---------------------------------------------- Check Options
$      IF outfile .EQS. "TT:" THEN GOTO OptOK
$      IF outfile .EQS. "" THEN outfile := "DIR.LIS"
$      OPEN/WRIT/ERR=NoOut DIRSAVE 'outfile'
$      GOTO OptOk
$NoOut:   Out "       LF - Cannot open Output file:  ",outfile
$         EXIT
$OptOK:
$      IF LFprog .EQS. "" THEN LFprog := "LFPACK"
$!----------------------------------------------- Set FileSpec Parts
$      loc = 'F$LOC("]",spec) + 1
$      PathName := ""
$      IF loc .LE. 'F$LEN(spec)' THEN GOTO GetPath
$         loc = 'F$LOC(":",spec) + 1
$         IF loc .GT. 'F$LEN(spec) THEN GOTO CkVer
$         len = loc - 1
$         lognam := "''F$EXT(0,len,spec)'"
$         PathName := "''F$LOGI(lognam)'"
$         IF PathName .EQS. "" THEN GOTO GetPath
$            spec := "''F$EXT(loc,80,spec)'"
$            GOTO CkVer
$GetPath: PathName := "''F$EXT(0,loc,spec)'"
$         spec := "''F$EXT(loc,80,spec)'"
$CkVer:loc = 'F$LOC(";",spec)
$      Version := ";*"
$      IF loc .EQ. 'F$LEN(spec) THEN GOTO CkTyp
$         Version := "''F$EXT(loc,80,spec)'"
$         spec := "''F$EXT(0,loc,spec)'"
$CkTyp:loc = 'F$LOC(".",spec)
$      FileName := "''spec'"
$      IF FileName .EQS. "" THEN FileName := "*"
$      FileType := ".*"
$      IF loc .EQ. 'F$LEN(spec) THEN GOTO Concatenate
$         FileName := "''F$EXT(0,loc,spec)'"
$         FileType := "''F$EXT(loc,80,spec)'"
$Concatenate:
$      FileSpec := "''PathName'''FileName'''FileType'''Version'"
$!------------------------------------------------ Get Directory Title
$      KeepDir := "''F$DIR()'"
$      IF PathName .NES. "" THEN SET DEF 'PathName'
$      TitleDir := "''F$DIR()'"
$      IF PathName .NES. "" THEN SET DEF DBA0:'KeepDir'
$      Out " Directory:  ", TitleDir
$!------------------------------------------------ Get Temp File for Dir
$      proc := "''F$PROC()'"     !  Try to get User's name
$      IF "''F$EXT(0,1,proc)'" .EQS. "_" THEN proc := ZZ
$      TempFile := "''TempDir'''proc'.LF"
$!-----------------------------------------------
$      IF opt.NES."-P" .AND. opt.NES."" THEN GOTO Column
$!------------------------------------------------ Print Condensed List
$      DIRECTORY/COL=1/BRIEF/OUT='TempFile' 'FileSpec'
$      OPEN/ERR=NoDir FOR001 'TempFile'
$      READ FOR001 Line
$      IF "''F$EXTR(2,5,Line)'" .EQS. "No fi" THEN Out " No such files"
$      ON Control_Y THEN GOTO Quit
$      ON Warning THEN GOTO Quit
$      RUN 'UtilityDir''LFprog'
$Quit: ON Control_Y THEN EXIT
$      ON Warning THEN EXIT
$      CLOSE FOR001
$      GOTO Del
$!------------------------------------------------ Option Requested
$Column:
$      Echo := WR SYS$OUTPUT
$      IF opt .EQS. "-C" THEN GOTO ListNames
$         Echo := "!"
$      IF opt .EQS. "-S" THEN GOTO ListNames
$         Echo := WR DIRSAVE
$ListNames:
$      ON Control_Y THEN GOTO EOF
$      ON Warning THEN GOTO EOF
$      DIRECTORY/SIZE=ALL/DATE/OUT='TempFile' 'FileSpec'
$      OPEN DIRFILE 'TempFile'
$      READ DIRFILE Line
$      READ/END=EOF DIRFILE Line
$      READ/END=EOF DIRFILE Line
$READ: READ/END=EOF DIRFILE Line       ! Line has CR,LF at front
$      IF Line .EQS. "" THEN GOTO Prt
$      Echo "''Line'"                          !  File Entry
$      GOTO READ
$Prt:
$      READ/END=EOF DIRFILE Line
$      Out " ''Line'"   !  TOTALS Line
$EOF:  CLOSE DIRFILE
$Del:  DELETE 'TempFile';*
$      IF opt .EQS. "-O" THEN CLOSE DIRSAVE
$NoDir:EXIT
$!------------------------------------------------
$INFO: Out "       List Files:  LF [file-spec][-COL|-OUT|-SUM|-PACK] |", -
                        "-F|-H {current-dir}"
$      IF opt .NES. "-F" THEN fmt 'HelpDir'lf.hlp TT:
