$!---------------------------------------------------------------------
$!             PG Command -  By Scott B. Sibley   24 Sept 80
$!---------------------------------------------------------------------
$!
$! Page Files:  PG [file-spec][-PAGELEN:n][-READ] | -F | -H {'SaveFile'}
$!
$!     This command file processes multiple files by reading file
$!     names from a saved "DIR" list built according to parameter 1.
$!
$!     GLOBAL SYMBOLS used:  SaveFile, HelpDir, Out, it
$!     FILES used:  DIRLIST.PGC;77, 'HelpDir'pg.hlp
$!
$!---------------------------------------------------------------------
$!---------------------------------------------- Process option
$      pagelen = 22
$      ReadMode := "NO"
$      arg = 0
$Next:    arg = arg + 1
$         it := ""
$         IF arg .EQ. 1 THEN it := "''P1'"
$         IF arg .EQ. 2 THEN it := "''P2'"
$         IF arg .EQ. 3 THEN it := "''P3'"
$         IF it .EQS. "" THEN GOTO DelSym
$         IF "''F$EXT(0,1,it)'" .EQS. "-" THEN GOTO TryOpt
$            file := "''it'"
$            it :== "''it'"
$            GOTO Next
$TryOpt:  opt := 'F$EXT(0,2,it)'
$         IF opt .EQS. "-F" .OR. opt .EQS. "-H" THEN GOTO INFO
$         last = "''F$LOC(":",it)'" + 1
$         IF opt .EQS. "-P" THEN pagelen = "''F$EXT(last,4,it)'"
$         IF opt .EQS. "-R" THEN ReadMode := "YES"
$         IF opt.EQS."-P".OR.opt.EQS."-R" THEN GOTO Next
$            Out "       PG - Invalid Option:  ''it'"
$            EXIT
$DelSym:DELETE/SYMBOL/LOC arg
$!---------------------------------------------- Check Options
$      IF pagelen .GT. 0 THEN GOTO CkFil
$         Out "       PG - Invalid page length:  ",pagelen
$         EXIT
$!---------------------------------------------- Check file-spec
$CkFil:it := 'file'
$      IF it .NES. "" THEN GOTO FileGiven
$!---------------------------------------------- Page Remembered File
$      Remembered := "YES"
$      FileSpec := 'SaveFile'
$      GOTO OpenPageFile
$!---------------------------------------------- Page Multiple Files
$FileGiven:
$!     SetDefFileType 'it' ".*"
$!----------------------------------------------- Set ".*" Type
$      spec := "''it'"
$CkDir:loc = 'F$LOC("]",spec) + 1
$      PathName := ""
$      IF loc .GT. 'F$LEN(spec) THEN GOTO CkVer
$      PathName := 'F$EXT(0,loc,spec)
$      spec := 'F$EXT(loc,80,spec)
$CkVer:loc = 'F$LOC(";",spec)
$      Version := ";"
$      IF loc .EQ. 'F$LEN(spec) THEN GOTO CkTyp
$      Version := 'F$EXT(loc,80,spec)
$      spec := 'F$EXT(0,loc,spec)
$CkTyp:loc = 'F$LOC(".",spec)
$      FileName := 'spec'
$      FileType := ".*"
$      IF loc .EQ. 'F$LEN(spec) THEN GOTO Concatenate
$      FileName := 'F$EXT(0,loc,spec)
$      FileType := 'F$EXT(loc,80,spec)
$Concatenate:
$      FileSpec := 'PathName''FileName''FileType''Version'
$!-----------------------------------------------
$      Remembered := "NO"
$      DIRECTORY/COL=1/BRIEF/OUT=DIRLIST.PGC;77 'FileSpec'
$      OPEN DIRFILE DIRLIST.PGC;77
$      READ DIRFILE Line
$      READ/END=EOF DIRFILE Line
$      READ/END=EOF DIRFILE Line
$!---------------------------------------
$ReadDirFile:
$      ON Warning THEN GOTO EOF
$      ON Control_Y THEN GOTO EOF
$      READ/END=EOF DIRFILE Line
$      FileName := "''Line'"
$      IF FileName .EQS. "" THEN GOTO EOF
$      FileSpec := "''PathName'''FileName'"
$!----------------------------------------- Page a File
$OpenPageFile:
$      IF ReadMode .EQS. "NO" THEN Out "File: ", FileSpec
$      loc = 'F$LOC(".",FileSpec)' + 1
$      ext := "''F$EXT(loc,3,FileSpec)'"
$      IF ext.EQS."OBJ" .OR. ext.EQS."EXE" THEN GOTO ReadDirFile
$      IF ext.EQS."DIR" .OR. ext.EQS."OLB" THEN GOTO ReadDirFile
$      OPEN PAGEFILE 'FileSpec'
$      ON Warning THEN GOTO Cancel
$      ON Control_Y THEN GOTO Cancel
$      linenum = 0
$      numlines = 0
$      Print := "YES"
$GetLine:
$      READ/END=ClosePageFile PAGEFILE Line
$      IF numlines .LT. pagelen THEN GOTO Type
$Ask:     INQ/L ans ""
$         ans := "''F$EXT(0,1,ans)'"
$         IF ans .EQS. "Q" THEN GOTO ClosePageFile
$         linenum = linenum + numlines
$         numlines = 0
$         Print := "YES"
$         IF ans .EQS. "/" THEN Print := "NO"
$         IF ans.NES."?" .AND. ans.NES."=" .AND.ans.NES."H" THEN GOTO Type
$         IF ans .EQS. "?" THEN Out "File: ", FileName
$         IF ans .EQS. "=" THEN Out "Line number = ", linenum
$         IF ans .EQS. "H" THEN Out "Enter H,?,=,/,Quit; else continue"
$         GOTO Ask
$Type: numlines = numlines + 1
$      IF Print .EQS. "YES" THEN Out Line
$      GOTO GetLine
$ClosePageFile:
$      CLOSE PAGEFILE
$      IF Remembered .EQS. "YES" THEN EXIT
$      GOTO ReadDirFile
$Cancel:
$      CLOSE PAGEFILE
$      IF Remembered .EQS. "YES" THEN EXIT
$!-----------------------------------------
$EOF:  CLOSE DIRFILE
$      DELETE DIRLIST.PGC;77
$      EXIT
$!----------------------------------------------
$INFO:
$Out "       Page Files:  PG [file-spec][-PAGELEN:n]",-
               "[-READ] | -F | -H {'SaveFile'}"
$      IF "''F$EXT(0,2,P1)'" .NES. "-F" THEN fmt 'HelpDir'pg.hlp TT:
