$!---------------------------------------------------------------------
$!            TREE Command -  By Scott B. Sibley   4 Nov 80
$!---------------------------------------------------------------------
$!
$! Walk Directory Tree:  TREE [path][-C:cmd][-L:#lev][-O[:file]] {cur-dir}
$!
$!     This command file processes multiple files by reading file
$!     names from a saved "DIR" list built according to parameter 1.
$!
$!     GLOBAL SYMBOLS used:  CD, HelpDir, Out
$!     FILES used:  DIR.TRE, 'HelpDir'tree.hlp, TREE.LIS
$!
$!---------------------------------------------------------------------
$      ON Error THEN EXIT
$!---------------------------------------------- Process option
$      TreeDirPath := ""
$      MaxLevel = 99
$      outfile := "TT:"
$      CmdLine := "!"
$      arg = 0
$Next:    arg = arg + 1
$         it := ""
$         IF arg .EQ. 1 THEN it := "''P1'"
$         IF arg .EQ. 2 THEN it := "''P2'"
$         IF arg .EQ. 3 THEN it := "''P3'"
$         IF it .EQS. "" THEN GOTO DelSym
$         IF "''F$EXT(0,1,it)'" .EQS. "-" THEN GOTO TryOpt
$            TreeDirPath := "''it'"
$            GOTO Next
$TryOpt:  opt := 'F$EXT(0,2,it)'
$         IF opt .EQS. "-F" .OR. opt .EQS. "-H" THEN GOTO INFO
$         last = "''F$LOC(":",it)'" + 1
$         IF opt .EQS. "-L" THEN MaxLevel = "''F$EXT(last,4,it)'"
$         IF opt .EQS. "-O" THEN outfile := "''F$EXT(last,50,it)'"
$         IF opt .EQS. "-C" THEN CmdLine := "''F$EXT(last,50,it)'"
$         IF opt.EQS."-L".OR.opt.EQS."-O".OR.opt.EQS."-C" THEN GOTO Next
$            Out "       TREE - Invalid Option:  ''it'"
$            EXIT
$DelSym:DELETE/SYMBOL/LOC arg
$!---------------------------------------------- Check Options
$      IF MaxLevel .GT. 0 THEN GOTO CkOut
$         Out "       TREE - Invalid #levels:  ",MaxLevel
$         EXIT
$CkOut:IF outfile .EQS. "" THEN outfile := "TREE.LIS"
$      OPEN/WRIT/ERR=NoOut TREEFILE 'outfile'
$      GOTO CkDir
$NoOut:   Out "       TREE - Cannot open Output file:  ",outfile
$         EXIT
$CkDir:OrigDir := "''F$DIR()'"
$      IF TreeDirPath .EQS. "" THEN GOTO Init
$      SET DEF 'TreeDirPath'
$!---------------------------------------------- Get List of Directories
$Init: Level = 0
$      prefix := " "
$      OPEN/WRIT TERM TT:
$      abort := "NO"
$      ON Control_Y THEN abort := "YES"
$      ON ERROR THEN abort := "YES"
$      dirname := "''F$DIR()'"
$GetSub:
$      Level = Level + 1
$      title := "(no title)"
$      OPEN/ERR=NoWhere WHERE WHERE.
$      READ/END=NoTitle WHERE title
$NoTitle:
$      CLOSE WHERE
$NoWhere:
$      dirname[0,9]:= "''dirname'"
$      WR TREEFILE prefix, dirname, "    ",title
$!----------------------------------------- EXECUTE USER CMD
$!     DEAS SYS$OUTPUT
$      'CmdLine'
$!-----------------------------------------
$!     it := "''F$LOGI(""SYS$OUTPUT"")'"
$!     IF 'F$LOC(":",it)' .EQ. 'F$LEN(it)' THEN DEAS SYS$OUTPUT
$!     ASSI TRE: SYS$OUTPUT
$      IF Level .GT. MaxLevel THEN GOTO GoUp
$!-----------------------------------------
$      DIRECTORY/COL=1/BRIEF/OUT=DIR.TRE *.DIR;*
$      DirLogName := DLOG'Level'
$      OPEN/ERR=NoSub 'DirLogName' DIR.TRE
$      prefix := "''prefix'. "
$      READ 'DirLogName' Line
$      READ/END=EOF 'DirLogName' Line
$      READ/END=EOF 'DirLogName' Line
$!-----------------------------------------
$ReadDirFile:
$      IF abort .EQS. "YES" THEN GOTO Cancel
$      READ/END=EOF 'DirLogName' Line
$      TreeFileName := "''Line'"
$      IF TreeFileName .EQS. "" THEN GOTO EOF
$!----------------------------------------- Enter Subtree
$      len := 'F$LOC(".",TreeFileName)'
$      dirname := "''F$EXT(0,len,TreeFileName)'"
$      SET DEF [.'dirname']
$      GOTO GetSub
$!-----------------------------------------
$Cancel:
$      WR TERM "       TREE - Terminating at level ",Level
$EOF:  CLOSE 'DirLogName'
$      DELETE DIR.TRE;*
$      prefix := "''F$EXT(2,80,prefix)'"
$GoUp: Level = Level - 1
$      DirLogName := DLOG'Level'
$      IF Level .GT. 0 THEN cd <
$      IF Level .GT. 0 THEN GOTO ReadDirFile
$      SET DEF 'OrigDir'
$      CLOSE TREEFILE
$!     DEAS SYS$OUTPUT
$      CLOSE TERM
$      EXIT
$!---------------------------------------------
$NoSub:WR TERM "       TREE - Cannot enter subtree:  ",dirname
$      GOTO GoUp
$!---------------------------------------------
$INFO: Out "       Walk Directory Tree:  TREE [path]",-
                       "[-C:cmd][-L:#lev][-O[:file]] {cur-dir}"
$      IF opt .NES. "-F" THEN fmt 'HelpDir'tree.hlp TT:
