PROGRAM talk(input,output);

{ Two terminal teleconferencing program }

{ 
  Author:	Ira Winston
		Department of Computer and Information Science
		University of Pennsylvania
		200 South 33rd Street/D2
		Philadelphia, Pennsylvania  19104
}


{ This program requires OPER, SYSNAM, WORLD and TMPMBX privileges }


CONST %INCLUDE 'TALKIODEF.PAS/NOLIST'	{I/O function codes}
      JPI$_USERNAME = %X202;
      IO$_ENDOFFILE = %X870;
      SS$_MBFULL = %X8D8;
      SS$_INSFMEM = %X124;
      SS$_NOSUCHDEV = %X908;
      DC$_TERM = 66;
      class_d = 2;
      dtype_t = 14;

TYPE string = PACKED ARRAY[1..80] OF CHAR;
     username_string = PACKED ARRAY [1..13] OF CHAR;
     word = 0..65535;
     byte = 0..255;
     descriptor = PACKED RECORD
       length: word;
       dtype: byte;
       class: byte;
       pointer: ^string;
       END;
     iosbtype = PACKED RECORD
       status: word;
       length: word;
       sndpid: INTEGER;
       END;


VAR chariochan: INTEGER;  	{Channel assigned to TT:}
    done: boolean;
    iosb: iosbtype;
    trmch,mbxch,ch: CHAR;
    chan: INTEGER;      	{Mbx channel for other talker}
    pid: INTEGER;	     	{Process id of other talker}
    mbxchan: INTEGER;			     {Our mailbox channel}
    ttname: PACKED ARRAY [1..6] OF CHAR;     {Other terminal name}
    logname: PACKED ARRAY [1..18] OF CHAR;   {Logical name of our mailbox}
    lname: PACKED ARRAY [1..18] OF char;     {Logical name of other mailbox}
    len: INTEGER;
    i,j: INTEGER;
    trm_buf: PACKED ARRAY[1..127] OF CHAR;
    command: descriptor;
    notify: BOOLEAN;
    
%INCLUDE 'TLKCHARIO.INC'


		{ System Services }

PROCEDURE sys$exit(%IMMED status: integer); EXTERN;

PROCEDURE lib$get_foreign (VAR get_string: descriptor); EXTERN;

PROCEDURE sys$waitfr (%IMMED efn: integer); EXTERN;

FUNCTION sys$trnlog  (%STDESCR lognam: PACKED ARRAY [INTEGER] OF CHAR;
		      %IMMED rsllen: integer;
		      %STDESCR rslbuf: PACKED ARRAY [integer] OF CHAR;
		      %IMMED table,acmode,dsbmsk: INTEGER): INTEGER;
		     EXTERN;

FUNCTION sys$brdcst (%STDESCR msgbuf,devnam: PACKED ARRAY [INTEGER] OF CHAR):
		    INTEGER; EXTERN;

FUNCTION sys$crembx (%IMMED prmflg: integer;
		     VAR chan: integer;
		     %IMMED maxmsg,bufquo,promsk,acmode,lognam: integer):
		    integer; EXTERN;

FUNCTION sys$getchn (%IMMED chan,prilen: integer;
		     %STDESCR pribuf: PACKED ARRAY [integer] OF char;
		     %IMMED scdlen,scdbuf: integer):
		    integer; EXTERN;

FUNCTION sys$getdev (%STDESCR devnam: PACKED ARRAY [integer] OF char;
		     %IMMED prilen: integer;
		     %STDESCR pribuf: PACKED ARRAY [integer] OF char;
		     %IMMED scdlen,scdbuf: integer):
		    integer; EXTERN;

PROCEDURE lib$stop (%IMMED status: integer); EXTERN;

FUNCTION sys$fao (%STDESCR ctrstr: PACKED ARRAY [integer] OF char;
		  VAR outlen: integer;
		  %STDESCR outbuf: PACKED ARRAY [integer] OF char;
		  %IMMED p1: integer):
                 integer; EXTERN;

FUNCTION sys$assign (%STDESCR devnam: PACKED ARRAY [integer] OF char;
		     VAR chan: integer;
		     %IMMED acmode,mbxnam: integer):
		    integer; EXTERN;

FUNCTION sys$dassgn (%IMMED chan: integer): integer; EXTERN;

FUNCTION sys$setrwm (%IMMED watflg: integer): integer; EXTERN;

PROCEDURE sys$qio (%IMMED efn,chan,func,iosb,astadr,astprm,p1,p2,p3,p4,p5,p6:
		    integer); EXTERN;

PROCEDURE sys$dellog (%IMMED tblflg: integer;
		     %STDESCR lognam: PACKED ARRAY [integer] OF char;
		     %IMMED acmode: integer); EXTERN;

FUNCTION sys$crelog (%IMMED tblflg: integer;
		     %STDESCR lognam,eqlnam: PACKED ARRAY [integer] OF char;
		     %IMMED acmode: integer): integer; EXTERN;


PROCEDURE check(retcode: integer; message: PACKED ARRAY [integer] OF char);

  { If retcode is successful, do nothing }
  { IF retcode is an error, display 'message' and abort }

  VAR i: integer;

  BEGIN

    IF NOT odd(retcode) THEN BEGIN
      FOR i := lower(message) TO upper(message) DO write(message[i]);
      writeln;
      lib$stop(retcode);
      END;
    END;
  
PROCEDURE user_gone(msg: boolean);

  { Deactivate user }

  BEGIN

    { Deassign mailbox channel }
    check (sys$dassgn(chan),'DEASSIGN');
    chan := -1;
    pid := 0;

    { Delete his logical name in case he didn't.  Requires SYSPRV }
    sys$dellog(0,lname,0);

    { Indicate link broken }
    IF msg THEN BEGIN
      writeln ('Link broken...');
      writeln;
      END;
    END;

PROCEDURE get_username(pid: integer; VAR username: username_string);

  TYPE jpi_itmlst = PACKED RECORD	{sys$getjpi item list}
	 length: word;
	 rqtyp: word;
	 strptr: ^username_string;
	 retlen: integer;
	 listend: integer;
	 END;

  VAR itmlst: jpi_itmlst;

  FUNCTION sys$getjpi  (%IMMED efn: integer; pid: integer;
		        %IMMED prcnam: integer; itmlst: jpi_itmlst;
			%IMMED iosb,astadr,astprm: INTEGER): integer;
		       EXTERN;

  BEGIN

    { Setup for JPI call to get username }
    WITH itmlst DO BEGIN
      length := 12;
      rqtyp := JPI$_USERNAME;
      new(strptr);
      strptr^ := '             ';
      retlen := 0;
      listend := 0;
      END;

    { Get username - WORLD privilege required }
    IF odd(sys$getjpi(3,pid,0,itmlst,0,0,0)) THEN sys$waitfr(3);
    username := itmlst.strptr^;
    dispose(itmlst.strptr);      
    END;

PROCEDURE find_user;

  { See if the user is ready to talk to us }

  TYPE devinfo = RECORD		{device info block}
	 CASE integer OF
	   1: (pribuf: PACKED ARRAY [1..114] OF char);
	   2: (prilong: ARRAY [1..28] OF integer);
	 END;

  VAR dvinfo: devinfo;
      llen: integer;
      ourtermname: PACKED ARRAY [1..6] OF char;
      username: username_string;
      retcode: integer;
      i: integer;
      mess: PACKED ARRAY [1..76] OF CHAR;

  BEGIN

    { If we already have a user return immediately }
    IF chan = -1 THEN BEGIN

      { Get the owner of the other terminal }
      check (sys$getdev(ttname,0,dvinfo.pribuf,0,0), 'GETDEV');

      { Get the name of our terminal }
      check (sys$trnlog('TT',0,ourtermname,0,0,0),'TRNLOG');

      { If the terminal is owned, format mailbox name }
      IF dvinfo.prilong[5] <> 0 THEN BEGIN
        check (sys$fao('TALK_!XL',llen,lname,dvinfo.prilong[5]),' FAO - PID');
        FOR i := 1 TO 5 DO lname[13+i] := ourtermname[i];       

        { Try to assign the mailbox logical name }
        IF odd(sys$assign(lname,chan,0,0)) THEN BEGIN
	  pid := dvinfo.prilong[5];

          { Tell user that a connection has been made }
          get_username(pid,username);
          IF username[1] <> ' ' THEN BEGIN
	    notify := false;
	    write ('Link from ');
	    i := 1;
	    WHILE (username[i] <> ' ') AND (i <= 12) DO BEGIN
              write(username[i]);
	      i := i + 1;
	      END;
	    writeln (' on ',ttname);
            writeln;
	    END
	  ELSE user_gone(false);
          END
        ELSE chan := -1;
	END;

      { Notify the other user we want to TALK }
      IF notify THEN BEGIN
        notify := false;		{ Only do this one time }
	get_username(0,username);	{ Get our username }
	mess := '              on      wants to talk to you.  Run Sys$System:Talk to respond.' ;
	mess[1] := chr(7);		{ Bell }
        FOR I := 1 TO 12 DO
	  IF username[i] <> ' ' THEN mess[1+i] := username[i]
	  ELSE mess[1+i] := chr(0);
	FOR i := 1 TO 4 DO mess[17+i] := ourtermname[1+i];
        check (sys$brdcst(mess,ttname), 'BRDCST');
	END;
      END;
    END;
   
PROCEDURE post_read(VAR ch: char);

  { Post a mailbox read to our mailbox }
  { The 'GETCHAR' routine will check EFN 11 for completion and will
    call 'read_complete' at that time }

  FUNCTION sys$qio (%IMMED efn,chan,func: integer;
		    VAR iosb: iosbtype;
		    %IMMED astadr,astprm: integer;
		    VAR p1: char;
		    %IMMED p2,p3,p4,p5,p6: integer):
		   integer; EXTERN;

  BEGIN

    check (sys$qio(11,mbxchan,IO$_READVBLK,iosb,0,0,ch,1,0,0,0,0),
	   'POST_READ - QIO');
    END;

  PROCEDURE display_char(ch: char);

    VAR line: string;

    BEGIN

      CASE ord(ch) OF
	1,2,3,4,5,6,11,14,15,16,17,18,19,20,21,22,23,24,25,26,28,29,30,31:
	 BEGIN
	  line[1] := '^';
	  line[2] := chr(64+ord(ch));
	  putstring(line,2,chariochan);
	  END;
	13: BEGIN
	  line[1] := chr(13);
	  line[2] := chr(10);
	  putstring(line,2,chariochan);
	  END;
	27: putchar('$',chariochan);
	127: BEGIN
	  line[1] := chr(8);
	  line[2] := ' ';
	  line[3] := chr(8);
	  putstring(line,3,chariochan);
	  END;  
	OTHERWISE putchar(ch,chariochan);
	END;
      END;

PROCEDURE read_complete;

  { MBX read completion routine }
  { This routine is called by 'GETCHAR' (the character input routine)
    when a mailbox read completes }

  BEGIN

    find_user;

    { Is the sender known? }
    IF pid = iosb.sndpid THEN BEGIN

      { Is this a termination message? }
      IF iosb.status = IO$_ENDOFFILE THEN user_gone(true)

      { Write message to terminal }
      ELSE display_char(mbxch);
      END;

    { Post another mailbox read }
    post_read(mbxch);
    END;

PROCEDURE post_write(ch: char);

  { Send a message to another users mailbox }

  VAR retcode: integer;

  FUNCTION sys$qio (%IMMED efn,chan,func,iosb,astadr,astprm: integer;
		    VAR p1: char;
		    %IMMED p2,p3,p4,p5,p6: integer):
		   integer; EXTERN;

  BEGIN

    find_user;			{ Try to locate the other user }
    IF chan <> -1 THEN BEGIN	{ Is he is listening? }

      { Write to users mailbox }
      retcode := sys$qio(2,chan,IO$_WRITEVBLK+IO$M_NOW,0,0,0,ch,
		         1,0,0,0,0);

      { If his mailbox is full, he must not be listening }
      IF (retcode = SS$_MBFULL) OR (retcode = SS$_INSFMEM) THEN user_gone(true)
      ELSE check (retcode,'POST_WRITE - QIO');
      END;
    END;
  
PROCEDURE create_mailbox;

  { Create our mailbox and assign system logical name }

  VAR pribuf: PACKED ARRAY [1..116] OF char;
      ourpid,itmlst: integer;
      i: integer;
      mbxlen,loglen: integer;
      mbxnum: PACKED ARRAY [1..10] OF CHAR;

  FUNCTION sys$getjpi (%IMMED efn: integer; VAR pid: integer;
		       %IMMED prcnam: integer; itmlst: integer;
		       %IMMED iosb,astadr,astprm: integer): integer; EXTERN;

  BEGIN

    { Create mailbox and get unit name - TMPMBX required }
    check (sys$crembx(0,mbxchan,10,0,0,0,0),'CREMBX');
    check (sys$getchn(mbxchan,0,pribuf,0,0),'GETCHN - MBX');
    check (sys$fao('_MBA!5ZW:',mbxlen,mbxnum,
                   ord(pribuf[13])+256*ord(pribuf[14])),'FAO - MBX');

    { Build system logical name TALK_pid_term and assign our mailbox to it }
    { SYSNAM privilege required }
    itmlst := 0;
    ourpid := 0;
    check (sys$getjpi(0,ourpid,0,itmlst,0,0,0), 'GETJPI - PID');
    check (sys$fao('TALK_!XL',loglen,logname,ourpid),'FAO - PID');
    FOR i := 1 TO 5 DO logname[i+13] := ttname[i];
    check (sys$crelog(0,logname,mbxnum,0),'CRELOG');
    END;

BEGIN	{ main program }


  { Initialize character io package }
  initchario(chariochan);

  { Disable resource wait mode.  This avoids MWAIT state in case one of
    the other users terminates abnormally and isn't reading his mailbox
    and didn't have a chance to send an EOF }
  check (sys$setrwm(1),'SETRWM');

  { Initialize }
  pid := 0;
  chan := -1;
  notify := true;

  { Get terminal name }
  WITH command DO BEGIN
    length := 0;
    dtype := dtype_t;
    class := class_d;
    pointer := nil;
    END;
  lib$get_foreign(command);  
  IF command.length = 0 THEN BEGIN
    ttname := '      ';
    write ('Which terminal do you want to talk to? ');
    j := 0;
    IF eof THEN sys$exit(1);
    WHILE not EOLN DO BEGIN
      j := j + 1;
      ch := input^;
      IF (ch >= 'a') AND (ch <= 'z') THEN ch := chr(ord(ch)-32);
      IF j <= 6 THEN ttname[j] := ch;
      get(input);
      END;
    readln;
    END
  ELSE BEGIN
    IF command.length > 6 THEN j := 6
    ELSE j := command.length;
    FOR i := 1 TO j DO ttname[i] := command.pointer^[i];
    END;
  IF ((ttname[1] >= '0') AND (ttname[1] <= '7')) THEN BEGIN
    FOR i := 6 DOWNTO 5 DO ttname[i] := ttname[i-4];
    ttname[1] := '_';
    ttname[2] := 'T';
    ttname[3] := 'T';
    ttname[4] := 'A';
    j := j + 4;
    IF j > 6 THEN j := 6;
    END
  ELSE IF (ttname[1] >= 'A') AND (ttname[1] <= 'N') THEN BEGIN
    FOR i := 6 DOWNTO 4 DO ttname[i] := ttname[i-3];
    ttname[1] := '_';
    ttname[2] := 'T';
    ttname[3] := 'T';
    j := j + 3;
    IF j > 6 THEN j := 6;
    END
  ELSE IF ttname[1] <> '_' THEN BEGIN
    FOR i := 6 DOWNTO 2 DO ttname[i] := ttname[i-1];
    ttname[1] := '_';
    j := j + 1;
    IF j > 6 THEN j := 6;
    END;
  IF (ttname[j] <> ':') AND (j < 6) THEN BEGIN
    j := j + 1;
    ttname[j] := ':';
    END;

  { Verify that user entered a legal terminal name }
  j := sys$getdev(ttname,len,trm_buf,0,0);
  IF NOT (odd(j) AND (ord(trm_buf[5]) = DC$_TERM)) THEN sys$exit(SS$_NOSUCHDEV);

  create_mailbox;				{ Setup our mailbox }
  find_user;					{ Try to locate users }
  post_read(mbxch);				{ Post first mailbox read }

  { Read from input window and write to other users }
  { Messages from other users are handled by 'GETCHAR' and 'READ_COMPLETE' }
  trmch := getchar(chariochan);
  WHILE NOT (ord(trmch) IN [3,25,26]) DO BEGIN		{ ^C, ^Y or ^Z }
    post_write(trmch);
    display_char(trmch);
    trmch := getchar(chariochan);
    END;

  { Send termination message to other user }
  sys$qio(0,chan,IO$_WRITEOF+IO$M_NOW,0,0,0,0,0,0,0,0,0);

  { Delete mailbox logical name - requires SYSPRV }
  sys$dellog(0,logname,0);
  writeln;
  END.
