                                                      (*






                             Department of Geography and Computer Science
                      United States Military Academy, West Point, New York  10996
             
   
             Program name: DATEBOOK.PAS
   
             Author:       CDT Roy K.  Jeffery
                           Company C - 2, USCC
                           Class of 1981
                           
			   Home of record
			   Route 2, Box 68
			   Cabot, Arkansas
			   72023
			   First duty assignment
			   TRADOC
		  	   Fort Knox, Kentucky
   
             Course:       EF489A
                           Spring Semester, AY 1980 - 81
 
             Advisor:      CPT J.  Woloski, Signal Corps
             
             Date:         4 May 1981 - Final working version
  			   15 May 1981 - Working Version for VT-100 Terminals (Modified by :

Francis J. Monaco
Major, US ARMY
Systems Manager, Computer Graphics Laboratory
Department of Geography and Computer Science
The United States Military Academy
West Point, New York 10996
914-938-2063)


   
             Purpose:      This program allows the user to interact  with  the  VAX/VMS
                           Computer  System and graphically display an appointment type
                           calendar both on an HAZELTINE Cathode Ray Terminal  and  the
                           current line printer.
   
             Operation:    Program DATEBOOK allows the user to input and  update  data.
                           He  may then retrieve this data in two forms;  by day and by
                           month.  The day format contains a majority  of  the  entered
                           data.   This format contains the specified day with appoint-
                           ments listed for that day.  The month  format  contains  the
                           month with a count of the total number of items the user has
                           scheduled for a particular day.
   
             Requirements: An external datafile titled MAINDATA.DAT must  exist  before
                           program  execution.  This datafile is used to store any user
                           supplied data.
   
                           This program is written for a HAZELTINE Cathode Ray Terminal
                           as  defined  by  the  Procedure GOTOXY.  Modification can be
                           made to GOTOXY for use on other cathode ray terminals.
   
	     Equipment:    VAX 11/780 Minicomputer
			   using Version 2.2

             Program flow: DATEBOOK is conceptually separated into  8  sections.   They
                           are:            
   
                           1) Program declaration
             
                           2) All global procedures and functions used through out  the
                              program
 
                           3) The procedures within HELP
   
                           4) The procedures within DATA ENTRY.
   
                           5) The procedures within DAY DISPLAY.
   
                           6) The procedures within  MONTH  DISPLAY
   
                           7) The procedures within CHANGE DATAFILE
   
                           8) The MAIN program code.
   
             Input:        The user is prompted at the proper time  for  entry  of  all
                           input.   All user supplied input is of type CHAR (character)
                           and is converted to type INTEGER as needed by the program.
   
                           DATEBOOK allows the user to input any amount of data and  is
                           restricted only by system storage capabilities.
   
             Output:       The output is in the form of a file of records and is  writ-
                           ten to the datafile MAINDATA.DAT.
   
                           The hard copy output is to the datafile HARDCOPY.DAT.
   
 
 
 
 
   
                                                       *)
(**)

PROGRAM DATEBOOK (INPUT,
                  OUTPUT,
                  HARDCOPY,
                  MAINDATA(* FILE *));










                                                      (*

                     $$$$$$$$$$$$$$$$$$$$ PROGRAM DECLARATIONS $$$$$$$$$$$$$$$$$$$$

                                                      *)










TYPE 
     NUMBER = SET OF CHAR;
     STRING2 = PACKED ARRAY[1..2] OF CHAR;
     STRING4 = PACKED ARRAY[1..4] OF CHAR;
     STRING10 = PACKED ARRAY[1..10] OF CHAR;
     STRING12 = PACKED ARRAY[1..12] OF CHAR;
     STRING24 = PACKED ARRAY[1..24] OF CHAR;
     STRING45 = PACKED ARRAY[1..45] OF CHAR;
     STRING22_BY_64 = PACKED ARRAY[1..22,1..64] OF CHAR;
     STRING23_BY_33 = PACKED ARRAY[1..23,1..33] OF CHAR;
                                                      (*

######################################
MAINDATA.DAT HAS RECORDS OF THIS TYPE.
######################################

                                                      *)
     DATAREC  = RECORD
                   DAY,
                   MONTH :   STRING2;
                   TIME,
                   YEAR : STRING4;
                   MESSAGE : STRING24;
                   COUNT : INTEGER
                END;  (* DEFINITION OF DATAREC *)

VAR 
    COMPLETE : BOOLEAN; (* GLOBAL VARIABLE THAT IS USED IN THE COMPLETION OF PROGRAM *)
    REQUEST : INTEGER; (* VARIABLE THAT IS USED TO INDICATE THE SELECTED OPTION IN THE MAIN PROGRAM CASE STATEMENT *)
    HARDCOPY : TEXT; (* OUTPUT FILE TO WHICH THE MONTH AND DAY ARE WRITTEN *)
    CURENTRY, (* GLOBAL VARIABLE USED IN PROCEDURES MERGE AND DATA_ENTRY *)
    MAINDATA : FILE OF DATAREC; (* EXTERNAL OUTPUT FILE TO WHICH ALL DATE ENTRIES ARE WRITTEN *)
    SELECTION, (* VARIABLE USED IN THE MAIN PROGRAM BLOCK TO READ IN USERS DESIRED OPTION *)
    THIS_CENTURY, (* GLOBAL VARIABLE TO WHICH THE CURRENT CENTURY IS ASSIGNED *)
    THEDAY, (* GLOBAL VARIABLE TO WHICH THE DEFAULT DAY IS ASSIGNED *)
    THEMONTH : STRING2; (* GLOBAL VARIABLE TO WHICH THE DEFAULT MONTH IS ASSIGNED *)
    THEYEAR  : STRING4; (* GLOBAL VARIABLE TO WHICH THE GLOBAL DEFAULT YEAR IS ASSIGNED *)
    HEADER_ONE,
    HEADER_TWO,
    HEADER_THREE : STRING45; (* GLOBAL VARIABLES USED IN THE OUTPUT OF A HEADING ON THE HARDCOPIES *)
    MONTH_1ST_DIGIT,
    YEAR_1ST_DIGIT,
    TIME_1ST_DIGIT,
    TIME_3RD_DIGIT,
    REMAINING_DIGITS : NUMBER;
                                                      (*

                MEMBERS OF THE SET OF NUMBERS, THE ALLOWABLE VALUES THAT A DATE ENTRY CAN BE ASSIGNED

                                                      *)
    HARD_MONTH : STRING22_BY_64; (* GLOBAL 2D ARRAY USED TO WRITE THE MONTH OUTPUT TO HARDCOPY *)
    HARD_DAY : STRING23_BY_33; (* GLOBAL 2D ARRAY USED TO WRITE THE DAY OUTPUT TO HARDCOPY *)
(**)
                                                      (*

             THE FOLLOWING VALUE ASSIGNMENTS ARE MADE TO ALLOW SIMPLIFIED COMPARISIONS IN THE CHECK
            YEAR, MONTH, DAY, AND TIME PROCEDURES

                                                      *)




    VALUE
    MONTH_1ST_DIGIT := [' ','0','1'];
    YEAR_1ST_DIGIT  := ['1','2','3','4','5','6','7','8','9'];
    TIME_1ST_DIGIT  := ['0','1','2'];
    TIME_3RD_DIGIT  := ['0','1','2','3','4','5'];
    REMAINING_DIGITS := ['0','1','2','3','4','5','6','7','8','9'];
(**)
                                                      (*

 THE FOLLOWING VALUE ASSIGNMENTS INITIALIZE THE TWO-DIMENSIONAL ARRAY, HARD_MONTH

                                                      *)




    HARD_MONTH := (
                  (64 OF ' '),
                  (64 OF ' '),
                  (3 OF ' ','S','u','n',6 OF ' ','M','o','n',6 OF ' ','T','u','e',
                  6 OF ' ','W','e','d',6 OF ' ',
                  'T','h','u',6 OF ' ','F','r','i',6 OF ' ','S','a','t',4 OF ' '),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',8 OF ' ','|',
                  8 OF ' ','|',8 OF ' ','|'),
                  ('|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',8 OF '-','|',
                  8 OF '-','|',8 OF '-','|'));
(**)
                                                      (*

 THE FOLLOWING VALUE ASSIGNMENTS INITIALIZE THE TWO-DIMENSIONAL ARRAY, HARD_DAY

                                                      *)




    HARD_DAY := (
                (33 OF ' '),
                (33 OF '-'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                ('|',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
                ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|'),
                (33 OF '-'));
(**)
                                                      (*

                $$$$$$$$$$$$$$$$$$$$ GLOBAL PROCEDURES AND FUNCTIONS $$$$$$$$$$$$$$$$$$$$

                                                      *)


%include 'vtgo.pas'

PROCEDURE SLOW_DOWN_THE_OUTPUT;






                                                      (*

     Procedure SLOW-DOWN-THE-OUTPUT is used with any procedure that has a  GOTOXY  dependent  opera-
     tion.  Because of the difference in speed between the terminal and the computer, this procedure
     must be used to prevent characters from being scattered over the screen.

                                            Calls:      GOTOXY
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
VAR 
    I : INTEGER;
BEGIN (* SLOW_DOWN_THE_OUTPUT *)
END;  (* SLOW_DOWN_THE_OUTPUT *)

PROCEDURE CLEAR_THE_SCREEN;






                                                      (*

     Procedure CLEAR-THE-SCREEN is used any time it is necessary to clear the screen  of  all  char-
     acters.

                                            Calls:      GOTOXY
                                                        SLOW-DOWN-THE-OUTPUT
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN (* CLEAR_THE_SCREEN *)
   GOTOXY(-1,2);
   SLOW_DOWN_THE_OUTPUT;
END;  (* CLEAR_THE_SCREEN *)

PROCEDURE CLEAR_THE_FORE_GROUND(X,Y : INTEGER);






                                                      (*

     Procedure CLEAR-THE-FORE-GROUND is used any time it is necessary to erase the bright characters
     from the screen.  The cursor is returned to the location as specified by X and Y.

                                            Calls:      GOTOXY
                                                        SLOW-DOWN-THE-OUTPUT
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN (* CLEAR_THE_FORE_GROUND *)
   GOTOXY(-1,3);
   SLOW_DOWN_THE_OUTPUT;
   GOTOXY(X,Y);
END;  (* CLEAR_THE_FORE_GROUND *)

PROCEDURE SET_UP_THE_FORE_GROUND(X,Y : INTEGER);






                                                      (*

     Procedure SET-UP-THE-FORE-GROUND is used any time bright characters are desired.  The cursor  is
     returned to the location as specified by X and Y.

                                            Calls:      GOTOXY
                                                        SLOW-DOWN-THE-OUTPUT
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN (* SET_UP_THE_FORE_GROUND *)
   GOTOXY(-1,8);
   SLOW_DOWN_THE_OUTPUT;
   GOTOXY(X,Y);
END;  (* SET_UP_THE_FORE_GROUND *)

PROCEDURE SET_UP_THE_BACK_GROUND(X,Y : INTEGER);






                                                      (*

     Procedure SET-UP-THE-BACK-GROUND is used any time light characters are desired.  The cursor  is
     returned to the location as specified by X and Y.

                                            Calls:      GOTOXY
                                                        SLOW-DOWN-THE-OUTPUT
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN (* SET_UP_THE_BACK_GROUND *)
   GOTOXY(-1,7);
   SLOW_DOWN_THE_OUTPUT;
   GOTOXY(X,Y);
END;  (* SET_UP_THE_BACK_GROUND *)

PROCEDURE CLEAR_TO_END_OF_LINE(X,Y : INTEGER);






                                                      (*

     Procedure CLEAR-TO-THE-END-OF-LINE is used to clear any print from a start location as directed
     by  X  and  Y to the end of the line.  The cursor is returned to the location as specified by X
     and Y.

                                            Calls:      GOTOXY
                                                        SLOW-DOWN-THE-OUTPUT
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN (* CLEAR_TO_END_OF_LINE *)
   GOTOXY(X,Y);
   GOTOXY(-1,4);
   GOTOXY(X,Y);
END;  (* CLEAR_TO_END_OF_LINE *)

PROCEDURE CLEAR_A_LOCAL_AREA(X,Y,Y1,Y2 : INTEGER);






                                                      (*

     Procedure CLEAR-A-LOCAL-AREA is used to clear a vertical area in which print is  present.   The
     left boundary is specified by X and the number of rows to be erased are specified by Y1 and Y2.
     The cursor is returned to the location as specified by X and Y.

                                            Calls:      GOTOXY
                                                        SLOW-DOWN-THE-OUTPUT
                                            Called by:  Nearly every procedure
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    I : INTEGER;
BEGIN (* CLEAR_A_LOCAL_AREA *)
   FOR I := Y1 TO Y2 DO
      BEGIN  (* FOR *)
         CLEAR_TO_END_OF_LINE(X,Y1);
      END;  (* FOR *)
   GOTOXY(X,Y);
END;  (* CLEAR_A_LOCAL_AREA *)

PROCEDURE BELL;






                                                      (*

     Procedure BELL is used through out the program to warn the user that a response is  desired  or
     that a mistake has been made.

                                            Calls:      None
                                            Called by:  Nearly every procedure 
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    B : INTEGER;
BEGIN (* BELL *)
END;  (* BELL *)

PROCEDURE GETDATE;






                                                      (*

     Procedure GETDATE obtains the current date from the system and transfers that date to the  glo-
     bal  variables;   THEMONTH,  THEDAY, and THEYEAR.  The format of the date, as obtained from the
     system, is 27-MAY-1981.  This date is read as character data and is converted by this procedure
     to  character data in the format of, 05/27/1981. The variables;  THEMONTH, THEDAY, THEYEAR, and
     THIS-CENTURY are used through out DATEBOOK.  Once a different date  has  been  entered  at  the
     DAY-DISPLAY  or  MONTH-DISPLAY level, the variables;  THEMONTH, THEDAY, and THEYEAR take on the
     different date.  These different dates are reflected in the lower  right  corner  by  procedure
     PRINT-DEFAULT-DATES.   The  value of THIS-CENTURY always remains the original value as assigned
     by the system.  THIS-CENTURY allows the user the ability to input the year  as  two  characters
     and cause the program to take these two characters as a year in the current century.

                                            Calls:      None
                                            Called by:  Main
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    TODAY : PACKED ARRAY[1..11] OF CHAR;
    COUNT : INTEGER;
BEGIN (* GETDATE *)
   DATE(TODAY); (* NON-STANDARD PASCAL TO RETRIEVE DATE FROM SYSTEM *)
   FOR COUNT := 1 TO 2 DO (* ASSIGN A VALUE TO THIS_CENTURY *)
      THIS_CENTURY[COUNT] := TODAY[COUNT + 7];
   FOR COUNT := 1 TO 2 DO (* ASSIGN A VALUE TO THEDAY *)
      THEDAY[COUNT] := TODAY[COUNT];
   IF (THEDAY[1] = ' ')
      THEN
         THEDAY[1] := '0';
   FOR COUNT := 1 TO 4 DO (* ASSIGN A VALUE TO THEYEAR *)
      THEYEAR[COUNT] := TODAY[COUNT + 7];
   CASE TODAY[4] OF  (* DETERMINE A NUMERIC VALUE FOR THEMONTH *)
      'F' : THEMONTH := '02';
      'S' : THEMONTH := '09';
      'O' : THEMONTH := '10';
      'N' : THEMONTH := '11';
      'D' : THEMONTH := '12';
      'J' : CASE TODAY[5] OF
               'A' : THEMONTH := '01';
               'U' : CASE TODAY[6] OF
                        'N' : THEMONTH := '06';
                        'L' : THEMONTH := '07'
                     END  (* TODAY[6] *)
            END;  (* TODAY[5] *)
      'M' : CASE TODAY[6] OF
               'R' : THEMONTH := '03';
               'Y' : THEMONTH := '05'
            END;  (* TODAY[6] *)
      'A' : CASE TODAY[5] OF
               'P' : THEMONTH := '04';
               'U' : THEMONTH := '07'
            END  (* TODAY[5] *)
   END  (* MAIN CASE *)
END;  (* GETDATE *)

PROCEDURE PRINT_DEFAULT_DATES;






                                                      (*

     Procedure PRINT-DEFAULT-DATES maintains track of the global variables THEMONTH, THEDAY,  THEYE-
     AR,  and  THIS-CENTURY.   The  current  values assigned to these variables are displayed in the
     lower right corner of the screen at various time through out program execution.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                            Called by:  PRINT-MAIN-OPTIONS
                                                        DATAENTRY
                                                        ENTER-NEW-DATE
                                                        THEN-DISPLAY-DAY-CALENDAR
                                                        THEN-DISPLAY-MONTH-CALENDAR
                                                        PRINT-CHANGE-OPTIONS
                                                        CHANGE-ENTRY
                                                        DELETE-ENTRY
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN (* PRINT_DEFAULT_DATES *)
   SET_UP_THE_BACK_GROUND(37,22);
   WRITELN('Default: M/D/Y = ',THEMONTH,'/',THEDAY,'/',THEYEAR,
         ' Century = ',THIS_CENTURY);
END;  (* PRINT_DEFAULT_DATES *)

FUNCTION CONVERT_MONTH(MONTH : STRING2) : INTEGER;






                                                      (*

     Function CONVERT-MONTH is called any time there is a need for integers instead of characters by
     the  program.   The  month enters as characters and a value is assign to CONVERT-MONTH based on
     the value of month.

                                            Calls:      None
                                            Called by:  GET-FIRST-DAY
                                                        PRINT-MONTH
                                                        CORRECT-MAX-DAYS
                                                        COMPUTE-NEXT-DAY-OR-MONTH
                                                        COMPUTE-PRIOR-DAY-OR-MONTH
                                                        DISPLAY-MONTH-CALENDAR
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
VAR 
    TEN,
    ONE : INTEGER;
BEGIN  (* CONVERT_MONTH *)
   TEN := (ORD(MONTH[1]) - ORD('0')) * 10;
   ONE := (ORD(MONTH[2]) - ORD('0'));
   CONVERT_MONTH := TEN + ONE
END;  (* CONVERT_MONTH *)

FUNCTION CONVERT_DAY(DAY : STRING2) : INTEGER;
                                                      (*

     Function CONVERT-DAY is used any time there is a need for integers instead of characters.   The
     execution of this function is the same as CONVERT-MONTH.

                                            Calls:      None
                                            Called by:  PRINT-DAY
                                                        CORRECT-MAX-DAYS
                                                        COMPUTE-NEXT-DAY-OR-MONTH
                                                        COMPUTE-PRIOR-DAY-OR-MONTH
                                                        COUNT-APPOINTMENTS
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    TEN,
    ONE : INTEGER;
BEGIN  (* CONVERT_DAY *)
   TEN := (ORD(DAY[1]) - ORD('0')) * 10;
   ONE := (ORD(DAY[2]) - ORD('0'));
   CONVERT_DAY := TEN + ONE
END;  (* CONVERT_DAY *)

FUNCTION CONVERT_YEAR(YEAR : STRING4) : INTEGER;
                                                      (*

     Function CONVERT-YEAR has the same operation and function as CONVERT-MONTH and CONVERT-DAY.

                                            Calls:      None
                                            Called by:  GET-FIRST-DAY
                                                        CORRECT-MAX-DAYS
                                                        COMPUTE-NEXT-DAY-OR-MONTH
                                                        COMPUTE-PRIOR-DAY-OR-MONTH
                                                        DISPLAY-MONTH-CALENDAR
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    THOUSAND,
    HUNDRED,
    TEN,
    ONE : INTEGER;
BEGIN  (* CONVERT_YEAR *)
   THOUSAND := (ORD(YEAR[1]) - ORD('0')) * 1000;
   HUNDRED := (ORD(YEAR[2]) - ORD('0')) * 100;
   TEN := (ORD(YEAR[3]) - ORD('0')) * 10;
   ONE := (ORD(YEAR[4]) - ORD('0'));
   CONVERT_YEAR := THOUSAND + HUNDRED + TEN + ONE
END;  (* CONVERT_YEAR *)

FUNCTION  GET_FIRST_DAY(MONTH : STRING2; YEAR :  STRING4) :  INTEGER;
                                                      (*

     Function GET-FIRST-DAY determines the first day of any month from the STARTYEAR listed below to
     the  month  and year the user has requested through one of his option selections or the date as
     supplied by the system.  A value returned by this function is an integer from 0 to 6.  A 0  re-
     presents a Sunday and a 6 represents a Saturday.

                                            Calls:      CONVERT-MONTH
                                                        CONVERT-YEAR
                                            Called by:  PRINT-DAY
                                                        COUNT-APPOINTMENTS
                                                        DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

CONST 
      STARTDAY  =  1;
      STARTYEAR  =  1753;

VAR 
    IMONTH,
    IYEAR,
    DAY,
    J:  INTEGER;
BEGIN  (* GET_FIRST_DAY *)
   IMONTH := CONVERT_MONTH(MONTH);
   IYEAR := CONVERT_YEAR(YEAR);
   DAY  :=  STARTDAY;
   FOR  J  :=  STARTYEAR  TO  IYEAR  -  1  DO
      IF  ((J MOD 4 = 0) AND (J MOD 100 <> 0))
         OR (J MOD 400 = 0)
         THEN
            DAY  :=  DAY  +  2
         ELSE
            DAY  :=  DAY  +  1;
   CASE  IMONTH  OF
      2 : DAY   :=  DAY  +  31;
      3 : DAY   :=  DAY  +  59;
      4 : DAY   :=  DAY  +  90;
      5 : DAY   :=  DAY  +  120;
      6 : DAY   :=  DAY  +  151;
      7 : DAY   :=  DAY  +  181;
      8 : DAY   :=  DAY  +  212;
      9 : DAY   :=  DAY  +  243;
      10 : DAY   :=  DAY  +  273;
      11 : DAY   :=  DAY  +  304;
      12 : DAY   :=  DAY  +  334
   END  (* CASE *);
   IF  (IMONTH > 2)
      AND ((IYEAR MOD 4 = 0) AND (IYEAR MOD 100 <> 0))
      OR (IYEAR MOD 400 = 0)
      THEN (* THIS IS A LEAP YEAR *)
         DAY  :=  SUCC(DAY);
   DAY  :=  DAY  MOD  7;
(* 0 is SUNDAY; 6 is SATURDAY *)
   GET_FIRST_DAY  (* Month, Year *)  :=  DAY;
END;  (* GET_FIRST_DAY *)

PROCEDURE PRINT_MONTH(SPELL_MONTH : STRING2;
                      VAR PRINT_THIS_MONTH : STRING12);






                                                      (*

     Procedure PRINT-MONTH is used to convert the numeric representation for a month  to  the  alpha
     equivalent.  This is done in an effort to increase readability and appearence of the output.

                                            Calls:      CONVERT-MONTH
                                            Called by:  GET-AND-PRINT-CURRENT-DATE
                                                        PRINT-ENTRY-DATE
                                                        DISPLAY-DAY-CALENDAR
                                                        DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    MONTH : INTEGER;
BEGIN  (* PRINT_MONTH *)
   MONTH := CONVERT_MONTH(SPELL_MONTH);
   CASE MONTH OF (* DETERMINE THE MONTH *)
      01 : PRINT_THIS_MONTH := '  January   ';
      02 : PRINT_THIS_MONTH := '  February  ';
      03 : PRINT_THIS_MONTH := '  March     ';
      04 : PRINT_THIS_MONTH := '  April     ';
      05 : PRINT_THIS_MONTH := '  May       ';
      06 : PRINT_THIS_MONTH := '  June      ';
      07 : PRINT_THIS_MONTH := '  July      ';
      08 : PRINT_THIS_MONTH := '  August    ';
      09 : PRINT_THIS_MONTH := '  September ';
      10 : PRINT_THIS_MONTH := '  October   ';
      11 : PRINT_THIS_MONTH := '  November  ';
      12 : PRINT_THIS_MONTH := '  December  '
   END  (* CASE *)
END;  (* PRINT_MONTH *)

PROCEDURE PRINT_DAY(MONTH,
                    DAY : STRING2;
                    YEAR : STRING4;
                    VAR PRINT_THIS_DAY : STRING12);






                                                      (*

     Procedure PRINT-DAY is used to convert the numeric representation for a day to the alpha  equi-
     valent.  This is done to increase readability and appearance of the output.

                                            Calls:      CONVERT-DAY
                                            Called by:  GET-AND-PRINT-CURRENT-DATE
                                                        PRINT-ENTRY-DATE
                                                        DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)

VAR 
    IDAY : INTEGER;
BEGIN  (* PRINT_DAY *)
   IDAY := CONVERT_DAY(DAY);
   CASE ((IDAY+(GET_FIRST_DAY(MONTH,YEAR)-1))MOD 7) OF (* DETERMINE DAY OF WEEK *)
      0 : PRINT_THIS_DAY := '   Sunday   ';
      1 : PRINT_THIS_DAY := '   Monday   ';
      2 : PRINT_THIS_DAY := '   Tuesday  ';
      3 : PRINT_THIS_DAY := '   Wednesday';
      4 : PRINT_THIS_DAY := '   Thursday ';
      5 : PRINT_THIS_DAY := '   Friday   ';
      6 : PRINT_THIS_DAY := '   Saturday '
   END  (* CASE *)
END;  (* PRINT_DAY *)

FUNCTION MAX_DAYS_IN_MONTH(MONTH,YEAR : INTEGER) : INTEGER;






                                                      (*

     Function MAX-DAYS-IN-MONTH assigns a value to the function that is the maximum  allowable  days
     in the passed in month.  

                                            Calls:      None
                                            Called by:  CORRECT-MAX-DAYS
                                                        COMPUTE-NEXT-DAY-OR-MONTH
                                                        COMPUTE-PRIOR-DAY-OR-MONTH
                                                        DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN  (* MAX_DAYS_IN_MONTH *)
   CASE MONTH OF  (* ASSIGN A NUMBER FOR MAX_DAYS *)
      01  : MAX_DAYS_IN_MONTH := 31;
      02  : MAX_DAYS_IN_MONTH := 28;
      03  : MAX_DAYS_IN_MONTH := 31;
      04  : MAX_DAYS_IN_MONTH := 30;
      05  : MAX_DAYS_IN_MONTH := 31;
      06  : MAX_DAYS_IN_MONTH := 30;
      07  : MAX_DAYS_IN_MONTH := 31;
      08  : MAX_DAYS_IN_MONTH := 31;
      09  : MAX_DAYS_IN_MONTH := 30;
      10  : MAX_DAYS_IN_MONTH := 31;
      11  : MAX_DAYS_IN_MONTH := 30;
      12  : MAX_DAYS_IN_MONTH := 31
   END; (* CASE *)
   IF (MONTH = 2)
      AND ((YEAR MOD 4 = 0) AND (YEAR MOD 100 <> 0))
      OR (YEAR MOD 400 = 0)
      THEN  (* THIS IS A LEAP YEAR *)
         MAX_DAYS_IN_MONTH := 29
END; (* MAX_DAYS_IN_MONTH *)

PROCEDURE CORRECT_TIME_OR_YEAR_ENTRY(VAR TIME_OR_YEAR : STRING4;
                                     X_LOCATION,
                                     Y_LOCATION : INTEGER);






                                                      (*

     Procedure CORRECT-TIME-OR-YEAR-ENTRY notifies the user that he has  made  a  mistake  and  must
     re-enter  an  entry  for  either  the time or the year.  The cursor is directed to the location
     specified by X-LOCATION and Y-LOCATION.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CLEAR-TO-END-OF-LINE
                                                        SET-UP-THE-FORE-GROUND
                                                        BELL
                                            Called by:  CORRECT-TIME
                                                        CORRECT-YEAR
                                            Nests:      None
                                            Nested w/i: Main

                                                      *)
BEGIN  (* CORRECT_TIME_OR_YEAR_ENTRY *)
   BELL;
   SET_UP_THE_FORE_GROUND(11,13);
   WRITELN('                  You have made a mistake.');
   SET_UP_THE_BACK_GROUND(X_LOCATION,Y_LOCATION);
   CLEAR_TO_END_OF_LINE(X_LOCATION,Y_LOCATION);
   READLN(TIME_OR_YEAR);
   CLEAR_TO_END_OF_LINE(0,13);
END;  (* CORRECT_TIME_OF_YEAR_ENTRY *)

PROCEDURE CORRECT_MONTH_OR_DAY_ENTRY(VAR MONTH_OR_DAY : STRING2;
                                     X_LOCATION,
                                     Y_LOCATION : INTEGER);






                                                   (*

     Procedure CORRECT-MONTH-OR-DAY-ENTRY notifies the user that he has  made  a  mistake  and  must
     re-enter  an  entry  for  either  the month or the day.  The cursor is directed to the location
     specified by X-LOCATION and Y-LOCATION.

                                            Calls:      BELL
                                                        SET-UP-THE-FORE-GROUND
                                                        SET-UP-THE-BACK-GROUND
                                                        CLEAR-TO-END-OF-LINE
                                            Called by:  CORRECT-MONTH
                                                        CORRECT-DAY
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* CORRECT_MONTH_OR_DAY_ENTRY *)
   BELL;
   SET_UP_THE_FORE_GROUND(11,13);
   WRITELN('                  You have made a mistake.');
   SET_UP_THE_BACK_GROUND(X_LOCATION,Y_LOCATION);
   CLEAR_TO_END_OF_LINE(X_LOCATION,Y_LOCATION);
   READLN(MONTH_OR_DAY);
   CLEAR_TO_END_OF_LINE(0,13);
END;  (* CORRECT_MONTH_OR_DAY_ENTRY *)

PROCEDURE CORRECT_TIME(VAR DIGIT : STRING4; VAR DONE : BOOLEAN);






                                                   (*

     Procedure CORRECT-TIME is used anytime an entry for time is done.  This procedure insures  that
     the  user  has entered a time that is within the established parameters as defined by the value
     declaration for NUMBER.

                                            Calls:      CORRECT-TIME-OR-YEAR-ENTRY
                                                        CHECK-TIME
                                            Called by:  ENTER-TIME
                                            Nests:      CHECK-TIME
                                            Nested w/i: Main

                                                   *)

VAR 
    RIGHT : BOOLEAN;

PROCEDURE CHECK_TIME;






                                                   (*

     Procedure CHECK-TIME contains the code used to compare the users entry for time against the al-
     lowed  values  for  time as defined by the value declaration for NUMBERs.  If all entered char-
     acters(DIGIT) are correct, then RIGHT is assign a value of TRUE and the program continues  exe-
     cution.   If  the entered characters are incorrect, then a value for RIGHT of false is assigned
     and the user is forced to CORRECT-TIME-ENTRY until RIGHT in the main procedure block.

                                            Calls:      None
                                            Called by:  CORRECT-TIME
                                            Nests:      None
                                            Nested w/i: CORRECT-TIME

                                                   *)

VAR 
    NUMBER : INTEGER;
BEGIN   (* CHECK_TIME *)
   RIGHT := TRUE;
   IF (DIGIT = 'DONE') OR (DIGIT = 'done')
      THEN  (* USER HAS COMPLETED ENTRIES *)
         DONE := TRUE
      ELSE
         BEGIN  (* TO CHECK FOR INVALID ENTRIES *)
            IF (DIGIT[1] = '0') AND (DIGIT[2] = '0')
               AND (DIGIT[3] = '0') AND (DIGIT[4] = '0')
               THEN  (* INVALID ENTRY; TOO LOW *)
                  RIGHT := FALSE;
            IF (DIGIT[1] = '2') AND (DIGIT[2] = '4') AND (RIGHT)
               THEN
                  IF (DIGIT[3] <> '0') OR (DIGIT[4] <> '0')
                     THEN (* INVALID ENTRY; TOO HIGH *)
                        RIGHT := FALSE;
            IF (DIGIT[1] = '2') AND (DIGIT[2] > '4') AND (RIGHT)
               THEN  (* INVALID ENTRY; TOO HIGH *)
                  RIGHT := FALSE;
            FOR NUMBER := 1 TO 4 DO
               BEGIN  (* FOR *)
                  CASE NUMBER OF  (* CHECK EACH CHARACTER FOR MEMBERSHIP IN THE PROPER SET OF NUMBER AS DEFINED IN THE VALUE STATEMENT *)
                     1 :  IF (DIGIT[1] IN TIME_1ST_DIGIT) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     2 :  IF (DIGIT[2] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     3 :  IF (DIGIT[3] IN TIME_3RD_DIGIT) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     4 :  IF (DIGIT[4] IN REMAINING_digits) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE
                  END  (* CASE *)
               END  (* FOR *)
         END  (* IF DIGIT = DONE *)
END;  (* CHECK_TIME *)





BEGIN  (*  CORRECT_TIME *)
   REPEAT
      CHECK_TIME;
      IF NOT RIGHT
         THEN
            CORRECT_time_or_year_entry(DIGIT,33,0);
   UNTIL RIGHT;
END;  (* CORRECT_TIME *)

PROCEDURE CORRECT_MONTH(VAR DIGIT : STRING2; VAR DONE : BOOLEAN);






                                                   (*

     Procedure CORRECT-MONTH has the same operation and purpose as CORRECT-TIME except the  applica-
     tion is for the MONTH entry of the user.

                                            Calls:      CORRECT-MONTH-OR-DAY-ENTRY
                                                        CHECK-MONTH
                                            Called by:  ENTER-MONTH
                                            Nests:      CHECK-MONTH
                                            Nested w/i: Main

                                                   *)

VAR 
    RIGHT : BOOLEAN;

PROCEDURE CHECK_MONTH;






                                                   (*

     Procedure CHECK-MONTH has the same operation and function as CHECK-TIME except the  application
     is for the entered month.

                                            Calls:      None
                                            Called by:  CORRECT-MONTH
                                            Nests:      None
                                            Nested w/i: CORRECT-MONTH

                                                   *)

CONST 
      BLANK = ' ';

VAR 
    NUMBER : INTEGER;
BEGIN (* CHECK_MONTH *)
   RIGHT := TRUE;
   IF (DIGIT = 'DO') OR (DIGIT = 'do')
      THEN  (* USER HAS COMPLETED ENTRIES *)
         DONE := TRUE
      ELSE
         BEGIN  (* TO CHECK FOR INVALID ENTRIES *)
            IF (DIGIT[1] = '1') AND (DIGIT[2] > '2')
               THEN  (* ONLY 12 MONTHS IN A YEAR *)
                  RIGHT := FALSE;
            FOR NUMBER := 1 TO 2 DO
               BEGIN  (* FOR *)
                  CASE NUMBER OF  (* CHECK FOR INVALID ENTRIES *)
                     1 : 	IF (DIGIT[1] IN MONTH_1ST_DIGIT) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     2 : 	IF (DIGIT[2] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE
                  END  (* CASE *)
               END;  (* FOR *)
            IF (DIGIT[1] IN REMAINING_DIGITS) AND (DIGIT[2] = BLANK)
               THEN  (* USER HAS ENTER ONLY ONE CHARACTER *)
                  BEGIN
                     DIGIT[2] := DIGIT[1];
                     DIGIT[1] := '0';
                     RIGHT := TRUE;
                  END;  (* IF *)
            IF (DIGIT[1] = '0') AND (DIGIT[2] = '0')
               THEN
                  RIGHT := FALSE;
            IF (DIGIT = '  ')
               THEN  (* USER HAS HIT CARRIAGE RETURN *)
                  BEGIN
                     DIGIT := THEMONTH;
                     RIGHT := TRUE;
                  END;  (* IF DIGIT WAS BLANK, meaning USER hit carriage return *)
         END;  (* IF DIGIT = DO *)
END;  (* CHECK_MONTH *)





BEGIN  (* CORRECT_MONTH *)
   REPEAT
      CHECK_MONTH;
      IF NOT RIGHT
         THEN
            CORRECT_MONTH_OR_DAY_ENTRY(DIGIT,19,1);
   UNTIL RIGHT;
END;  (* CORRECT_MONTH *)

PROCEDURE CORRECT_DAY(VAR DIGIT : STRING2; VAR DONE : BOOLEAN);






                                                   (*

     Procedure CORRECT-DAY has the same operation and purpose as CORRECT-TIME except the application
     is for the DAY entry of the user.

                                            Calls:      CORRECT-MONTH-OR-DAY-ENTRY
                                                        CHECK-DAY
                                            Called by:  ENTER-DAY
                                                        CORRECT-MAX-DAYS
                                            Nests:      CHECK-DAY
                                            Nested w/i: Main

                                                   *)

VAR 
    RIGHT : BOOLEAN;

PROCEDURE CHECK_DAY;






                                                   (*

     Procedure CHECK-DAY has the same operation and function as CHECK-TIME except the application is
     for the entered DAY.

                                            Calls:      None
                                            Called by:  CORRECT-DAY
                                            Nests:      None
                                            Nested w/i: CORRECT-DAY

                                                   *)

CONST 
      BLANK = ' ';

VAR 
    NUMBER : INTEGER;
BEGIN (* CHECK_DAY *)
   RIGHT := TRUE;
   IF (DIGIT = 'DO') OR (DIGIT = 'do')
      THEN  (* USER HAS COMPLETED ENTRIES *)
         DONE := TRUE
      ELSE
         BEGIN  (* TO CHECK FOR INVALID ENTRIES *)
            FOR NUMBER := 1 TO 2 DO
               BEGIN  (* FOR *)
                  CASE NUMBER OF  (* CHECK ENTRIES *)
                     1 :  IF (DIGIT[1] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     2 :  IF (DIGIT[2] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE
                  END  (* CASE *)
               END;  (* FOR *)
            IF (DIGIT[1] IN REMAINING_DIGITS) AND (DIGIT[2] = BLANK)
               THEN
                  BEGIN  (* USER HAS ENTERED ONE CHARACTER *)
                     DIGIT[2] := DIGIT[1];
                     DIGIT[1] := '0';
                     RIGHT := TRUE
                  END;  (* IF *)
            IF (DIGIT[1] = '0') AND (DIGIT[2] = '0')
               THEN (* INVALID ENTRY; TOO LOW *)
                  RIGHT := FALSE;
            IF (DIGIT = '  ')
               THEN  (* USER HAS HIT CARRAGE RETURN *)
                  BEGIN
                     DIGIT := THEDAY;
                     RIGHT := TRUE;
                  END;  (* IF DIGIT WAS BLANK, meaning USER hit carriage return *)
         END;  (* IF DIGIT = DO *)
END;  (* DAY_CHECK *)





BEGIN  (* CORRECT_DAY *)
   REPEAT
      CHECK_DAY;
      IF NOT RIGHT
         THEN
            CORRECT_MONTH_OR_DAY_ENTRY(DIGIT,17,1);
   UNTIL RIGHT;
END;  (* CORRECT_DAY *)

PROCEDURE CORRECT_YEAR(VAR DIGIT : STRING4; VAR DONE : BOOLEAN);






                                                   (*

     Procedure CORRECT-YEAR has the same operation and purpose as CORRECT-TIME except  the  applica-
     tion is for the YEAR entry of the user.

                                            Calls:      CORRECT-TIME-OR-YEAR-ENTRY
                                                        CHECK-YEAR
                                            Called by:  ENTER-YEAR
                                            Nests:      CHECK-YEAR
                                            Nested w/i: Main

                                                   *)

VAR 
    RIGHT : BOOLEAN;

PROCEDURE CHECK_YEAR;






                                                   (*

     Procedure CHECK-YEAR has the same operation and function as CHECK-TIME except  the  application
     is for the entered YEAR.

                                            Calls:      None
                                            Called by:  CORRECT-YEAR
                                            Nests:      None
                                            Nested w/i: CORRECT-YEAR

                                                   *)

CONST 
      BLANK = ' ';

VAR 
    NUMBER : INTEGER;
BEGIN (* CHECK_YEAR *)
   RIGHT := TRUE;
   IF (DIGIT = 'DONE') OR (DIGIT = 'done')
      THEN  (* USER HAS COMPLETED ENTRIES *)
         DONE := TRUE
      ELSE
         BEGIN  (* TO CHECK FOR INVALID ENTRIES *)
            IF (DIGIT[1] = '1') AND (DIGIT[2] < '7')
               THEN
                  RIGHT := FALSE;
            IF (DIGIT[1] = '1') AND (DIGIT[2] = '7') AND (DIGIT[3] < '5') AND (RIGHT)
               THEN
                  RIGHT := FALSE;
            IF (DIGIT[1] = '1') AND (DIGIT[2] = '7') AND (DIGIT[3] = '5') AND (DIGIT[4] < '3') AND (RIGHT)
               THEN
                  RIGHT := FALSE;
            FOR NUMBER := 1 TO 4 DO
               BEGIN  (* FOR *)
                  CASE NUMBER OF  (* CHECK ENTRIES *)
                     1 :  IF (DIGIT[1] IN YEAR_1ST_DIGIT) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     2 :  IF (DIGIT[2] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     3 :  IF (DIGIT[3] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE;
                     4 :  IF (DIGIT[4] IN REMAINING_DIGITS) AND (RIGHT)
                             THEN
                                RIGHT := TRUE
                             ELSE
                                RIGHT := FALSE
                  END  (* CASE *)
               END; (* FOR *)
            IF (DIGIT[1] IN REMAINING_DIGITS)
               AND (DIGIT[2] IN REMAINING_DIGITS)
               AND (DIGIT[3] = BLANK)
               AND (DIGIT[4] = BLANK)
               THEN  (* USER HAS ENTERED TWO CHARACTERS *)
                  BEGIN
                     DIGIT[3] := DIGIT[1];
                     DIGIT[4] := DIGIT[2];
                     DIGIT[1] := THIS_CENTURY[1];
                     DIGIT[2] := THIS_CENTURY[2];
                     RIGHT := TRUE
                  END;  (* IF *)
            IF (DIGIT = '    ')
               THEN  (* USER HAS HIT CARRIAGE RETURN *)
                  BEGIN
                     DIGIT := THEYEAR;
                     RIGHT := TRUE
                  END  (* IF *)
         END  (* IF DIGIT = DONE *)
END; (* CHECK_YEAR *)





BEGIN  (* CHECK_MONTH *)
   REPEAT
      CHECK_YEAR;
      IF NOT RIGHT
         THEN
            CORRECT_time_or_year_entry(DIGIT,18,1);
   UNTIL RIGHT;
END; (* CORRECT_YEAR *)

PROCEDURE CORRECT_MAX_DAYS(VAR MONTH, DAY : STRING2;
                           YEAR : STRING4;
                           VAR DONE : BOOLEAN);






                                                   (*

     Procedure CORRECT-MAX-DAYS is used after the user has entered the month, day, and year  to  de-
     termine is the entered value has exceeded the maximum allowable days in the particular month he
     has entered.  If the maximum days in a month have been exceeded the user is then  prompted  for
     another  day.  This day is then tested to insure that it is within all parameters.  This proce-
     dure in invoked only after the single date entry has been completed because the logic must make
     allowances for a leap year.

                                            Calls:      CONVERT-MONTH
                                                        CONVERT-DAY
                                                        CONVERT-YEAR
                                                        MAX-DAYS-IN-MONTH
                                                        CLEAR-A-LOCAL-AREA
                                                        BELL
                                                        SET-UP-THE-BACK-GROUND
                                                        CLEAR-TO-END-OF-LINE
                                                        GOTOXY
                                                        CORRECT-DAY
                                            Called by:  DATAENTRY
                                                        ENTER-NEW-DATE
                                                        CHANGE-ENTRY
                                                        DELETE-ENTRY
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)

VAR 
    IMONTH,
    IDAY,
    IYEAR : INTEGER;
BEGIN  (* CORRECT_MAX_DAYS *)
   IF (YEAR = 'DONE') OR (YEAR = 'done')
      THEN  (* USER HAS COMPLETED ENTRIES *)
         DONE := TRUE
      ELSE
         BEGIN  (* TO CHECK FOR PROPER NUMBER OF DAYS *)
            IMONTH := CONVERT_MONTH(MONTH);
            IDAY := CONVERT_DAY(DAY);
            IYEAR := CONVERT_YEAR(YEAR);
            WHILE (IDAY > MAX_DAYS_IN_MONTH(IMONTH,IYEAR))
                  AND (NOT DONE) DO
               BEGIN (* TO FORCE USER TO RE-ENTER PROPER DAY *)
                  CLEAR_A_LOCAL_AREA(0,0,0,8);
                  BELL;
                  SET_UP_THE_BACK_GROUND(0,0);
                  WRITELN('You have entered a day that does not exist.');
                  CLEAR_TO_END_OF_LINE(0,1);
                  WRITELN('Enter the day. >');
                  READLN(DAY);
                  GOTOXY(5,6);
                  WRITELN(DAY);
                  CORRECT_DAY(DAY,DONE);
                  IDAY := CONVERT_DAY(DAY);
               END;  (* WHILE *)
         END;  (* IF *)
   CLEAR_TO_END_OF_LINE(0,0);
   CLEAR_TO_END_OF_LINE(0,1);
END;  (* CORRECT_MAX_DAYS *)

PROCEDURE QUERY(VAR LOGIC : BOOLEAN);






                                                   (*

     Procedure QUERY is used through out the program when a question has been asked and a yes or  no
     response  is  desired.   The wording of the question must be manipulated in order to return the
     desired logic (T or F) from this procedure.

                                            Calls:      BELL
                                                        PROPER-ENTRY
                                            Called by:  Quite a number of procedures
                                            Nests:      PROPER-ENTRY
                                            Nested w/i: Main

                                                   *)

VAR 
    ANSWER : CHAR;

PROCEDURE PROPER_ENTRY;






                                                   (*

     Procedure PROPER-ENTRY is used to compared the user supplied answer to a  yes  or  no  question
     against  the  allowable  values  of Y or y and N or n.  If an incorrect response has been given
     then a warning message is printed and the user is required to respond until a  proper  response
     has been entered.

                                            Calls:      BELL
                                                        SET-UP-THE-FORE-GROUND
                                                        CLEAR-TO-END-OF-LINE
                                            Called by:  QUERY
                                            Nests:      None
                                            Nested w/i: QUERY

                                                   *)
BEGIN  (* PROPER_ENTRY *)
   WHILE (ANSWER <> 'Y') AND (ANSWER <> 'N')
         AND (ANSWER <> 'y') AND (ANSWER <> 'n') DO
      BEGIN  (* FORCE USER TO ENTER PROPER CHARACTER *)
         BELL;
         SET_UP_THE_FORE_GROUND(37,18);
         WRITELN('You must enter a <Y> or <N>!! >');
         READLN(ANSWER);
         CLEAR_TO_END_OF_LINE(37,18);
      END; (* WHILE IMPROPER ENTRY *)
END; (* PROPER_ENTRY *)





BEGIN  (* QUERY *)
   BELL;
   READLN(ANSWER);
   PROPER_ENTRY;
   IF (ANSWER = 'Y') OR (ANSWER = 'y')
      THEN
         LOGIC := TRUE
      ELSE
         LOGIC := FALSE;
END; (* QUERY *)

PROCEDURE EXIT_INSTRUCTIONS;






                                                   (*

     Procedure EXIT-INSTRUCTIONS displays the message 

                              Enter DONE at a prompt to return to display.

     at the proper time in the program.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        SET-UP-THE-FORE-GROUND
                                            Called by:  DATAENTRY
                                                        ENTER-NEW-DATE
                                                        CHANGE-ENTRY
                                                        DELETE-ENTRY
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)

BEGIN  (* EXIT_INSTRUCTIONS *)
   SET_UP_THE_BACK_GROUND(11,17);
   WRITELN('        Enter      at a prompt to return to display.');
   SET_UP_THE_FORE_GROUND(25,17);
   WRITELN('DONE');
END; (* EXIT_INSTRUCTIONS *)

PROCEDURE ENTER_TIME(VAR TIME : STRING4; VAR  DONE : BOOLEAN);






                                                   (*

     Procedure ENTER-TIME is used within any procedure that requires a time entry.  Its  major  pur-
     pose  is  to reduce duplicated code through out the program.  This procedure calls CORRECT-TIME
     and then returns the entered data to the calling procedure.  Additionally, a  block  containing
     the entered TIME is printed on the screen.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CORRECT-TIME
                                                        GOTOXY
                                            Called by:  DATAENTRY
                                                        CHANGE-ENTRY
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* ENTER_TIME *)
   SET_UP_THE_BACK_GROUND(0,0);
   WRITELN('Enter the time, format is 0730. >');
   READLN(TIME);
   CORRECT_TIME(TIME,DONE);
   CLEAR_TO_END_OF_LINE(33,0);
   GOTOXY(2,4);
   WRITELN('Entered data');
   GOTOXY(2,5);
   WRITELN(TIME,' hours');
END;  (* ENTER_TIME *)

PROCEDURE ENTER_MONTH(VAR MONTH : STRING2; VAR DONE : BOOLEAN);






                                                   (*

     Procedure ENTER-MONTH is used within any procedure that requires a MONTH entry.  Its major pur-
     pose  is to reduce duplicated code through out the program.  This procedure calls CORRECT-MONTH
     and then returns the entered data to the calling procedure.  Additionally, a  block  containing
     the entered MONTH is printed on the screen.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CORRECT-MONTH
                                                        GOTOXY
                                            Called by:  DATAENTRY
                                                        CHANGE-ENTRY
                                                        ENTER-NEW-DATE
                                                        DELELTE-ENTRY
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* ENTER_MONTH *)
   SET_UP_THE_BACK_GROUND(0,1);
   WRITELN('Enter the ');
   GOTOXY(11,1);
   WRITELN('month. >');
   READLN(MONTH);
   CORRECT_MONTH(MONTH,DONE);
   GOTOXY(2,6);
   WRITELN(MONTH,'/');
END;  (* ENTER_MONTH *)

PROCEDURE ENTER_DAY(VAR DAY: STRING2; VAR DONE : BOOLEAN);






                                                   (*

     Procedure ENTER-DAY is used within any procedure that requires a DAY entry.  Its major  purpose
     is  to  reduce  duplicated  code through out the program.  This procedure calls CORRECT-DAY and
     then returns the entered data to the calling procedure.  Additionally, a block  containing  the
     entered DAY is printed on the screen.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CORRECT-DAY
                                                        GOTOXY
                                            Called by:  DATAENTRY
                                                        CHANGE-ENTRY
                                                        ENTER-NEW-DATE
                                                        DELELTE-ENTRY
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* ENTER_DAY *)
   SET_UP_THE_BACK_GROUND(11,1);
   CLEAR_TO_END_OF_LINE(11,1);
   WRITELN('day. >');
   READLN(DAY);
   CORRECT_DAY(DAY,DONE);
   GOTOXY(5,6);
   WRITELN(DAY,'/');
END;  (* ENTER_DAY *)

PROCEDURE ENTER_YEAR(VAR YEAR : STRING4; VAR DONE : BOOLEAN);






                                                   (*

     Procedure ENTER-YEAR is used within any procedure that requires a YEAR entry.  Its  major  pur-
     pose  is  to reduce duplicated code through out the program.  This procedure calls CORRECT-YEAR
     and then returns the entered data to the calling procedure.  Additionally, a  block  containing
     the entered YEAR is printed on the screen.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CORRECT-YEAR
                                                        GOTOXY
                                            Called by:  DATAENTRY
                                                        CHANGE-ENTRY
                                                        ENTER-NEW-DATE
                                                        DELELTE-ENTRY
                                                        PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* ENTER_YEAR *)
   SET_UP_THE_BACK_GROUND(11,1);
   CLEAR_TO_END_OF_LINE(11,1);
   WRITELN('year. >');
   READLN(YEAR);
   CORRECT_YEAR(YEAR,DONE);
   GOTOXY(8,6);
   WRITELN(YEAR);
   CLEAR_TO_END_OF_LINE(0,1);
END;  (* ENTER_YEAR *)

PROCEDURE ENTER_MESSAGE(VAR MESSAGE : STRING24);






                                                   (*

     Procedure ENTER-MESSAGE is used within any procedure that requires a MESSAGE entry.  Its  major
     purpose is to reduce duplicated code through out the program.  Additionally, a block containing
     the entered MESSAGE is printed on the screen.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        SET-UP-THE-FORE-GROUND
                                                        CLEAR-TO-END-OF-LINE
                                                        GOTOXY
                                            Called by:  DATAENTRY
                                                        CHANGE-ENTRY
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* ENTER_MESSAGE *)
   CLEAR_TO_END_OF_LINE(0,17);
   SET_UP_THE_BACK_GROUND(0,2);
   WRITELN('Enter the reminder, no more than 24 characters.');
   SET_UP_THE_FORE_GROUND(47,2);
   WRITELN(' (________________________)');
   SET_UP_THE_BACK_GROUND(49,2);
   READLN(MESSAGE);
   GOTOXY(2,7);
   WRITELN(MESSAGE);
   CLEAR_TO_END_OF_LINE(47,2);
END;  (* ENTER_MESSAGE *)

PROCEDURE COMPUTE_NEXT_DAY_OR_MONTH(VAR PAST_THE_UPPER_LIMIT : BOOLEAN;
                                    APPLICATION_IS_FOR_DAY : BOOLEAN);






                                                   (*

     Procedure COMPUTE-NEXT-DAY-OR-MONTH allows the user to select such  options  as  next  day  and
     quick  look.   This procedure calculates the next day or month instead of requiring the user to
     enter  the  actual  date.   The  use  (day  or  month)  is   determined   by   the   value   of
     APPLICATION-IS-FOR-DAY.   If APPLICATION-IS-FOR-DAY is TRUE then the procedure makes the neces-
     sary calculation to accomplish a next day value.  If not then a next month calculation is  per-
     formed.   This  procedure  is structured in the dual use manner in an effort to reduce duplica-
     tion.  If, during a user executed request, the value of THEYEAR exceeds 9999;  then  a  warning
     is  printed.   The boolean PAST-THE-UPPER-LIMIT prevents the repetition of this warning message
     if the QUICK-LOOK option has been requested.

                                            Calls:      CLEAR-THE-FORE-GROUND
                                                        CONVERT-MONTH
                                                        CONVERT-DAY
                                                        CONVERT-YEAR
                                                        MAX-DAYS-IN-MONTH
                                                        BELL
                                                        CLEAR-THE-SCREEN
                                                        SET-UP-THE-BACK-GROUND
                                                        GOTOXY
                                            Called by:  QUICK-LOOK-AT-NEXT-WEEK
                                                        THEN-DISPLAY-DAY-CALENDAR
                                                        QUICK-LOOK-AT-NEXT-12-MONTHS
                                                        THE-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
VAR 
    IMONTH,
    IDAY,
    IYEAR : INTEGER;
BEGIN  (* COMPUTE_NEXT_DAY_OR_MONTH *)
   CLEAR_THE_FORE_GROUND(4,0);
   PAST_THE_UPPER_LIMIT := FALSE;
   IMONTH := CONVERT_MONTH(THEMONTH);
   IDAY := CONVERT_DAY(THEDAY);
   IYEAR := CONVERT_YEAR(THEYEAR);
   IF APPLICATION_IS_FOR_DAY
      THEN
         BEGIN  (* INCRETE DAY *)
            IDAY := SUCC(IDAY);
            IF (IDAY > MAX_DAYS_IN_MONTH(IMONTH,IYEAR))
               THEN
                  BEGIN  (* INCRETE MONTH AND SET DAY TO 1 *)
                     IDAY := 1;
                     IMONTH := SUCC(IMONTH);
                  END  (* IF IDAY > MAX *)
         END  (* IF APPLICATION IS FOR DAY *)
      ELSE  (* APPLICATION IS FOR MONTH BY LOGIC *)
         IMONTH := SUCC(IMONTH);
   IF (IMONTH > 12)
      THEN  (* SET MONTH TO 1 *)
         BEGIN  (* INCRETE YEAR *)
            IMONTH := 1;
            IYEAR := SUCC(IYEAR)
         END;  (* IF IMONTH > 12 *)
   IF (IYEAR > 9999)
      THEN
         BEGIN  (* PRINT WARNING *)
            BELL;
            CLEAR_THE_SCREEN;
            SET_UP_THE_BACK_GROUND(20,7);
            GOTOXY(20,7);
            WRITELN('  The year 10000 is not allowed.');
            GOTOXY(20,9);
            WRITELN('Hit a carriage return to continue.');
            READLN;
            PAST_THE_UPPER_LIMIT := TRUE;
            IMONTH := 12;
            IDAY := 31;
            IYEAR := 9999;
         END;  (* IF *)
                                      (*
CONVERT DATE TO CHARACTERS
                                      *)

   THEMONTH[1] := CHR(IMONTH DIV 10 + 48);
   THEMONTH[2] := CHR(IMONTH MOD 10 + 48);
   IF APPLICATION_IS_FOR_DAY
      THEN  (* ASSIGN A NEW VALUE TO THEDAY *)
         BEGIN
            THEDAY[1] := CHR(IDAY DIV 10 + 48);
            THEDAY[2] := CHR(IDAY MOD 10 + 48);
         END;  (* IF *)
   THEYEAR[1] := CHR(IYEAR DIV 1000 + 48);
   THEYEAR[2] := CHR(((IYEAR MOD 1000) DIV 100) + 48);
   THEYEAR[3] := CHR(((IYEAR MOD 100) DIV 10) + 48);
   THEYEAR[4] := CHR(IYEAR MOD 10 + 48);
END;  (* THEN_COMPUTE_NEXT_DAY_OR_MONTH *)

PROCEDURE COMPUTE_PRIOR_DAY_OR_MONTH(VAR BELOW_THE_LOWER_LIMIT : BOOLEAN;
                                     APPLICATION_IS_FOR_DAY : BOOLEAN);






                                                  (*

     Procedure COMPUTE-PRIOR-DAY-OR-MONTH allows the user to select the option prior.   This  proce-
     dure  calculates the prior day or month instead of requiring the user to enter the actual date.
     The  use  (day  or  month)  is  determined  by  the  value   of   APPLICATION-IS-FOR-DAY.    If
     APPLICATION-IS-FOR-DAY is TRUE then the procedure makes the necessary calculation to accomplish
     a prior day value.  If not then a prior month calculation  is  performed.   This  procedure  is
     structured  in this dual use manner in an effort to reduce duplication.  If, during a user exe-
     cuted request, the value of THEYEAR falls below 1753;  then a warning is printed.

                                            Calls:      CLEAR-THE-FORE-GROUND
                                                        CONVERT-MONTH
                                                        CONVERT-DAY
                                                        CONVERT-YEAR
                                                        MAX-DAYS-IN-MONTH
                                                        BELL
                                                        CLEAR-THE-SCREEN
                                                        SET-UP-THE-BACK-GROUND
                                                        GOTOXY
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                                        THE-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: Main


                                                   *)

VAR 
    IMONTH,
    IDAY,
    IYEAR : INTEGER;
BEGIN  (* COMPUTE_PRIOR_DAY_OR_MONTH *)
   CLEAR_THE_FORE_GROUND(4,0);
   BELOW_THE_LOWER_LIMIT := FALSE;
   IMONTH := CONVERT_MONTH(THEMONTH);
   IDAY := CONVERT_DAY(THEDAY);
   IYEAR := CONVERT_YEAR(THEYEAR);
   IF APPLICATION_IS_FOR_DAY
      THEN  (* DECRETE DAY BY 1 *)
         BEGIN
            IDAY := PRED(IDAY);
            IF (IMONTH = 1) AND (IDAY = 0) AND (IYEAR >= 1753)
               THEN  (* INSURE THAT THE LOWER LIMIT IS NOT PASSED *)
                  BEGIN  (* DECRETE YEAR AND ASSIGN A VALUE TO MONTH AND DAY *)
                     IMONTH := 12;
                     IYEAR := PRED(IYEAR);
                     IDAY := MAX_DAYS_IN_MONTH(IMONTH,IYEAR);
                  END;  (* IF *)
            IF (IDAY = 0)
               THEN
                  BEGIN  (* DECRETE MONTH AND ASSIGN A VALUE FOR DAY *)
                     IMONTH := PRED(IMONTH);
                     IDAY := MAX_DAYS_IN_MONTH(IMONTH,IYEAR);
                  END  (* IF *)
         END  (* IF APPLICATION IS FOR DAY *)
      ELSE
         BEGIN  (* APPLICATION IS FOR MONTH BY LOGIC *)
            IMONTH := PRED(IMONTH);
            IF (IMONTH = 0) AND (IYEAR >= 1753)
               THEN
                  BEGIN  (* DECRETE YEAR AND ASSIGN A VALUE TO MONTH *)
                     IMONTH := 12;
                     IYEAR := PRED(IYEAR);
                  END;  (* IF *)
         END;  (* ELSE *)
   IF (IYEAR < 1753)
      THEN  (* PRINT A WARNING *)
         BEGIN
            BELL;
            CLEAR_THE_SCREEN;
            SET_UP_THE_BACK_GROUND(20,7);
            GOTOXY(20,7);
            WRITELN('  The year 1752 is not allowed.');
            GOTOXY(20,9);
            WRITELN('Hit a carriage return to continue.');
            READLN;
            BELOW_THE_LOWER_LIMIT := TRUE;
            IMONTH := 1;
            IDAY := 1;
            IYEAR := 1753;
         END;  (* IF *)
                                      (*
CONVERT DATE TO CHARACTERS
                                      *)
   THEMONTH[1] := CHR(IMONTH DIV 10 + 48);
   THEMONTH[2] := CHR(IMONTH MOD 10 + 48);
   IF APPLICATION_IS_FOR_DAY
      THEN
         BEGIN  (* ASSIGN A VALUE TO THEDAY *)
            THEDAY[1] := CHR(IDAY DIV 10 + 48);
            THEDAY[2] := CHR(IDAY MOD 10 + 48);
         END;  (* IF APPLICATION *)
   THEYEAR[1] := CHR(IYEAR DIV 1000 + 48);
   THEYEAR[2] := CHR(((IYEAR MOD 1000) DIV 100) + 48);
   THEYEAR[3] := CHR(((IYEAR MOD 100) DIV 10) + 48);
   THEYEAR[4] := CHR(IYEAR MOD 10 + 48);
END;  (* COMPUTE_PRIOR_DAY_OR_MONTH *)

PROCEDURE INTRODUCTION_TO_DATE_BOOK;






                                                   (*

     Procedure INTRODUCTION-TO-DATEBOOK prints a general welcome to the user.  Additionally, it  al-
     lows  him  to enter a three line heading that will appear at the top of any harcopy output that
     he may desire.  Additionally, the current date is displayed.

                                            Calls:      CLEAR-THE-SCREEN
                                                        SET-UP-THE-FORE-GROUND
                                                        SET-UP-THE-BACK-GROUND
                                                        GET-AND-PRINT-CURRENT-DATE
                                                        QUERY
                                                        GOTOXY
                                            Called by:  Main
                                            Nests:      GET-AND-PRINT-CURRENT-DATE
                                            Nested w/i: Main

                                                   *)

VAR 
    QUESTION : BOOLEAN;
    I : INTEGER;

PROCEDURE GET_AND_PRINT_CURRENT_DATE(MONTH,
                                     DAY : STRING2;
                                     YEAR : STRING4);






                                                   (*

     Procedure GET-AND-PRINT-CURRENT-DATE converts the current system date to  nice  form  and  then
     outputs this date when the user first runs DATEBOOK.

                                            Calls:      PRINT-MONTH
                                                        PRINT-DAY
                                                        SET-UP-THE-BACK-GROUND
                                                        SET-UP-THE-FORE-GROUND
                                            Called by:  INTRODUCTION-TO-DATEBOOK
                                            Nests:      None
                                            Nested w/i: INTRODUCTION-TO-DATEBOOK

                                                   *)

VAR 
    PRINT_THIS_MONTH,
    PRINT_THIS_DAY : STRING12;
BEGIN  (* GET_AND_PRINT_CURRENT_DATE *)
   PRINT_MONTH(MONTH,PRINT_THIS_MONTH);
   PRINT_DAY(MONTH,DAY,YEAR,PRINT_THIS_DAY);
   SET_UP_THE_BACK_GROUND(35,7);
   WRITELN('Today is');
   SET_UP_THE_FORE_GROUND(21,9);
   WRITELN(DAY,'  ',PRINT_THIS_MONTH,'  ',YEAR,', a',PRINT_THIS_DAY);
END;  (* GET_AND_PRINT_CURRENT_DATE *)





BEGIN  (* INTRODUCTION_TO_DATEBOOK *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_FORE_GROUND(0,3);
   WRITELN('                     WELCOME TO THE VAX/VMS PASCAL DATEBOOK');
   SET_UP_THE_BACK_GROUND(0,4);
   WRITELN('                  Department of Geography and Computer Science');
   WRITELN('           United States Military Academy, West Point, New York 10996');
   GET_AND_PRINT_CURRENT_DATE(THEMONTH,THEDAY,THEYEAR);
   SET_UP_THE_BACK_GROUND(0,14);
                                                           (*
ALLOW USER THE OPTION OF A HEADING ON HARDCOPY OUTPUT
                                                           *)
   WRITELN('          You now have the one time option to enter three sentences to');
   WRITELN('          act as the heading for any hardcopy output you choose to re-');
   WRITELN('          quest.');
   WRITELN;
   WRITELN;
   WRITELN('                Do you want to enter these sentences? <Y> or <N>');
   QUERY(QUESTION);
   IF QUESTION
      THEN  (* ALLOW USER TO ENTER DESIRED HEADING *)
         FOR I := 1 TO 3 DO
            BEGIN  (* FOR *)
               CLEAR_THE_SCREEN;
               SET_UP_THE_BACK_GROUND(0,2);
               WRITELN('Enter line     of your heading, no more than 45 characters.');
               GOTOXY(11,2);
               WRITELN(I:2);
               WRITELN;
               WRITELN;
               WRITELN('          (_____________________________________________)');
               GOTOXY(11,4);
               IF (I = 1)
                  THEN  (* ENTER HEADING LINE ONE *)
                     READLN(HEADER_ONE);
               IF (I = 2)
                  THEN  (* ENTER HEADING LINE TWO *)
                     READLN(HEADER_TWO);
               IF (I = 3)
                  THEN  (* ENTER HEADING LINE THREE *)
                     READLN(HEADER_THREE);
            END;  (* FOR *)
   CLEAR_THE_SCREEN;
END;  (* INTRODUCTION_TO_DATE_BOOK *)

FUNCTION TRANSLATE(ANSWER : STRING2) : INTEGER;






                                                   (*

     Function TRANSLATE converts the requested option to an integer for use in the particular  point
     of  the  program.  The user may enter either caps or small letters.  If the option requested is
     not present, then the procedure PRINT-OPTIONS-WARNING will do so because of its position as  an
     OTHERWISE statement.

                                            Calls:      None
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                                        THEN-DISPLAY-MONTH-CALENDAR
                                                        THEN-CHANGE-MAIN-DATAFILE
                                                        Main
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* TRANSLATE *)
   CASE ANSWER[1] OF  (* ASSIGN A VALUE TO TRANSLATE *)
      'E','e' : TRANSLATE := 1;
      'D','d' : TRANSLATE := 2;
      'M','m' : TRANSLATE := 3;
      'H','h' : CASE ANSWER[2] OF
                   'E','e' : TRANSLATE := 4;
                   'A','a' : TRANSLATE := 5
                END;  (* CASE ANSWER[2] OF *)
      'C','c' : TRANSLATE := 6;
      'P','p' : TRANSLATE := 7;
      'A','a' : TRANSLATE := 8;
      'S','s' : TRANSLATE := 9;
      'N','n' : TRANSLATE := 10;
      'R','r' : TRANSLATE := 11;
      ' '     : TRANSLATE := 12;
      'Q','q' : TRANSLATE := 13
   END  (* MAIN CASE *)
END;  (* TRANSLATE *)

PROCEDURE PRINT_OPTIONS_WARNING(OPTION : STRING2;
                                X,
                                Y,
                                X2,
                                Y2 : INTEGER);






                                                   (*

     Procedure PRINT-OPTIONS-WARNING informs the user that the character he has entered at a partic-
     ular  option selection level is not valid.  This is done because of its position within an OTH-
     ERWISE statement.  The option must be available at that particular selection level or this pro-
     cedure  will  be  executed.   The cursor is returned to the selection location after warning is





     printed.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        BELL
                                                        GOTOXY
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                                        THEN-DISPLAY-MONTH-CALENDAR
                                                        THEN-CHANGE-MAIN-DATAFILE
                                                        Main
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN (* PRINT_OPTIONS_WARNING *)
   SET_UP_THE_BACK_GROUND(X,Y);
   WRITELN(OPTION,' is not valid.');
   BELL;
   GOTOXY(X2,Y2);  (* RETURN CURSOR TO PROPER PLACE FOR OPTIONS SELECTION *)
END;  (* OPTIONS_WARNING *)

PROCEDURE PRINT_MAIN_OPTIONS;






                                                   (*

     Procedure PRINT-MAIN-OPTIONS prints the options availbale at the main level.  This  level  acts
     as  a  "cross-road"  for  the  program.  The user must return to this level anytime he cares to
     change the current operations he is performing.

                                            Calls:      SET-UP-THE-FORE-GROUND
                                                        GOTOXY
                                                        SET-UP-THE-BACK-GROUND
                                                        PRINT-DEFAULT-DATES
                                            Called by:  RETURN-TO-MAIN-PROGRAM
                                                        THEN-HELP
                                                        Main
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* PRINT_MAIN_OPTIONS *)
   SET_UP_THE_FORE_GROUND(35,5);
   WRITELN('MAIN OPTIONS');
   GOTOXY(30,7);
   WRITELN('C');
   GOTOXY(30,8);
   WRITELN('D');
   GOTOXY(30,9);
   WRITELN('E');
   GOTOXY(30,10);
   WRITELN('M');
   GOTOXY(30,11);
   WRITELN('S');
   GOTOXY(30,12);
   WRITELN('HELP');
   GOTOXY(30,15);
   WRITELN('highlighted');
   GOTOXY(50,9);
   WRITELN('(____)');
   SET_UP_THE_BACK_GROUND(31,7);
   WRITELN(')hange data file');
   GOTOXY(31,8);
   WRITELN(')ay display');
   GOTOXY(31,9);
   WRITELN(')nter new data');
   GOTOXY(31,10);
   WRITELN(')onth display');
   GOTOXY(31,11);
   WRITELN(')top');
   GOTOXY(20,14);
   WRITELN('Type HELP for an explanation of each option.');
   GOTOXY(25,15);
   WRITELN('Type');
   GOTOXY(42,15);
   WRITELN('characters only.');
   PRINT_DEFAULT_DATES;
   GOTOXY(51,9)
END;  (* PRINT_MAIN_OPTIONS *)

PROCEDURE RETURN_TO_MAIN_PROGRAM;






                                                   (*

     Procedure RETURN-TO-MAIN-PROGRAM act as the terminator for  the  sub-option  selection  levels.
     This  procedure  assigns a value of FALSE to the variable RETURN, which is used in the selction
     level repeat statements.  This allows exit from the REPEAT.  The first impression is that  this
     is not needed but, it is.  The main options are then printed thus, allowing the user to contin-
     ue with the program.

                        Calls:      CLEAR-THE-SCREEN
                                    PRINT-MAIN-OPTIONS
                        Called by:  RETURN-FROM-CHANGE-TO-MAIN-PROGRAM
                                    RETURN-FROM-DISPLAY-DAY-CALENDAR-TO-MAIN-PROGRAM
                                    RETURN-FROM-DISPLAY-MONTH-CALENDAR-TO-MAIN-PROGRAM
                        Nests:      None
                        Nested w/i: Main

                                                   *)
BEGIN  (* RETURN_TO_MAIN_PROGRAM *)
   CLEAR_THE_SCREEN;
   PRINT_MAIN_OPTIONS;
END;  (* RETURN_TO_MAIN_PROGRAM *)

PROCEDURE THEN_STOP_PROGRAM_EXECUTION;






                                                   (*

     Procedure THEN-STOP-PROGRAM-EXECUTION assigns a value of FALSE to the boolean  COMPLETE.   This
     allows  exit  from the main program repeat statement.  The screen is then cleared and a message
     is printed.

                                            Calls:      CLEAR-THE-SCREEN
                                                        SET-UP-THE-FORE-GROUND
                                                        SET-UP-THE-BACK-GROUND
                                            Called by:  Main
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)
BEGIN  (* THEN_STOP_PROGRAM_EXECUTION *)
   COMPLETE := TRUE;
   CLEAR_THE_SCREEN;
   SET_UP_THE_FORE_GROUND(0,0);
   WRITELN('Program execution complete.');
   SET_UP_THE_BACK_GROUND(0,1);
END;  (* THEN_STOP_PROGRAM_EXECUTION *)
(**)
(*

                             $$$$$$$$$$$$$$$$$$$$ HELP $$$$$$$$$$$$$$$$$$$$

                                                  *)










PROCEDURE HELP(VAR MORE_HELP : BOOLEAN;
               NEEDS : INTEGER);






                                                   (*

     Procedure HELP allows the user to receive a short explanation of each of the options  and  fea-
     tures  of  DATEBOOK.   Each  of the explantions available are within a separate procedure are a
     FAIRLY self-explanatory.  INDIVIDUAL DOCUMENTATION HAS NOT BEEN PROVIDED FOR THESE  PROCEDURES.
     The  procedures  that  determine  the sequence in which these explanations are print are in the
     Calls block below.  This structure will allow future modification by placing a call to each in-
     dividual explanation in a CASE statement.

                                            Called by:       THEN-HELP
                                                             HELP-DAY-DISPLAY 
                                                             HELP-MONTH-DISPLAY
                                                             HELP-WITH-CHANGE
                                            Important calls: MAIN-HELP
                                                             CHANGE-HELP
                                                             DAY-HELP
                                                             MONTH-HELP
                                            Nests:           Many
                                            Nested w/i:      Main

                                                   *)

PROCEDURE PRINT_HELP_INSTRUCTIONS;
BEGIN  (* PRINT_HELP_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                      HELP');
   WRITELN;
   WRITELN('          This option allows you to receive a short explanation of the');
   WRITELN('          various options available at this level.');
   WRITELN;
   WRITELN('          You must give a positive response to all  prompts  for  more');
   WRITELN('          information to obtain an explanation of all the options ava-');
   WRITELN('          ilable at this level.');
   WRITELN;
   WRITELN('                     Do you want more information? <Y> or <N>');
END;  (* PRINT_HELP_INSTRUCTIONS *)

PROCEDURE PRINT_RETURN_INSTRUCTIONS;
BEGIN  (* PRINT_RETURN_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                     Return');
   WRITELN;
   WRITELN('          This option allows you to return to the main  option  selec-');
   WRITELN('          tion level.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_RETURN_INSTRUCTIONS *)

PROCEDURE PRINT_HARDCOPY_INSTRUCTIONS;
BEGIN  (* PRINT_HARDCOPY_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                    HARDcopy');
   WRITELN;
   WRITELN('          This option allows you to receive a hardcopy of the  current');
   WRITELN('          display.');
   WRITELN;
   WRITELN('          Once you have finished program execution, you may type PRINT');
   WRITELN('          HARDCOPY.DAT  at  the system prompt to receive a hardcopy of');
   WRITELN('          your hardcopy requests.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_HARDCOPY_INSTRUCTIONS *)

PROCEDURE PRINT_NO_MORE_HELP;
BEGIN  (* PRINT_NO_MORE_HELP *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_FORE_GROUND(0,5);
   WRITELN('                 There is no new help remaining at this level.');
   SET_UP_THE_BACK_GROUND(0,7);
   WRITELN('                      Do you want to continue? <Y> or <N>');
END;  (* PRINT_NO_MORE_HELP *)

PROCEDURE PRINT_DAY_INSTRUCTIONS;
BEGIN  (* PRINT_DAY_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('          Option Day display allows you to view your entered  appoint-');
   WRITELN('          ments  one  day  at a time.  If you have concurrent appoint-');
   WRITELN('          ments scheduled a star will appear by the repeated entry.');
   WRITELN;
   WRITELN('          The day that will appear is reflected in the  default  dates');
   WRITELN('          that appear in the lower right corner.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_DAY_INSTRUCTIONS *)

PROCEDURE PRINT_ANOTHER_DAY_INSTRUCTIONS;
BEGIN  (* PRINT_ANOTHER_DAY_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                  Another day');
   WRITELN;
   WRITELN('          This option allows you to enter another date and  have  that');
   WRITELN('          date appear in the day display format.  ');
   WRITELN;
   WRITELN('          Remember that once you have entered a date with this option,');
   WRITELN('          the  default dates for the program will change.  The current');
   WRITELN('          default dates appear in the lower right hand corner.');
   WRITELN;
   WRITELN('          You can return to the prior  default  dates  by  making  the');
   WRITELN('          proper  entry  with  this option or with the next, prior, or');
   WRITELN('          quick options.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_ANOTHER_DAY_INSTRUCTIONS *)

PROCEDURE PRINT_NEXT_DAY_INSTRUCTIONS;
BEGIN  (* PRINT_NEXT_DAY_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                    next day');
   WRITELN;
   WRITELN('          This option allows you to view the next  day  without  being');
   WRITELN('          required  to  enter the date through the Another day option.');
   WRITELN;
   WRITELN('          You select this option simply by hitting  the  carriage  re-');
   WRITELN('          turn.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_NEXT_DAY_INSTRUCTIONS *)

PROCEDURE PRINT_PRIOR_DAY_INSTRUCTIONS;
BEGIN  (* PRINT_PRIOR_DAY_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                   Prior day');
   WRITELN;
   WRITELN('          This option allows you to view the prior day  without  being');
   WRITELN('          required  to  enter the date through the Another day option.');
   WRITELN('          You select this option simply by entering P and pressing the');
   WRITELN('          carriage return.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_PRIOR_DAY_INSTRUCTIONS *)

PROCEDURE PRINT_QUICK_DAY_LOOK_INSTRUCTIONS;
BEGIN   (* PRINT_QUICK_DAY_LOOK_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                   Quick look');
   WRITELN;
   WRITELN('          This option allows you to view, in  very  fast  progression,');
   WRITELN('          the next week.  You select this option by entering Q.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_QUICK_DAY_LOOK_INSTRUCTIONS *)

PROCEDURE PRINT_MONTH_DISPLAY_INSTRUCTIONS;
BEGIN  (* PRINT_MONTH_DISPLAY_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('          Option Month display allows you to view the current month as');
   WRITELN('          indicated in the default dates.  In the lower right box will');
   WRITELN('          appear the total  number  of  appointments/events  you  have');
   WRITELN('          scheduled in the displayed month.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_MONTH_DISPLAY_INSTRUCTIONS *)

PROCEDURE PRINT_ANOTHER_MONTH_DATE_INSTRUCTIONS;
BEGIN  (* PRINT_ANOTHER_MONTH_DATE_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                  Another date');
   WRITELN;
   WRITELN('          This option allows you to enter another month and year  that');
   WRITELN('          you  would  like to view.  You do not have to enter the full');
   WRITELN('          numeric sequence for a year if you would like the same year.');
   WRITELN('          If you would like another year which is still in this centu-');
   WRITELN('          ry then all you must  do  is  enter  the  last  two  digits.');
   WRITELN;
   WRITELN('          Remember  that  once another date has been selected that the');
   WRITELN('          defaults in the lower right corner will change.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_ANOTHER_MONTH_DATE_INSTRUCTIONS *)

PROCEDURE PRINT_NEXT_MONTH_INSTRUCTIONS;
BEGIN  (* PRINT_NEXT_MONTH_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                   next month');
   WRITELN;
   WRITELN('          This option allows you to view the next month without  being');
   WRITELN('          required  to enter the date through the Another date option.');
   WRITELN;
   WRITELN('          Simply hit the carriage return.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END; (* PRINT_NEXT_MONTH_INSTRUCTIONS *)

PROCEDURE PRINT_PRIOR_MONTH_INSTRUCTIONS;
BEGIN  (* PRINT_PRIOR_MONTH_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                  Prior month');
   WRITELN;
   WRITELN('          This option allows you to view the prior month without being');
   WRITELN('          required  to enter the date through the Another date option.');
   WRITELN;
   WRITELN('          Simply enter P and press the carriage return.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_PRIOR_MONTH_INSTRUCTIONS *)

PROCEDURE PRINT_QUICK_MONTH_LOOK_INSTRUCTIONS;
BEGIN  (* PRINT_QUICK_MONTH_LOOK_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                   Quick look');
   WRITELN;
   WRITELN('          This option allows you to view the next year  in  very  fast');
   WRITELN('          progression.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_QUICK_MONTH_LOOK_INSTRUCTIONS *)

PROCEDURE PRINT_STOP_INSTRUCTIONS;
BEGIN  (* PRINT_STOP_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                      Stop');
   WRITELN;
   WRITELN('                  This option will terminate program execution.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_STOP_INSTRUCTIONS *)

PROCEDURE PRINT_CHANGE_DATA_INSTRUCTIONS;
BEGIN  (* PRINT_CHANGE_DATA_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('          Option Change data file allows you to make three type of al-');
   WRITELN('          terations  to  the  main datafile.  You may change an entry.');
   WRITELN('          You may delete an entry.  And you make purge a group of  en-');
   WRITELN('          tries.');
   WRITELN;
   WRITELN('          You will be prompted before you make a final decision as  to');
   WRITELN('          whether or not you to make the alteration.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_CHANGE_DATA_INSTRUCTIONS *)

PROCEDURE PRINT_CHANGE_INSTRUCTIONS;
BEGIN  (* PRINT_CHANGE_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                 Change an entry');
   WRITELN;
   WRITELN('          With this option, DATEBOOK offers you the ability to  change');
   WRITELN('          an entry in your datafile.');
   WRITELN;
   WRITELN('          You  will  be  prompted  as to the MONTH, DAY, and  YEAR  of');
   WRITELN('          the  entry  you  would  like to change.  If the entry exists');
   WRITELN('          then you will be given the opportunity to  change  the  TIME');
   WRITELN('          and MESSAGE.  If you would like to change the MONTH, DAY, or');
   WRITELN('          YEAR, then you must  select  the  Change  option  Delete  an');
   WRITELN('          entry,  delete the entry then return to the Main Options and');
   WRITELN('          select Enter data.');
   WRITELN;
   WRITELN('                     Do you want more information? <Y> or <N>');
END;  (* PRINT_CHANGE_INSTRUCTIONS *)

PROCEDURE PRINT_DELETE_INSTRUCTIONS;
BEGIN  (* PRINT_DELETE_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,5);
   WRITELN('                                Delete an entry');
   WRITELN;
   WRITELN('          With this option, DATEBOOK offers you the ability to  delete');
   WRITELN('          a specific or a number of specific entries in your datafile.');
   WRITELN('          You will be prompted to enter a month, a day,  and  a  year.');
   WRITELN('          You  will  then  be  asked  if you want to delete a specific');
   WRITELN('          entry associated with that day.  If there are  a  number  of');
   WRITELN('          entries  on  that  particular day, then you will be asked if');
   WRITELN('          you would like to delete each entry as a match with your en-');
   WRITELN('          tered date is found.');
   WRITELN;
   WRITELN('                     Do you want more information? <Y> or <N>');
END;  (* PRINT_DELETE_INSTRUCTIONS *)

PROCEDURE PRINT_PURGE_INSTRUCTIONS;
BEGIN  (* PRINT_PURGE_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,1);
   WRITELN('                            Purge a group of entries');
   WRITELN;
   WRITELN('          With this option, DATEBOOK offers you the ability to  delete');
   WRITELN('          a  group  of  entries in your datafile.  Various examples of');
   WRITELN('          this option are as follows.  If you would like to delete all');
   WRITELN('          entries  on  12/12/1912,  then  your  start  date  would  be');
   WRITELN('          12/12/1912 and your stop date would be 12/12/1912.   If  you');
   WRITELN('          would  like  to  delete  the entire datafile then your start');
   WRITELN('          date would  be  01/01/1753  and  your  stop  date  would  be');
   WRITELN('          12/31/9999.   Finally,  if  you would like to delete all en-');
   WRITELN('          tries in the month of May, 1981, then your start date  would');
   WRITELN('          be 05/01/1981 and your stop date would be 05/30/1981.');
   WRITELN;
   WRITELN('          You have the ability with this option to  delete  an  entire');
   WRITELN('          days,   months,  or  years   entries.  Additionally, you may');
   WRITELN('          delete the entire datafile.');
   SET_UP_THE_FORE_GROUND(0,18);
   WRITELN('          Because you can delete the entire datafile, you  should  in-');
   WRITELN('          sure  that  your  dates are correct.  Be careful of your en-');
   WRITELN('          tries.');
   SET_UP_THE_BACK_GROUND(0,23);
   WRITELN('                     Do you want more information? <Y> or <N>');
END;  (* PRINT_PURGE_INSTRUCTIONS *)

PROCEDURE PRINT_ENTER_DATA_INSTRUCTIONS;
BEGIN  (* PRINT_ENTER_DATA_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,2);
   WRITELN('          Option Enter data allows you to enter data  into  the  data-');
   WRITELN('          file.');
   WRITELN;
   WRITELN('          In order to save yourself time, you should insure  that  the');
   WRITELN('          items you enter are correct.  If you make a mistake you will');
   WRITELN('          be informed of such, but the specific mistake  will  not  be');
   WRITELN('          explained.');
   WRITELN;
   WRITELN('          You must enter all items in numeric form and within the lim-');
   WRITELN('          its of:');
   WRITELN;
   WRITELN('          TIME - 0001 hours to 2400 hours.');
   WRITELN('          MONTH - 1 to 12.');
   WRITELN('          DAY - as per month');
   WRITELN('          YEAR - 1753 to 9999');
   WRITELN;
   WRITELN('          You may enter done at any prompt that has a message to  that');
   WRITELN('          effect displayed.  This will allow you to return to the main');
   WRITELN('          option level.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_ENTER_DATA_INSTRUCTIONS *)

PROCEDURE PRINT_MORE_INSTRUCTIONS;
BEGIN  (* PRINT_MORE_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,3);
   WRITELN('          DATEBOOK is a PASCAL program that is designed to  allow  the');
   WRITELN('          user  the  ability to enter appointment type entries and re-');
   WRITELN('          trieve this data either on a  cathode  ray  terminal  or  in');
   WRITELN('          hardcopy form.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_MORE_INSTRUCTIONS *)

PROCEDURE PRINT_STILL_MORE_INSTRUCTIONS;
BEGIN  (* PRINT_STILL_MORE_INSTRUCTIONS *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,1);
   WRITELN('          There are several features which  may  confuse  the  untried');
   WRITELN('          user.   One is that the lower date limit for this program is');
   WRITELN('          1 January 1753 (01/01/1753).  Another is that the upper date');
   WRITELN('          limit is 31 December 9999(12/31/9999).');
   WRITELN;
   WRITELN('          Additionally, all entries involving  TIME,  MONTH,  DAY,  or');
   WRITELN('          YEAR  are  to be numeric.  If you may a mistake and enter an');
   WRITELN('          improper item of data, you will be informed  of  such.   The');
   WRITELN('          specific  mistake  will not be pointed out.  The most common');
   WRITELN('          mistake that may be made is exceeding an  established  limit');
   WRITELN('          on date entries.');
   WRITELN;
   WRITELN('          Finally, when entering data there are several defaults.  You');
   WRITELN('          are  not  required to enter the entire number sequence for a');
   WRITELN('          year if you want the year to be in the current century.   If');
   WRITELN('          you would like to enter 85 for a year, then the program will');
   WRITELN('          take this to mean, 1985.  Additionally, you may hit the car-');
   WRITELN('          riage  return  for any entry requiring a month, day, or year');
   WRITELN('          and the program will take the values for month, day, or year');
   WRITELN('          that appears in the lower right corner of the screen.');
   WRITELN;
   WRITELN('                    Do you want more information? <Y> or <N>');
END;  (* PRINT_STILL_MORE_INSTRUCTIONS *)

PROCEDURE MAIN_HELP(VAR MORE : BOOLEAN);
BEGIN  (* MAIN_HELP *)
   PRINT_MORE_INSTRUCTIONS;
   QUERY(MORE);
   IF MORE
      THEN
         BEGIN
            PRINT_STILL_MORE_INSTRUCTIONS;
            QUERY(MORE);
            IF MORE
               THEN
                  BEGIN
                     PRINT_HELP_INSTRUCTIONS;
                     QUERY(MORE);
                     IF MORE
                        THEN
                           BEGIN
                              PRINT_CHANGE_DATA_INSTRUCTIONS;
                              QUERY(MORE);
                              IF MORE
                                 THEN
                                    BEGIN
                                       PRINT_DAY_INSTRUCTIONS;
                                       QUERY(MORE);
                                       IF MORE
                                          THEN
                                             BEGIN
                                                PRINT_ENTER_DATA_INSTRUCTIONS;
                                                QUERY(MORE);
                                                IF MORE
                                                   THEN
                                                      BEGIN
                                                         PRINT_MONTH_DISPLAY_INSTRUCTIONS;
                                                         QUERY(MORE);
                                                         IF MORE
                                                            THEN
                                                               BEGIN
                                                                  PRINT_STOP_INSTRUCTIONS;
                                                                  QUERY(MORE);
                                                                  IF MORE
                                                                     THEN
                                                                        BEGIN
                                                                           PRINT_NO_MORE_HELP;
                                                                           QUERY(MORE);
                                                                        END;
                                                               END;
                                                      END;
                                             END;
                                    END;
                           END;
                  END;
         END;
END; (* MAIN_HELP *)

PROCEDURE CHANGE_HELP(VAR MORE : BOOLEAN);
BEGIN  (* CHANGE_HELP *)
   PRINT_HELP_INSTRUCTIONS;
   QUERY(MORE);
   IF MORE
      THEN
         BEGIN
            PRINT_CHANGE_DATA_INSTRUCTIONS;
            QUERY(MORE);
            IF MORE
               THEN
                  BEGIN
                     PRINT_CHANGE_INSTRUCTIONS;
                     QUERY(MORE);
                     IF MORE
                        THEN
                           BEGIN
                              PRINT_DELETE_INSTRUCTIONS;
                              QUERY(MORE);
                              IF MORE
                                 THEN
                                    BEGIN
                                       PRINT_PURGE_INSTRUCTIONS;
                                       QUERY(MORE);
                                       IF MORE
                                          THEN
                                             BEGIN
                                                PRINT_RETURN_INSTRUCTIONS;
                                                QUERY(MORE);
                                                IF MORE
                                                   THEN
                                                      BEGIN
                                                         PRINT_NO_MORE_HELP;
                                                         QUERY(MORE);
                                                      END;
                                             END;
                                    END;
                           END;
                  END;
         END;
END;  (* CHANGE_HELP *)

PROCEDURE DAY_HELP(VAR MORE : BOOLEAN);
BEGIN  (* DAY_HELP *)
   PRINT_HELP_INSTRUCTIONS;
   QUERY(MORE);
   IF MORE
      THEN
         BEGIN
            PRINT_DAY_INSTRUCTIONS;
            QUERY(MORE);
            IF MORE
               THEN
                  BEGIN
                     PRINT_ANOTHER_DAY_INSTRUCTIONS;
                     QUERY(MORE);
                     IF MORE
                        THEN
                           BEGIN
                              PRINT_NEXT_DAY_INSTRUCTIONS;
                              QUERY(MORE);
                              IF MORE
                                 THEN
                                    BEGIN
                                       PRINT_PRIOR_DAY_INSTRUCTIONS;
                                       QUERY(MORE);
                                       IF MORE
                                          THEN
                                             BEGIN
                                                PRINT_QUICK_DAY_LOOK_INSTRUCTIONS;
                                                QUERY(MORE);
                                                IF MORE
                                                   THEN
                                                      BEGIN
                                                         PRINT_HARDCOPY_INSTRUCTIONS;
                                                         QUERY(MORE);
                                                         IF MORE
                                                            THEN
                                                               BEGIN
                                                                  PRINT_RETURN_INSTRUCTIONS;
                                                                  QUERY(MORE);
                                                                  IF MORE
                                                                     THEN
                                                                        BEGIN
                                                                           PRINT_NO_MORE_HELP;
                                                                           QUERY(MORE);
                                                                        END;
                                                               END;
                                                      END;
                                             END;
                                    END;
                           END;
                  END;
         END;
END;  (* DAY_HELP *)

PROCEDURE MONTH_HELP(VAR MORE : BOOLEAN);
BEGIN  (* MONTH_HELP *)
   PRINT_HELP_INSTRUCTIONS;
   QUERY(MORE);
   IF MORE
      THEN
         BEGIN
            PRINT_MONTH_DISPLAY_INSTRUCTIONS;
            QUERY(MORE);
            IF MORE
               THEN
                  BEGIN
                     PRINT_ANOTHER_MONTH_DATE_INSTRUCTIONS;
                     QUERY(MORE);
                     IF MORE
                        THEN
                           BEGIN
                              PRINT_NEXT_MONTH_INSTRUCTIONS;
                              QUERY(MORE);
                              IF MORE
                                 THEN
                                    BEGIN
                                       PRINT_PRIOR_MONTH_INSTRUCTIONS;
                                       QUERY(MORE);
                                       IF MORE
                                          THEN
                                             BEGIN
                                                PRINT_QUICK_MONTH_LOOK_INSTRUCTIONS;
                                                QUERY(MORE);
                                                IF MORE
                                                   THEN
                                                      BEGIN
                                                         PRINT_HARDCOPY_INSTRUCTIONS;
                                                         QUERY(MORE);
                                                         IF MORE
                                                            THEN
                                                               BEGIN
                                                                  PRINT_RETURN_INSTRUCTIONS;
                                                                  QUERY(MORE);
                                                                  IF MORE
                                                                     THEN
                                                                        BEGIN
                                                                           PRINT_NO_MORE_HELP;
                                                                           QUERY(MORE);
                                                                        END;
                                                               END;
                                                      END;
                                             END;
                                    END;
                           END;
                  END;
         END;
END;  (* MONTH_HELP *)










BEGIN  (* HELP *)
   MORE_HELP := TRUE;
   repeat (* FIX FOR THE VT VERSION *)
   CLEAR_THE_SCREEN;
      CASE NEEDS OF  (* VALUE OF NEEDS DETERMINES THE SEQUENCE OF HELP TO BE OFFERED *)
         1 : MAIN_HELP(MORE_HELP);
         2 : CHANGE_HELP(MORE_HELP);
         3 : DAY_HELP(MORE_HELP);
         4 : MONTH_HELP(MORE_HELP);
      END  (* CASE *)
   UNTIL NOT MORE_HELP;
   CLEAR_THE_SCREEN;
END;  (* HELP *)

PROCEDURE THEN_HELP;






                                                   (*

     Procedure THEN-HELP allows the user access to HELP from the main options selection level.

                                            Calls:      HELP
                                                        PRINT-MAIN-OPTIONS
                                            Called by:  Main
                                            Nests:      None
                                            Nested w/i: Main

                                                   *)

VAR 
    MORE : BOOLEAN;
BEGIN  (* THEN_HELP *)
   MORE := TRUE;
   REPEAT
      HELP(MORE,1);
   UNTIL NOT MORE;
   PRINT_MAIN_OPTIONS;
END;  (* THEN_HELP *)

(**)
                                                  (*

                          $$$$$$$$$$$$$$$$$$$$ DATA ENTRY $$$$$$$$$$$$$$$$$$$$

                                                   *)










PROCEDURE THEN_DATA_ENTRY;






                                                   (*

     Procedure THEN-DATA-ENTRY acts as the coordinator for those procedures that allow the  user  to
     enter  data into the datafile, MAINDATA.  The main purpose of this procedure is to allow struc-
     ture and a separate identity to those procedures primarily concerned with data entry.

                                            Calls:      CLEAR-THE-SCREEN
                                                        DATAENTRY
                                                        RETURN-TO-MAIN-PROGRAM
                                            Called by:  Main
                                            Nests:      DATAENTRY
                                            Nested w/i: Main

                                                   *)

PROCEDURE DATAENTRY;






                                                   (*

     Procedure DATAENTRY allows the user to enter data into the main datafile.  This  is  the  major
     procedure  of  the  THEN-DATA-ENTRY level of the program.  All data is enter through the use of
     this procedure, checked to insure that it is a proper entry, and then merged into the main  da-
     tafile.


                                            Calls:      CLEAR-THE-SCREEN
                                                        EXIT-INSTRUCTIONS
                                                        PRINT-DEFAULT-DATES
                                                        PRINT-ENTRY-DATE
                                                        ENTER-TIME
                                                        ENTER-MONTH
                                                        ENTER-DAY
                                                        ENTER-YEAR
                                                        CORRECT-MAX-DAYS
                                                        ENTER-MESSAGE
                                                        GIVE-OPTION
                                                        MERGE
                                            Called by:  THEN-ENTER-DATA
                                            Nests:      PRINT-ENTRY-DATE
                                                        GIVE-OPTION
                                                        MERGE
                                            Nested w/i: THEN-DATA-ENTRY

                                                   *)
VAR 
    INSTRUCTIONS,
    REPLY,
    SEVERAL_TIMES,
    DONE : BOOLEAN;
    COUNT : INTEGER;
    ONE_APPOINTMENT_ENTRY : DATAREC;

PROCEDURE PRINT_ENTRY_DATE(MONTH,DAY : STRING2; YEAR : STRING4);






                                                   (*

     Procedure PRINT-ENTER-DATE displays the date that the user is  entering  data  for  if  he  has
     elected to enter several times on the same date.  

                                            Calls:      PRINT-MONTH
                                                        PRINT-DAY
                                                        SET-UP-THE-BACK-GROUND
                                                        SET-UP-THE-FORE-GROUND
                                            Called by:  DATAENTRY
                                            Nests:      None
                                            Nested w/i: DATAENTRY

                                                   *)

VAR 
    PRINT_THIS_MONTH,
    PRINT_THIS_DAY : STRING12;
BEGIN  (* PRINT_ENTRY_DATE *)
   PRINT_MONTH(MONTH,PRINT_THIS_MONTH);
   PRINT_DAY(MONTH,DAY,YEAR,PRINT_THIS_DAY);
   SET_UP_THE_BACK_GROUND(26,8);
   WRITELN('You are entering data for');
   SET_UP_THE_FORE_GROUND(21,9);
   WRITELN(DAY,'  ',PRINT_THIS_MONTH,'  ',YEAR,', a',PRINT_THIS_DAY);
END;  (* PRINT_ENTRY_DATE *)

PROCEDURE GIVE_OPTION(VAR INSTRUCTIONS, SEVERAL_TIMES : BOOLEAN);






                                                   (*

     Procedure GIVE-OPTION offers the user the ability to make a selection as to  whether  he  would
     like to enter several times on the same day or continue receiving all prompts.  If he elects to
     enter several times on the same day, he will be promted for a time and message entry only.

                                            Calls:      CLEAR-THE-SCREEN
                                                        SET-UP-THE-BACK-GROUND
                                                        SET-UP-THE-FORE-GROUND
                                                        GOTOXY
                                                        QUERY
                                            Called by:  DATAENTRY
                                            Nests:      None
                                            Nested w/i: DATAENTRY

                                                   *)

VAR 
    REPLY : BOOLEAN;
BEGIN  (* GIVE_OPTION *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,7);
   WRITELN('                           You now have two options.');
   WRITELN;
   WRITELN('          1) You can enter several dates.  In which case, you will re-');
   WRITELN('          ceive all prompts.');
   WRITELN;
   WRITELN('          2) You can enter several different times on  the  same  day.');
   WRITELN('          In which case, only minimum prompts will appear.');
   WRITELN;
   SET_UP_THE_FORE_GROUND(0,16);
   GOTOXY(0,16);
   WRITELN('        Do you want to enter several times on the same day? <Y> or <N>');
   QUERY(REPLY);
   CLEAR_THE_SCREEN;
   IF REPLY
      THEN
         BEGIN  (* INSURE SAME DAY ENTRY AND NO MORE OPTION *)
            SEVERAL_TIMES := TRUE;
            INSTRUCTIONS := FALSE
         END  (* THEN *)
      ELSE
         BEGIN (* INSURE REPEATED ENTRIES AND NO MORE OPTION *)
            SEVERAL_TIMES := FALSE;
            INSTRUCTIONS := FALSE
         END  (* ELSE *)
END;  (* GIVE_OPTION *)

PROCEDURE MERGE;






                                                   (*

     Procedure MERGE accomplishes the following operation to the main datafile:  combines  the  cur-
     rent user entries with the old user entries, sorts the datafile in chronological order, and at-
     taches a number to the specific entry for later use in THEN-CHANGE-MAIN-DATAFILE.

                                            Calls:      PRINT-WAIT-MESSAGE
                                                        MOVE-DATA-TO-SCRATCH-FILE
                                                        MOVE-SCRATCH-FILE-TO-MAIN-FILE
                                                        SORT-MAIN-DATAFILE
                                                        COUNT-TOTAL-NUMBER-OF-ENTRIES
                                            Called by:  DATAENTRY
                                            Nests:      SORT-FILE
                                                        MOVE-DATA-TO-SCRATCH-FILE
                                                        MOVE-SCRATCH-FILE-TO-MAIN-FILE
                                                        COUNT-TOTAL-NUMBER-OF-ENTRIES
                                            Nested w/i: DATAENTRY

                                                   *)

VAR 
    TEMPENTRY : FILE OF DATAREC;

PROCEDURE PRINT_WAIT_MESSAGE;
BEGIN  (* PRINT_WAIT_MESSAGE *)
   BELL;
   CLEAR_THE_SCREEN;
   SET_UP_THE_FORE_GROUND(0,7);
   WRITELN('                             Please wait a moment.');
END;  (* PRINT_WAIT_MESSAGE *)

PROCEDURE MOVE_DATA_TO_SCRATCH_FILE;






                                                   (*

     Procedure MOVE-DATA-TO-SCRATCH-FILE take the items in CURENTRY and  MAINDATA  and  placed  them
     into a temporary file.  Additionally, it test the last entry in the datafile to see if it is the
     BOGUS entry.  If not (meaning this is the first time the program has been used) then  the  BOGUS
     entry  is  created.   This  was  done  because  of  programmer  logic  faults  in the procedure
     PURGE-A-GROUP.

                                            Calls:      None
                                            Called by:  MERGE
                                            Nests:      None
                                            Nested w/i: MERGE

                                                   *)

VAR 
    ONE_BOGUS_ENTRY : DATAREC;
BEGIN  (* MOVE_DATA_TO_SCRATCH_FILE *)
   RESET(MAINDATA);
   RESET(CURENTRY);
   rewrite(TEMPENTRY);
   WHILE NOT EOF(MAINDATA) DO
      BEGIN  (* TRANSFER MAINDATA TO SCRATCH FILE AND ASSIGN A VALUE TO BOGUS ENTRY *)
         ONE_BOGUS_ENTRY := MAINDATA^;
         TEMPENTRY^ := MAINDATA^;
         GET(MAINDATA);
         PUT(TEMPENTRY)
      END;  (* WHILE NOT EOF *)
   IF (ONE_BOGUS_ENTRY.TIME <> '2401')
                                                           (*
TEST OF THE LAST ENTRY IN THE DATAFILE FOR THE BOGUS ENTRY
                                                           *)
      THEN  (* ASSIGN LAST VALUE OF DATAFILE OUT OF REACH OF PROGRAM *)
         BEGIN
            ONE_BOGUS_ENTRY.TIME := '2401';
            ONE_BOGUS_ENTRY.MONTH := '99';
            ONE_BOGUS_ENTRY.DAY := '99';
            ONE_BOGUS_ENTRY.YEAR := '9999';
            ONE_BOGUS_ENTRY.MESSAGE := 'THIS IS A BOGUS ENTRY   ';
            TEMPENTRY^ := ONE_BOGUS_ENTRY;
            PUT(TEMPENTRY);
         END;  (* IF *)
   WHILE NOT EOF(CURENTRY) DO
      BEGIN  (* MOVE ALL CURRENT ENTRIES TO SCRATCH FILE *)
         TEMPENTRY^ := CURENTRY^;
         GET(CURENTRY);
         PUT(TEMPENTRY);
      END  (* WHILE NOT EOF *)
END;  (* MOVE_DATA_TO_SCRATCH_FILE *)

PROCEDURE MOVE_SCRATCH_FILE_TO_MAIN_FILE;






                                                   (*

     Procedure MOVE-SCRATCH-FILE-TO-MAIN-FILE take the combined file, TEMPENTRY and places  it  into
     MAINDATA.

                                            Calls:      None
                                            Called by:  MERGE
                                            Nests:      None
                                            Nested w/i: MERGE

                                                   *)
BEGIN  (* MOVE_SCRATCH_FILE_TO_MAIN_FILE *)
   rewrite(MAINDATA);
   RESET(TEMPENTRY);
   WHILE NOT EOF(TEMPENTRY) DO
      BEGIN  (* PUT SCRATCH FILE INTO MAIN DATAFILE *)
         MAINDATA^ := TEMPENTRY^;
         GET(TEMPENTRY);
         PUT(MAINDATA)
      END  (* WHILE NOT EOF *)
END;  (* MOVE_SCRATCH_FILE_TO_MAIN_FILE *)

PROCEDURE SORT_MAIN_DATAFILE;






                                                   (*

     Procedure SORT-MAIN-DATAFILE employs a linked list to place the  data  items  in  chronological
     order.  The item are first compressed into a 24 character string to allow comparison for a gre-
     ater than or less than evaluation.  Then sorted, then expanded and placed back  into  the  main
     file.
                                            Calls:      SORTFILE
                                                        WRITE-LINK-LIST-TO-MAIN-DATAFILE
                                            Called by:  MERGE
                                            Nests:      SORT-FILE
                                                        WRITE-LINK-LIST-TO-MAIN-DATAFILE
                                            Nested w/i: MERGE

                                                   *)

TYPE 
     SORTDATA = RECORD
                   UNIT : STRING24;
                   MESSAGE : STRING24;
                   LINK : ^SORTDATA
                END;  (* SORTDATA *)

VAR 
    SORT_HEAD,
    SORT_POINTER,
    SORT_FOLLOW,
    SORT_NEW_POINTER : ^SORTDATA;
    SORT_ENTRY : DATAREC;
    TEMPFILE : TEXT;
    I,
    J : INTEGER;
    MESSAGE,
    UNIT : STRING24;

PROCEDURE SORT_FILE;






                                                   (*

     Procedure SORT-FILE compresses the MAINDATA file into a string of 24 characters to  allow  com-
     parison  for chronological sorting.  It then compares the entries and places them in the proper
     chronological order.

                                            Call:      None
                                            Called by:  SORT-MAIN-DATAFILE
                                            Nests:      None
                                            Nested w/i: SORT-MAIN-DATAFILE

                                                   *)
BEGIN  (* SORT_FILE *)
   SORT_ENTRY := MAINDATA^;
   GET(MAINDATA);
   WITH SORT_ENTRY DO
      BEGIN  (* TO COMPRESS SORT_ENTRY INTO A 24 CHARACTER STRING *)
         FOR I := 1 TO 4 DO  (* PLACE YEAR FIRST IN THE 24 CHARACTER STRING *)
            SORT_NEW_POINTER^.UNIT[I] := YEAR[I];
         J := 1;
         FOR I := 5 TO 6 DO  (* PLACE MONTH SECOND *)
            BEGIN
               SORT_NEW_POINTER^.UNIT[I] := MONTH[J];
               J := J + 1;
            END;  (* FOR *)
         J := 1;
         FOR I := 7 TO 8 DO  (* PLACE DAY THIRD *)
            BEGIN
               SORT_NEW_POINTER^.UNIT[I] := DAY[J];
               J := J + 1;
            END;  (* FOR *)
         J := 1;
         FOR I := 9 TO 12 DO  (* PLACE TIME LAST *)
            BEGIN
               SORT_NEW_POINTER^.UNIT[I] := TIME[J];
               J := J + 1;
            END;  (* FOR *)
                                                       (*
MAINTAIN MESSAGE WITH THE ENTRIES FOR LATER EXPANSION 
                                                        *)

         SORT_NEW_POINTER^.MESSAGE := MESSAGE;
         SORT_NEW_POINTER^.LINK := NIL;
         UNIT := SORT_NEW_POINTER^.UNIT;
         SORT_POINTER := SORT_HEAD;
         SORT_FOLLOW := SORT_HEAD;
         IF (SORT_HEAD <> SORT_NEW_POINTER)
            THEN
               BEGIN
                  WHILE (SORT_POINTER^.LINK <> NIL)
                        AND (SORT_POINTER^.UNIT < UNIT) DO
                     BEGIN
                        SORT_FOLLOW := SORT_POINTER;
                        SORT_POINTER := SORT_POINTER^.LINK
                     END;
                  IF (SORT_POINTER <> SORT_HEAD)
                     THEN
                        IF (SORT_POINTER^.UNIT < UNIT)
                           THEN
                              SORT_POINTER^.LINK := SORT_NEW_POINTER
                           ELSE
                              BEGIN
                                 SORT_FOLLOW^.LINK := SORT_NEW_POINTER;
                                 SORT_NEW_POINTER^.LINK := SORT_POINTER
                              END
                     ELSE
                        IF (SORT_POINTER^.UNIT < UNIT)
                           THEN
                              SORT_POINTER^.LINK := SORT_NEW_POINTER
                           ELSE
                              BEGIN
                                 SORT_HEAD := SORT_NEW_POINTER;
                                 SORT_NEW_POINTER^.LINK := SORT_POINTER
                              END
               END
      END;
   NEW(SORT_NEW_POINTER)  (* CREATE NEXT RECORD *)
END; (* SORT_FILE *)

PROCEDURE WRITE_LINK_LIST_TO_MAIN_datafile;






                                                   (*

     Procedure WRITE-LINK-LIST-TO-MAIN-DATAFILE expands the sorted items into the DATAREC  form  and
     rewrites MANIDATA with these items.

                                            Calls:      None
                                            Called by:  SORT-MAIN-DATAFILE
                                            Nests:      None
                                            Nested w/i: SORT-MAIN-DATAFILE

                                                   *)
BEGIN
   rewrite(TEMPFILE);
   SORT_POINTER := SORT_HEAD;
   WHILE (SORT_POINTER <> NIL) DO
      BEGIN
         WRITELN(TEMPFILE,SORT_POINTER^.UNIT,SORT_POINTER^.MESSAGE);
         SORT_POINTER := SORT_POINTER^.LINK
      END;  (* WHILE *)
   RESET(TEMPFILE);
   rewrite(MAINDATA);
   WHILE NOT EOF(TEMPFILE) DO
      BEGIN  (* EXPAND SORTED DATA INTO MONTH, DAY, YEAR, AND MESSAGE *)
         READLN(TEMPFILE,UNIT,MESSAGE);
         FOR I := 1 TO 4 DO  (* EXPAND YEAR *)
            SORT_ENTRY.YEAR[I] := UNIT[I];
         J := 1;
         FOR I := 5 TO 6 DO
            BEGIN  (* EXPAND MONTH *)
               SORT_ENTRY.MONTH[J] := UNIT[I];
               J := J + 1
            END;  (* FOR 5 TO 6 *)
         J := 1;
         FOR I := 7 TO 8 DO
            BEGIN  (* EXPAND DAY *)
               SORT_ENTRY.DAY[J] := UNIT[I];
               J := J + 1
            END;  (* FOR 7 TO 8 *)
         J := 1;
         FOR I := 9 TO 12 DO
            BEGIN  (* EXPAND TIME *)
               SORT_ENTRY.TIME[J] := UNIT[I];
               J := J + 1
            END;  (* FOR 9 TO 12 *)
         SORT_ENTRY.MESSAGE := MESSAGE;
         MAINDATA^ := SORT_ENTRY;
         PUT(MAINDATA);
      END  (* WHILE NOT EOF TEMPFILE *)
END; (* WRITE_LINK_LIST_TO_MAIN_DATAFILE *)





BEGIN  (*  SORT_MAIN_DATAFILE *)
   RESET(MAINDATA);
   NEW(SORT_NEW_POINTER);  (* CREATE FIRST RECORD *)
   SORT_HEAD := SORT_NEW_POINTER;
   WHILE NOT EOF(MAINDATA) DO
      BEGIN  (* COMPRESS AND SORT ENTRY *)
         SORT_FILE
      END;  (* WHILE NOT EOF MAINDATA *)
   WRITE_LINK_LIST_TO_MAIN_DATAFILE
END;  (* SORT_MAIN_DATAFILE *)

PROCEDURE COUNT_TOTAL_NUMBER_OF_ENTRIES;






                                                   (*

     Procedure COUNT-TOTAL-NUMBER-OF-ENTRIES attaches a count to the  sorted  entries  dependent  on
     there  position within the file.  The greater the date, the larger the count.  This is required
     for simplified testing in the THEN-CHANGE-DATAFILE block.

                                            Calls:      None
                                            Called by:  MERGE
                                            Nests:      None
                                            Nested w/i: MERGE

                                                   *)

VAR 
    NUMBER_OF_ENTRIES : INTEGER;
    ONE_COUNT_ENTRY : DATAREC;
    TEMPFILE : FILE OF DATAREC;
BEGIN  (* COUNT_TOTAL_NUMBER_OF_ENTRIES *)
   RESET(MAINDATA);
   rewrite(TEMPFILE);
   NUMBER_OF_ENTRIES := 0;
   WHILE NOT EOF(MAINDATA) DO
      BEGIN  (* TO COUNT ENTRIES AND PLACE THEM INTO A SCRATCH FILE *)
         ONE_COUNT_ENTRY := MAINDATA^;
         GET(MAINDATA);
         NUMBER_OF_ENTRIES := SUCC(NUMBER_OF_ENTRIES);
         ONE_COUNT_ENTRY.COUNT := NUMBER_OF_ENTRIES;
         TEMPFILE^ := ONE_COUNT_ENTRY;
         PUT(TEMPFILE);
      END;  (* WHILE NOT EOF MAINDATA *)
   RESET(TEMPFILE);
   rewrite(MAINDATA);
   WHILE NOT EOF(TEMPFILE) DO
      BEGIN  (* WRITE ENTRIES WITH COUNT TO MAINDATA *)
         MAINDATA^ := TEMPFILE^;
         GET(TEMPFILE);
         PUT(MAINDATA);
      END  (* WHILE NOT EOF TEMPFILE *)
END;  (* COUNT_TOTAL_NUMBER_OF_ENTRIES *)





BEGIN  (* MERGE *)
   PRINT_WAIT_MESSAGE;
   MOVE_DATA_TO_SCRATCH_FILE;
   MOVE_SCRATCH_FILE_TO_MAIN_FILE;
   SORT_MAIN_DATAFILE;
   COUNT_TOTAL_NUMBER_OF_ENTRIES
END; (* MERGE *)





BEGIN (* DATAENTRY *)
   rewrite(CURENTRY);
REPEAT (* VT FIX *)
   CLEAR_THE_SCREEN;
   SEVERAL_TIMES := FALSE;
   DONE := FALSE;
   INSTRUCTIONS := TRUE;
      WITH ONE_APPOINTMENT_ENTRY DO
         BEGIN  (* TO ENTER DATES AND MESSAGES *)
            EXIT_INSTRUCTIONS;
            PRINT_DEFAULT_DATES;
            IF SEVERAL_TIMES
               THEN  (* USER HAS ELECTED TO ENTER SEVERAL TIMES ON THE SAME DAY *)
                  PRINT_ENTRY_DATE(MONTH,DAY,YEAR);
            ENTER_TIME(TIME,DONE);
            IF NOT DONE AND NOT SEVERAL_TIMES
               THEN
                  ENTER_MONTH(MONTH,DONE);
            IF NOT DONE AND NOT SEVERAL_TIMES
               THEN
                  ENTER_DAY(DAY,DONE);
            IF NOT DONE AND NOT SEVERAL_TIMES
               THEN
                  ENTER_YEAR(YEAR,DONE);
            IF NOT DONE AND NOT SEVERAL_TIMES
               THEN
                  CORRECT_MAX_DAYS(MONTH,DAY,YEAR,DONE);
            IF NOT DONE
               THEN
                  ENTER_MESSAGE(MESSAGE);
            IF NOT DONE AND INSTRUCTIONS
               THEN
                  GIVE_OPTION(INSTRUCTIONS,SEVERAL_TIMES);
         END;(*WITH ONE_APPOINTMENT_ENTRY DO*)
      IF NOT DONE
         THEN
            BEGIN  (* WRITE CURRENT ENTER TO SCRATCH FILE FOR A LATER MERGE *)
               CURENTRY^ := ONE_APPOINTMENT_ENTRY;
               PUT(CURENTRY);
            END;  (* IF NOT DONE *)
   UNTIL DONE;
   MERGE
END;(* DATENTRY *)










BEGIN  (* THEN_DATA_ENTRY *)
   CLEAR_THE_SCREEN;
   DATAENTRY;
   RETURN_TO_MAIN_PROGRAM
END; (* THEN_DATA_ENTRY *)

(**)
                                                    (*

                          $$$$$$$$$$$$$$$$$$$$ DAY DISPLAY $$$$$$$$$$$$$$$$$$$$

                                                    *)










PROCEDURE THEN_DISPLAY_DAY_CALENDAR;






                                                    (*

     Procedure THEN-DISPLAY-DAY-CALENDAR acts as the coordinator for the daily calendar display.

                                            Calls:      DRAW-DAY-OUTLINE
                                                        DISPLAY-DAY-CALENDAR
                                                        PRINT-DEFAULT-DATES
                                                        PRINT-DAY-OPTIONS
                                                        TRANSLATE
                                                        HELP-DISPLAY-DAY
                                                        HARD-COPY-DAY
                                                        ENTER-NEW-DATE
                                                        COMPUTE-PRIOR-DAY-OR-MONTH
                                                        COMPUTE-NEXT-DAY-OR-MONTH
                                                        QUICK-LOOK-AT-NEXT-WEEK
                                                        RETURN-FROM-DISPLAY-DAY
                                                        PRINT-OPTIONS-WARNING
                                            Called by:  Main
                                            Nests:      PRINT-DAY-OPTIONS
                                                        DRAW-DAY-OUTLINE
                                                        DISPLAY-DAY-CALENDAR
                                                        QUICK-LOOK-AT-NEXT-WEEK
                                                        ENTER-NEW-DATE
                                                        HARD-COPY-DAY
                                                        HELP-DAY-DISPLAY
                                                        RETURN-FROM-DAY-DISPLAY-ETC
                                            Nested w/i: Main

                                                    *)


VAR 
    TOO_HIGH_DAY,
    TOO_LOW_DAY,
    RETURN : BOOLEAN;

PROCEDURE PRINT_DAY_OPTIONS;






                                                    (*

     Procedure PRINT-DAY-OPTIONS displays the options available for user selection at this level.

                                            Calls:      SET-UP-THE-FORE-GROUND
                                                        GOTOXY
                                                        SET-UP-THE-BACK-GROUND
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)
BEGIN  (* PRINT_DAY_OPTIONS *)
   SET_UP_THE_FORE_GROUND(37,7);
   WRITELN('A');
   GOTOXY(37,8);
   WRITELN(' ');
   GOTOXY(37,9);
   WRITELN('P');
   GOTOXY(37,10);
   WRITELN('Q');
   GOTOXY(37,11);
   WRITELN('R');
   GOTOXY(37,12);
   WRITELN('HARD');
   GOTOXY(37,13);
   WRITELN('HELP');
   GOTOXY(57,9);
   WRITELN('(____)');
   SET_UP_THE_BACK_GROUND(38,7);
   WRITELN(')nother day');
   GOTOXY(38,8);
   WRITELN(')next day');
   GOTOXY(38,9);
   WRITELN(')rior day');
   GOTOXY(38,10);
   WRITELN(')uick look');
   GOTOXY(38,11);
   WRITELN(')eturn to program');
   GOTOXY(41,12);
   WRITELN(' copy');
   GOTOXY(58,9)
END;  (* PRINT_DAY_OPTIONS *)

PROCEDURE DRAW_DAY_OUTLINE;






                                                    (*
     Procedure DRAW-DAY-OUTLINE prints the box that appointments appear in.

                                            Calls:      CLEAR-THE-SCREEN
                                                        SET-UP-THE-BACK-GROUND
                                            Called by:  QUICK-LOOK-AT-NEXT-WEEK
                                                        ENTER-NEW-DATE
                                                        HELP-DAY-DISPLAY
                                                        THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)

CONST 
      VERTICAL_DIVISIONS = 
                           '|                                |';
      HORIZONTAL_DIVISIONS = 
                             '|--------------------------------|';
      BLANK = ' ';

VAR 
    I : INTEGER;
BEGIN  (* DRAW_DAY_OUTLINE *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,22);
   FOR I := 1 TO 50 DO  (* START THE OUTLINE AT THE BOTTOM OF THE SCREEN *)
      WRITELN;
   WRITELN(BLANK,BLANK,HORIZONTAL_DIVISIONS);
   FOR I := 1 TO 20 DO
      WRITELN(BLANK,BLANK,VERTICAL_DIVISIONS);
   WRITELN(BLANK,BLANK,HORIZONTAL_DIVISIONS);
END;  (* DRAW_DAY_OUTLINE *)

PROCEDURE DISPLAY_DAY_CALENDAR(ADAY,AMONTH : STRING2;AYEAR : STRING4;
                               QUICK_LOOK : BOOLEAN);






                                                    (*

     Procedure DISPLAY-DAY-CALENDAR takes the passed in day, month, and year  and  searches  through
     the datafile for a match on that particular date.  It also displays the passed date and any re-
     lated items.

                                            Calls:      SET-UP-THE-FORE-GROUND
                                                        PRINT-MONTH
                                                        PRINT-DAY
                                                        PRINT-HARD-DAY-HEADING
                                                        QUERY-FOR-MORE
                                                        GOTOXY
                                            Called by:  QUICK-LOOK-AT-NEXT-WEEK
                                                        THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      PRINT-HARD-DAY-HEADING
                                                        QUERY-FOR-MORE
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)

VAR 
    ONE_PRINT_ENTRY : DATAREC;
    I,
    J,
    LINE_COUNT : INTEGER;
    LAST_TIME : STRING4;
    PRINT_THIS_MONTH,
    PRINT_THIS_DAY : STRING12;

PROCEDURE PRINT_HARD_DAY_HEADING(DAY : STRING2;
                                 YEAR  : STRING4;
                                 MONTH,
                                 DAY_OF_WEEK : STRING12);






                                                    (*

     Procedure PRINT-HARD-DAY-HEADING assigns the current values of the date to the heading  portion
     of the array HARD-DAY.  

                                            Calls:      None
                                            Called by:  DISPLAY-DAY-CALENDAR
                                                        QUERY-FOR-MORE
                                            Nests:      None
                                            Nested w/i: DISPLAY-DAY-CALENDAR

                                                    *)

VAR 
    I : INTEGER;
BEGIN  (* PRINT_HARD_DAY_HEADING *)
   FOR I := 1 TO 3 DO  (* SPACE 3 PLACES TO THE RIGHT *)
      HARD_DAY[1,I] := ' ';
   FOR I := 4 TO 5 DO  (* WRITE DAY AT TOP 1 CHARACTER AT A TIME *)
      HARD_DAY[1,I] := DAY[I - 3];
   FOR I := 6 TO 17 DO  (* WRITE MONTH AT TOP 1 CHARACTER AT A TIME *)
      HARD_DAY[1,I] := MONTH[I - 5];
   FOR I := 18 TO 21 DO  (* WRITE YEAR AT TOP 1 CHARACTER AT A TIME *)
      HARD_DAY[1,I] := YEAR[I - 17];
   FOR I := 22 TO 33 DO  (* PRINT THE DAY OF THE WEEK AT TOP *)
      HARD_DAY[1,I] := DAY_OF_WEEK[I - 21];
END;  (* PRINT_HARD_DAY_HEADING *)

PROCEDURE QUERY_FOR_MORE;






                                                   (*

     Procedure QUERY-FOR-MORE allows the user the option of viewing any appointments that  have  not
     been displayed because the number of appointments scheduled for that day are greater than 20.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        GOTOXY
                                                        QUERY
                                                        CLEAR-TO-END-OF-LINE
                                            Called by:  DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: DISPLAY-DAY-CALENDAR

                                                   *)

VAR 
    MORE : BOOLEAN;
BEGIN  (* QUERY_FOR_MORE *)
   SET_UP_THE_BACK_GROUND(37,3);
   IF NOT QUICK_LOOK  (* THIS IF ALLOWS THE PROGRAM TO BY-PASS THIS CODE IF THE QUICK_LOOK OPTION IS USED *)
      THEN  (* ASK USER IF HE WOULD LIKE TO SEE ADDITIONAL ENTRIES *)
         BEGIN  (* QUESTION SEQUENCE *)
            WRITELN('There are more appointments for this date.');
            GOTOXY(37,4);
            WRITELN('Do you want those displayed? <Y> OR <N>');
            QUERY(MORE);
            CLEAR_TO_END_OF_LINE(37,3);
            CLEAR_TO_END_OF_LINE(37,4);
         END  (* IF NOT QUICK LOOK *)
      ELSE  (* ASSIGN MORE THE VALUE OF TRUE AND DISPLAY THE OTHER ENTRIES *)
         MORE := TRUE;
   IF MORE
      THEN
         BEGIN  (* TO DISPLAY THOSE ENTRIES REMAINING *)
            LINE_COUNT := 2;
            DRAW_DAY_OUTLINE;
            SET_UP_THE_FORE_GROUND(4,0);
            WRITELN(ADAY,PRINT_THIS_MONTH,AYEAR,PRINT_THIS_DAY);
            PRINT_HARD_DAY_HEADING(ADAY,AYEAR,PRINT_THIS_MONTH,PRINT_THIS_DAY);
         END  (* IF MORE *)
      ELSE  (* ASSIGN A VALUE TO AYEAR THAT WILL BY-PASS QUERY_FOR_MORE IN THE MAIN PROCEDURE *)
         AYEAR := '0000';
END;  (* QUERY_FOR_MORE *)





BEGIN  (* DISPLAY_DAY_CALENDAR *)
   RESET(MAINDATA);
   LINE_COUNT := 2;
   SET_UP_THE_FORE_GROUND(4,0);
   PRINT_MONTH(AMONTH,PRINT_THIS_MONTH);
   PRINT_DAY(AMONTH,ADAY,AYEAR,PRINT_THIS_DAY);
   WRITELN(ADAY,PRINT_THIS_MONTH,AYEAR,PRINT_THIS_DAY);
   PRINT_HARD_DAY_HEADING(ADAY,AYEAR,PRINT_THIS_MONTH,PRINT_THIS_DAY);
   LAST_TIME := '0000';
   WHILE NOT EOF(MAINDATA) DO
      BEGIN  (* SEARCH THROUGH MAINDATA FOR POSSIBLE MATCH *)
         ONE_PRINT_ENTRY := MAINDATA^;
         GET(MAINDATA);
         IF (LINE_COUNT = 22) AND (ONE_PRINT_ENTRY.YEAR = AYEAR)
            THEN  (* THERE ARE MORE ENTRIES FOR THIS DAY *)
               QUERY_FOR_MORE;
         WITH ONE_PRINT_ENTRY DO
            BEGIN  (* TO TEST FOR MATCH *)
               IF (YEAR = AYEAR) AND (MONTH = AMONTH) AND (DAY = ADAY)
                  THEN  (* A MATCH HAS BEEN FOUND *)
                     BEGIN  (* TO PRINT THE MATCH *)
                        SET_UP_THE_FORE_GROUND(4,LINE_COUNT);
                        IF (TIME = LAST_TIME)
                           THEN  (* PRINT A STAR TO INDICATE CONCURRENT APPOINTMENTS *)
                              BEGIN
                                 WRITELN('*');
                                 HARD_DAY[LINE_COUNT + 1,3] := '*'
                              END  (* IF TIME = LAST_TIME *)
                           ELSE  (* PRINT A BLANK *)
                              BEGIN
                                 WRITELN(' ');
                                 HARD_DAY[LINE_COUNT + 1,3] := ' ';
                              END;  (* ELSE *)
                        LAST_TIME := TIME;
                        WRITELN(TIME,' ',MESSAGE);
                        FOR I := 4 TO 7 DO  (* WRITE TIME TO ARRAY *)
                           HARD_DAY[LINE_COUNT + 1,I] := TIME[I - 3];
                        FOR I := 9 TO 32 DO  (* WRITE MESSAGE TO ARRAY *)
                           HARD_DAY[LINE_COUNT + 1,I] := MESSAGE[I - 8];
                                                  (*
THIS CODE PREVENTS CHARACTERS FROM EXCEEDING 257
                        GOTOXY(34,34);
                        WRITELN(OUTPUT);   VT FIX *)
                        LINE_COUNT := SUCC(LINE_COUNT)
                     END  (* IF MATCH IS FOUND *)
            END;  (* WITH ONE_PRINT_ENTRY *)
      END;  (* WHILE NOT EOF MAINDATA *)
   IF (LINE_COUNT < 22)
      THEN  (* ERASE UNUSED LINE OF THE ARRAY HARD_DAY *)
         FOR I := LINE_COUNT + 1 TO 22 DO
            FOR J := 2 TO 32 DO
               HARD_DAY[I,J] := ' ';
END;  (* DISPLAY_DAY_CALENDAR *)


PROCEDURE QUICK_LOOK_AT_NEXT_WEEK;






                                                    (*

     Procedure QUICK-LOOK-AT-NEXT-WEEK allows the user to view the next 12 months in very quick pro-
     gression.   The upper parameter of 9999 for year will cause a warning to be printed.In order to
     prevent this warning from being printed repeatly the boolean PAST-LIMIT is included to cause  a
     by pass if its value is TRUE.

                                            Calls:      COMPUTE-NEXT-DAY-OR-MONTH
                                                        DISPLAY-DAY-CALENDAR
                                                        DRAW-MONTH-OUTLINE
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)

VAR 
    PAST_LIMIT : BOOLEAN;
    I : INTEGER;
BEGIN  (* QUICK_LOOK_AT_NEXT_WEEK *)
   I := 0;
   REPEAT
      I := SUCC(I);
      COMPUTE_NEXT_DAY_OR_MONTH(PAST_LIMIT,TRUE);
      IF NOT PAST_LIMIT
         THEN
            DISPLAY_DAY_CALENDAR(THEDAY,THEMONTH,THEYEAR,TRUE);
   UNTIL (I > 6) OR (PAST_LIMIT);
   IF PAST_LIMIT
      THEN
         DRAW_DAY_OUTLINE;
END;  (* QUICK_LOOK_AT_NEXT_WEEK *)

PROCEDURE ENTER_NEW_DATE;






                                                    (*

     Procedure ENTER-NEW-DATE allows the user to enter another date to be display in the day format.

                                            Calls:      CLEAR-THE-SCREEN
                                                        EXIT-INSTRUCTIONS
                                                        PRINT-DEFAULT-DATES
                                                        SET-UP-THE-BACK-GROUND
                                                        ENTER-MONTH
                                                        ENTER-DAY
                                                        ENTER-YEAR
                                                        DRAW-DAY-OUTLINE
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)

VAR 
    DAY,
    MONTH : STRING2;
    YEAR : STRING4;
    DONE : BOOLEAN;
BEGIN  (* ENTER_NEW_DATE *)
   CLEAR_THE_SCREEN;
   EXIT_INSTRUCTIONS;
   PRINT_DEFAULT_DATES;
   SET_UP_THE_BACK_GROUND(0,2);
   ENTER_MONTH(MONTH,DONE);
   IF NOT DONE
      THEN
         ENTER_DAY(DAY,DONE);
   IF NOT DONE
      THEN
         ENTER_YEAR(YEAR,DONE);
   IF NOT DONE
      THEN
         CORRECT_MAX_DAYS(MONTH,DAY,YEAR,DONE);
   IF NOT DONE
      THEN
         BEGIN
            THEMONTH := MONTH;
            THEDAY := DAY;
            THEYEAR := YEAR;
         END;  (* IF *)
   CLEAR_THE_SCREEN;
   DRAW_DAY_OUTLINE;
END;  (* ENTER_NEW_DATE *)

PROCEDURE HARD_COPY_DAY;






                                                    (*

     Procedure HARD-COPY-DAY writes the current value of  HARD-DAY(i.e.the  current  display)to  the
     output file HARDCOPY.DAT.

                                            Calls:      None
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)

CONST 
      MOVE_TO_CENTER = 
                       '                                                   ';

VAR 
    I,
    J : INTEGER;
BEGIN  (* HARD_COPY_DAY *)
   PAGE(HARDCOPY);
   FOR I := 1 TO 13 DO
      WRITELN(HARDCOPY);
   WRITELN(HARDCOPY,MOVE_TO_CENTER,HEADER_ONE);
   WRITELN(HARDCOPY,MOVE_TO_CENTER,HEADER_TWO);
   WRITELN(HARDCOPY,MOVE_TO_CENTER,HEADER_THREE);
   FOR I := 1 TO 4 DO
      WRITELN(HARDCOPY);
   FOR I := 1 TO 23 DO
      BEGIN
         WRITELN(HARDCOPY,MOVE_TO_CENTER);
         FOR J := 1 TO 33 DO
            WRITELN(HARDCOPY,HARD_DAY[I,J]);
         WRITELN(HARDCOPY);
      END;  (* FOR 1 TO 23 *)
END;  (* HARD_COPY_DAY *)

PROCEDURE HELP_DAY_DISPLAY;






                                                    (*

     Procedure HELP-DAY-DISPLAY allows access to the procedure HELP at this level.

                                            Calls:      HELP
                                                        DRAW-DAY-OUTLINE
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)

VAR 
    MORE : BOOLEAN;
BEGIN  (* HELP_DAY_DISPLAY *)
   MORE := TRUE;
   REPEAT
      HELP(MORE,3);
   UNTIL NOT MORE;
   DRAW_DAY_OUTLINE;
END;  (* HELP_DAY_DISPLAY *)

PROCEDURE RETURN_FROM_DISPLAY_DAY_CALENDAR_TO_MAIN_PROGRAM;






                                                    (*

     Procedure THEN-RETURN-FROM-DISPLAY-DAY-CALENDAR-TO-MAIN-PROGRAM is a long way to say  that  the
     user  is  done with the day format and would like to do something else.This procedure assigns a
     value of TRUE to RETURN, which allows exit from the REPEAT statement.

                                            Calls:      RETURN-TO-MAIN-PROGRAM
                                            Called by:  THEN-DISPLAY-DAY-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-DAY-CALENDAR

                                                    *)
BEGIN (* RETURN_FROM_DISPLAY_DAY_CALENDAR_TO_MAIN_PROGRAM *)
   RETURN := TRUE;
   RETURN_TO_MAIN_PROGRAM
END;  (* RETURN_FROM_DISPLAY_DAY_CALENDAR_TO_MAIN_PROGRAM *)










BEGIN  (* THEN_DISPLAY_DAY_CALENDAR *)
   TOO_LOW_DAY := FALSE;
   TOO_HIGH_DAY := FALSE;
   RETURN := FALSE;
   REQUEST := 0;
   repeat (* VT FIX *)
   DRAW_DAY_OUTLINE;
      IF (REQUEST <> 5)  (* THIS IF PREVENTS QUERY_FOR_MORE IF > 20 APPOINTMENTS ARE SCHEDULED FOR A DAY *)
         THEN
            DISPLAY_DAY_CALENDAR(THEDAY,THEMONTH,THEYEAR,FALSE);
      PRINT_DEFAULT_DATES;
      PRINT_DAY_OPTIONS;
      READLN(SELECTION);
      REQUEST := TRANSLATE(SELECTION);
      CASE REQUEST OF
         4 : HELP_DAY_DISPLAY;
         5 : HARD_COPY_DAY;
         8 : ENTER_NEW_DATE;
         7 : BEGIN
                COMPUTE_PRIOR_DAY_OR_MONTH(TOO_LOW_DAY,TRUE);
                IF TOO_LOW_DAY
                   THEN
                      DRAW_DAY_OUTLINE;
             END;
         12 : BEGIN
                 COMPUTE_NEXT_DAY_OR_MONTH(TOO_HIGH_DAY,TRUE);
                 IF TOO_HIGH_DAY
                    THEN
                       DRAW_DAY_OUTLINE;
              END;
         13 : QUICK_LOOK_AT_NEXT_WEEK;
         11 : RETURN_FROM_DISPLAY_DAY_CALENDAR_TO_MAIN_PROGRAM
              OTHERWISE PRINT_OPTIONS_WARNING(SELECTION,37,14,58,9);
      END;  (* CASE REQUEST OF *)
   UNTIL RETURN
END;  (* THEN_DISPLAY_DAY_CALENDAR *)
(**)
                                                   (*

                         $$$$$$$$$$$$$$$$$$$$ MONTH DISPLAY $$$$$$$$$$$$$$$$$$$$

                                                   *)










PROCEDURE THEN_DISPLAY_MONTH_CALENDAR;






                                                   (*

     Procedure THEN-DISPLAY-MONTH-CALENDAR acts as the coordinator for the monthly calendar display.

                                            Calls:      DRAW-MONTH-OUTLINE
                                                        DISPLAY-MONTH-CALENDAR
                                                        PRINT-DEFAULT-DATES
                                                        PRINT-MONTH-OPTIONS
                                                        TRANSLATE
                                                        HELP-DISPLAY-MONTH
                                                        HARD-COPY-MONTH
                                                        ENTER-NEW-DATE
                                                        COMPUTE-PRIOR-DAY-OR-MONTH
                                                        COMPUTE-NEXT-DAY-OR-MONTH
                                                        QUICK-LOOK-AT-12-MONTHS
                                                        RETURN-FROM-DISPLAY-MONTH
                                                        PRINT-OPTIONS-WARNING
                                            Called by:  Main
                                            Nests:      PRINT-MONTH-OPTIONS
                                                        DRAW-MONTH-OUTLINE
                                                        DISPLAY-MONTH-CALENDAR
                                                        QUICK-LOOK-AT-12-MONTHS
                                                        ENTER-NEW-DATE
                                                        HARD-COPY-MONTH
                                                        HELP-MONTH-DISPLAY
                                                        RETURN-FROM-MONTH-DISPLAY-ETC
                                            Nested w/i: Main

                                                   *)

VAR 
    TOO_HIGH_MONTH,
    TOO_LOW_MONTH,
    RETURN : BOOLEAN;

PROCEDURE PRINT_MONTH_OPTIONS;






                                                   (*

     Procedure PRINT-MONTH-OPTIONS displays the options available for user selection at this level.

                                            Calls:      SET-UP-THE-FORE-GROUND
                                                        GOTOXY
                                                        SET-UP-THE-BACK-GROUND
                                            Called by:  THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)
BEGIN  (* PRINT_MONTH_OPTIONS *)
   SET_UP_THE_FORE_GROUND(67,7);
   WRITELN('A');
   GOTOXY(67,9);
   WRITELN('P');
   GOTOXY(67,10);
   WRITELN('Q');
   GOTOXY(67,11);
   WRITELN('R');
   GOTOXY(67,12);
   WRITELN('HARD');
   GOTOXY(67,13);
   WRITELN('HELP');
   GOTOXY(67,15);
   WRITELN('(____)');
   SET_UP_THE_BACK_GROUND(68,7);
   WRITELN(')nother date');
   GOTOXY(68,8);
   WRITELN(')next month');
   GOTOXY(68,9);
   WRITELN(')rior month');
   GOTOXY(68,10);
   WRITELN(')uick look');
   GOTOXY(68,11);
   WRITELN(')eturn');
   GOTOXY(71,12);
   WRITELN(' copy');
   GOTOXY(68,15);
END;  (* PRINT_MONTH_OPTIONS *)

PROCEDURE CONVERT_TO_CHARACTERS(NUUMBERS : INTEGER;
                                VAR CHHARACTERS : STRING2);






                                                   (*

     Procedure CONVERT-TO-CHARACTERS converts the various integer values to characters in order that
     they can be written to the array HARD-MONTH.

                                            Calls:      None
                                            Called by:  COUNT-APPOINTMENTS
                                                        DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)
BEGIN  (* CONVERT_TO_CHARACTERS *)
   CHHARACTERS[1] := CHR(NUUMBERS DIV 10 + 48);
   CHHARACTERS[2] := CHR(NUUMBERS MOD 10 + 48);
END;  (* CONVERT_TO_CHARACTER *)

PROCEDURE DRAW_MONTH_OUTLINE;






                                                   (*

     Procedure DRAW-MONTH-OUTLINE prints the box that days appear in.

                                            Calls:      CLEAR-THE-SCREEN
                                                        SET-UP-THE-BACK-GROUND
                                            Called by:  QUICK-LOOK-AT-12-MONTHS
                                                        ENTER-NEW-DATE
                                                        HELP-MONTH-DISPLAY
                                                        THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)

CONST 
      VERTDIVS = 
                 '|        |        |        |        |        |        |        |'
      ;
      HORZDIVS = 
                 '|--------|--------|--------|--------|--------|--------|--------|'
      ;
      DAYS = '   Sun      Mon      Tue      Wed      Thu       Fri      Sat ';
      BLANK = ' ';

VAR 
    I,
    J : INTEGER;
BEGIN  (* DRAW_MONTH_OUTLINE *)
   CLEAR_THE_SCREEN;
   SET_UP_THE_BACK_GROUND(0,22);
   WRITELN;
   WRITELN(BLANK,BLANK,DAYS);
   WRITELN;
   WRITELN(BLANK,BLANK,HORZDIVS);
   FOR I := 1 TO 6 DO
      BEGIN  (* TO WRITE OUT 6 LINES OF BLOCKS *)
         FOR J := 1 TO 2 DO
            WRITELN(BLANK,BLANK,VERTDIVS);
         WRITELN(BLANK,BLANK,HORZDIVS)
      END;  (* FOR 1 TO 6 *)
   WRITELN;
END;  (* DRAW_MONTH_OUTLINE *)

PROCEDURE DISPLAY_MONTH_CALENDAR(MONTH : STRING2; YEAR : STRING4);






                                                   (*

     Procedure DISPLAY-MONTH-CALENDAR takes the passed in month and year and  searches  through  the
     datafile for a match on that particular date.  It also displays the passed date and any related
     items.

                                            Calls:      SET-UP-THE-FORE-GROUND
                                                        PRINT-MONTH
                                                        CLEAR-UP-ARRAY
                                                        GET-FIRST-DAY
                                                        MAX-DAYS-IN-MONTH
                                                        CONVERT-TO-CHARACTERS
                                                        COUNT-APPOINTMENTS
                                                        GOTOXY
                                            Called by:  QUICK-LOOK-AT-12-MONTHS
                                                        THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      CLEAR-UP-ARRAY
                                                        COUNT-APPOINTMENTS
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)

CONST 
      X_START = 3;
      Y_START = 5;
      OFF_SET = 9;

VAR 
    START_DAY,
    J,
    K : INTEGER;
    DAY_AS_CHARACTERS : STRING2;
    PRINT_THIS_MONTH : STRING12;

PROCEDURE CLEAR_UP_ARRAY;






                                                   (*

     Procedure CLEAR-UP-ARRAY insures that there are no characters remaining in the array HARD-MONTH
     once a different month has been selected.

                                            Calls:      None
                                            Called by:  DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: DISPLAY-MONTH-CALENDAR

                                                   *)

VAR 
    G,
    H,
    I,
    J,
    K,
    L : INTEGER;
BEGIN  (* CLEAR_UP_ARRAY *)
   K := 5;
   L := 8;
   FOR G := 1 TO 6 DO
      BEGIN
         FOR H := 1 TO 2 DO
            BEGIN
               FOR I := 1 TO 2 DO
                  BEGIN
                     FOR J := 1 TO 7 DO
                        BEGIN
                           HARD_MONTH[K,L] := ' ';
                           L := L + 9;
                        END;
                     L := 9;
                  END;
               K := K + 1;
               L := 8;
            END;
         K := K + 1;
      END;
END; (* CLEAR_UP_ARRAY *)

PROCEDURE COUNT_APPOINTMENTS(AMONTH : STRING2; AYEAR : STRING4);






                                                   (*

     Procedure COUNT-APPOINTMENTS counts and prints the total number of appointments by the day  and
     by the month.

                                            Calls:      GET-FIRST-DAY
                                                        GOTOXY
                                                        CONVERT-TO-CHARACTERS
                                                        CONVERT-DAY
                                            Called by:  DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: DISPLAY-MONTH-CALENDAR

                                                   *)

VAR 
    I,
    J,
    K,
    FIRST_DAY,
    TOTAL_COUNT,
    PRINT_COUNT : INTEGER;
    ONE_COUNT_ENTRY : DATAREC;
    CHARACTERS,
    NEXT_DAY,
    LAST_ENTRY : STRING2;
    LAST_MONTH : STRING2;
    LAST_YEAR  : STRING4;
BEGIN  (* COUNT_APPOINTMENTS *)
   RESET(MAINDATA);
   TOTAL_COUNT := 0;
   PRINT_COUNT := 0;
   I := 2;
   K := 5;
   FIRST_DAY := GET_FIRST_DAY(AMONTH,AYEAR);
   WITH ONE_COUNT_ENTRY DO
      BEGIN  (* TO SEARCH FOR A MATCH *)
                                                         (*
THE FOLLOWING IF STATEMENT INSURES THAT THE PROGRAM
DOES NOT CRASH DUE TO AN EMPTY DATAFILE.
                                                         *)
         IF NOT EOF(MAINDATA)
            THEN
               REPEAT
                  ONE_COUNT_ENTRY := MAINDATA^;
                  GET(MAINDATA);
                  LAST_ENTRY := DAY;
                  NEXT_DAY := DAY;
               UNTIL (MONTH = AMONTH)
                     AND (YEAR = AYEAR)
                     OR EOF(MAINDATA);
         REPEAT
            WHILE (NEXT_DAY = LAST_ENTRY)
                  AND (MONTH = AMONTH)
                  AND (YEAR  = AYEAR)
                  AND  NOT EOF(MAINDATA) 
               DO
               BEGIN  (* TO INCRETE COUNT *)
                  TOTAL_COUNT := SUCC(TOTAL_COUNT);
                  PRINT_COUNT := SUCC(PRINT_COUNT);
                  ONE_COUNT_ENTRY := MAINDATA^;
                  GET(MAINDATA);
                  NEXT_DAY := DAY;
               END;  (* WHILE *)
                                                     (*
THE FOLLOWING IF STATEMENT INSURES THAT THE COUNT 
IS INCRETED TO ACCOUNT FOR THE LAST ENTRY OF  THE
DATAFILE, MAINDATA IF THE DATE IS STILL THE SAME.
                                                     *)
            IF (NEXT_DAY = LAST_ENTRY)
               AND (MONTH = AMONTH)
               AND (YEAR  = AYEAR)
               AND EOF(MAINDATA)
               THEN  (* INCRETE COUNT *)
                  BEGIN
                     TOTAL_COUNT := SUCC(TOTAL_COUNT);
                     PRINT_COUNT := SUCC(PRINT_COUNT);
                  END;  (* IF MATCH AND EOF *)
            FOR J := I TO CONVERT_DAY(LAST_ENTRY) DO
               BEGIN  (* TO DETERMINE ROW AND COLUMN TO PRINT CONT IN *)
                  IF (FIRST_DAY <> 6)
                     THEN  (* STAY ON CURRENT ROW *)
                        FIRST_DAY  :=  SUCC(FIRST_DAY)
                     ELSE
                        BEGIN  (* MOVE DOWN TO NEXT ROW *)
                           FIRST_DAY := 0;
                           K := K + 3
                        END  (* ELSE *)
               END;  (* IF *)
            IF (PRINT_COUNT = 0)
               THEN  (* ASSIGN A VALUE TO PRINT COUNT IN LOWER RIGHT HAND CORNER *)
                  BEGIN
                     FIRST_DAY := 6;
                     K := 20;
                  END; (* IF *)
            GOTOXY(X_START + FIRST_DAY * OFF_SET,K);
            WRITELN(PRINT_COUNT:8);
            CONVERT_TO_CHARACTERS(PRINT_COUNT,CHARACTERS);
            IF (CHARACTERS[1] <> '0')
               THEN  (* PRINT THE CHARACTER *)
                  HARD_MONTH[K+1,X_START + FIRST_DAY * OFF_SET+5] := 
                                                                     CHARACTERS[1];
            HARD_MONTH[K+1,X_START + FIRST_DAY * OFF_SET+6] := 
                                                               CHARACTERS[2];
            PRINT_COUNT := 0;
            I := CONVERT_DAY(LAST_ENTRY) + 1;
            LAST_ENTRY := DAY;
            IF (MONTH <> AMONTH) OR (YEAR <> AYEAR)
               THEN  (* READ TO EOF TO SAVE TIME *)
                  WHILE NOT EOF(MAINDATA) DO
                     BEGIN
                        ONE_COUNT_ENTRY := MAINDATA^;
                        GET(MAINDATA);
                     END;  (* WHILE NOT EOF *)
         UNTIL EOF(MAINDATA);
      END;  (* WITH *)
   GOTOXY(57,19);
   WRITELN('Total');
   HARD_MONTH[20,56] := 'T';
   HARD_MONTH[20,57] := 'o';
   HARD_MONTH[20,58] := 't';
   HARD_MONTH[20,59] := 'a';
   HARD_MONTH[20,60] := 'l';
   GOTOXY(57,20);
   WRITELN(TOTAL_COUNT:8);
   CONVERT_TO_CHARACTERS(TOTAL_COUNT,CHARACTERS);
   IF (CHARACTERS[1] <> '0')
      THEN  (* WRITE CHARACTER TO HARD_MONTH ARRAY *)
         HARD_MONTH[21,62] := CHARACTERS[1];
   HARD_MONTH[21,63] := CHARACTERS[2];
END;  (* COUNT_APPOINTMENTS *)





BEGIN  (* DISPLAY_MONTH_CALENDAR *)
   CLEAR_UP_ARRAY;
   START_DAY := GET_FIRST_DAY(MONTH,YEAR);
   PRINT_MONTH(MONTH,PRINT_THIS_MONTH);
   SET_UP_THE_FORE_GROUND(29,0);
   WRITELN(PRINT_THIS_MONTH,YEAR);
   FOR K := 28 TO 39 DO  (* WRITE MONTH TO HARD_MONTH ARRAY *)
      HARD_MONTH[1,K] := PRINT_THIS_MONTH[K - 27];
   FOR K := 40 TO 43 DO  (* WRITE YEAR TO HARD_MONTH ARRAY *)
      HARD_MONTH[1,K] := YEAR[K - 39];
   K := 4;
   FOR J := 1 TO
       MAX_DAYS_IN_MONTH(CONVERT_MONTH(MONTH),CONVERT_YEAR(YEAR)) DO
      BEGIN  (* WRITE PROPER DAY TO CORRECT PLACE IN HARD_MONTH ARRAY *)
         GOTOXY(OFF_SET + START_DAY * OFF_SET,K);
         WRITELN(J:2);
         CONVERT_TO_CHARACTERS(J,DAY_AS_CHARACTERS);
         IF (DAY_AS_CHARACTERS[1] <> '0')
            THEN  (* WRITE THE CHARACTER *)
               HARD_MONTH[K + 1,OFF_SET - 1 + OFF_SET * START_DAY] := 
                                                                      DAY_AS_CHARACTERS[1];
         HARD_MONTH[K + 1,OFF_SET + OFF_SET * START_DAY] := 
                                                            DAY_AS_CHARACTERS[2];
         START_DAY := START_DAY + 1;
         IF ((OFF_SET + START_DAY * OFF_SET)MOD 72 = 0)
            THEN
               BEGIN  (* GO TO NEXT ROW *)
                  START_DAY := 0;
                  K := K + 3
               END  (* IF MOD 72 *)
      END;  (* FOR 1 TO MAX_DAYS_IN_MONTH *)
   COUNT_APPOINTMENTS(MONTH,YEAR);
END;  (* DISPLAY_MONTH_CALENDAR *)


PROCEDURE QUICK_LOOK_AT_NEXT_12_MONTHS;






                                                   (*

     Procedure QUICK-LOOK-AT-12-MONTHS allows the user to view the next 12 months in very quick pro-
     gression.   The  upper parameter of 9999 for year will cause a warning to be printed.  In order
     to prevent this warning from being printed repeatly the boolean PAST-LIMIT is included to cause
     a by pass if its value is TRUE.

                                            Calls:      COMPUTE-NEXT-DAY-OR-MONTH
                                                        DISPLAY-MONTH-CALENDAR
                                                        DRAW-MONTH-OUTLINE
                                            Called by:  THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)

VAR 
    PAST_LIMIT : BOOLEAN;
    I : INTEGER;
BEGIN  (* QUICK_LOOK_AT_NEXT_12_MONTHS *)
   PAST_LIMIT := FALSE;
   I := 0;
   REPEAT
      I := SUCC(I);
      COMPUTE_NEXT_DAY_OR_MONTH(PAST_LIMIT,FALSE);
      IF NOT PAST_LIMIT
         THEN
            DISPLAY_MONTH_CALENDAR(THEMONTH,THEYEAR);
   UNTIL (I > 11) OR (PAST_LIMIT);
   IF PAST_LIMIT
      THEN
         DRAW_MONTH_OUTLINE;
END;  (* QUICK_LOOK_AT_NEXT_12_MONTHS *)

PROCEDURE ENTER_NEW_DATE;






                                                   (*

     Procedure ENTER-NEW-DATE allows the user to enter another date to be display in the month  for-
     mat.  

                                            Calls:      CLEAR-THE-SCREEN
                                                        EXIT-INSTRUCTIONS
                                                        PRINT-DEFAULT-DATES
                                                        SET-UP-THE-BACK-GROUND
                                                        ENTER-MONTH
                                                        ENTER-YEAR
                                                        DRAW-MONTH-OUTLINE
                                            Called by:  THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)

VAR 
    MONTH : STRING2;
    YEAR : STRING4;
    DONE : BOOLEAN;
BEGIN  (* ENTER_NEW_DATE *)
   CLEAR_THE_SCREEN;
   EXIT_INSTRUCTIONS;
   ENTER_MONTH(MONTH,DONE);
   IF NOT DONE
      THEN
         ENTER_YEAR(YEAR,DONE);
   IF NOT DONE
      THEN
         BEGIN
            THEMONTH := MONTH;
            THEYEAR := YEAR
         END;  (* IF *)
   DRAW_MONTH_OUTLINE;
END;  (* ENTER_NEW_DATE *)

PROCEDURE HARD_COPY_MONTH;






                                                   (*

     Procedure HARD-COPY-MONTH writes the current value of HARD-MONTH(i.e.  the current display)  to
     the output file HARDCOPY.DAT.

                                            Calls:      None
                                            Called by:  THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)

CONST 
      MOVE_TO_CENTER = 
                       '                                    ';

VAR 
    I,
    J : INTEGER;
BEGIN  (* HARD_COPY_MONTH *)
   PAGE(HARDCOPY);
   FOR I := 1 TO 14 DO
      WRITELN(HARDCOPY);
   WRITELN(HARDCOPY,MOVE_TO_CENTER,HEADER_ONE);
   WRITELN(HARDCOPY,MOVE_TO_CENTER,HEADER_TWO);
   WRITELN(HARDCOPY,MOVE_TO_CENTER,HEADER_THREE);
   FOR I := 1 TO 4 DO
      WRITELN(HARDCOPY);
   FOR I := 1 TO 22 DO
      BEGIN
         WRITELN(HARDCOPY,MOVE_TO_CENTER);
         FOR J := 1 TO 64 DO
            WRITELN(HARDCOPY,HARD_MONTH[I,J]);
         WRITELN(HARDCOPY);
      END;  (* FOR 1 TO 22 *)
END;  (* HARD_COPY_MONTH *)

PROCEDURE HELP_MONTH_DISPLAY;






                                                   (*

     Procedure HELP-MONTH-DISPLAY allows access to the procedure HELP at this level.

                                            Calls:      HELP
                                                        DRAW-MONTH-OUTLINE
                                            Called by:  THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)

VAR 
    MORE : BOOLEAN;
BEGIN  (* HELP_MONTH_DISPLAY *)
   REPEAT
      HELP(MORE,4);
   UNTIL NOT MORE;
   DRAW_MONTH_OUTLINE;
END;  (* HELP_MONTH_DISPLAY *)

PROCEDURE RETURN_FROM_DISPLAY_MONTH_CALENDAR_TO_MAIN_PROGRAM;






                                                   (*

     Procedure THEN-RETURN-FROM-DISPLAY-MONTH-CALENDAR-TO-MAIN-PROGRAM is a long way to say that the
     user is done with the day format and would like to do something else.  This procedure assigns a
     value of TRUE to RETURN, which allows exit from the REPEAT statement.

                                            Calls:      RETURN-TO-MAIN-PROGRAM
                                            Called by: THEN-DISPLAY-MONTH-CALENDAR
                                            Nests:      None
                                            Nested w/i: THEN-DISPLAY-MONTH-CALENDAR

                                                   *)
BEGIN (* RETURN_FROM_DISPLAY_MONTH_CALENDAR_TO_MAIN_PROGRAM *)
   RETURN := TRUE;
   RETURN_TO_MAIN_PROGRAM
END; (* RETURN_FROM_MONTH_DISPLAY_MONTH_CALENDAR_TO_MAIN_PROGRAM *)










BEGIN  (*  THEN_DISPLAY_MONTH_CALENDAR *)
   TOO_HIGH_MONTH := FALSE;
   TOO_LOW_MONTH := FALSE;
   RETURN := FALSE;
   REPEAT (* VT FIX *)
   CLEAR_THE_SCREEN;
   DRAW_MONTH_OUTLINE;
      DISPLAY_MONTH_CALENDAR(THEMONTH,THEYEAR);
      PRINT_DEFAULT_DATES;
      PRINT_MONTH_OPTIONS;
      READLN(SELECTION);
      REQUEST := TRANSLATE(SELECTION);
      CASE REQUEST OF
         4 : HELP_MONTH_DISPLAY;
         5 : HARD_COPY_MONTH;
         7 : BEGIN
                COMPUTE_PRIOR_DAY_OR_MONTH(TOO_LOW_MONTH,FALSE);
                IF TOO_LOW_MONTH
                   THEN
                      DRAW_MONTH_OUTLINE;
             END;
         8 : ENTER_NEW_DATE;
         12 : BEGIN
                 COMPUTE_NEXT_DAY_OR_MONTH(TOO_HIGH_MONTH,FALSE);
                 IF TOO_HIGH_MONTH
                    THEN
                       DRAW_MONTH_OUTLINE;
              END;
         13 : QUICK_LOOK_AT_NEXT_12_MONTHS;
         11 : RETURN_FROM_DISPLAY_MONTH_CALENDAR_TO_MAIN_PROGRAM
              OTHERWISE PRINT_OPTIONS_WARNING(SELECTION,0,22,68,14)
      END;  (* CASE *)
   UNTIL RETURN
END;  (* THEN_DISPLAY_MONTH_CALENDAR *)
(**)
                                                   (*

                        $$$$$$$$$$$$$$$$$$$$ CHANGE DATAFILE $$$$$$$$$$$$$$$$$$$$

                                                   *)










PROCEDURE THEN_CHANGE_MAIN_DATAFILE;






                                                   (*

     Procedure THEN-CHANGE-MAIN-DATAFILE acts as the coordinator for the procedures that  allow  al-
     terations to the datafile.

                                            Calls:      CLEAR-THE-SCREEN
                                                        PRINT-CHANGE-OPTIONS
                                                        TRANSLATE
                                                        DELETE-ENTRY
                                                        HELP-WITH-CHANGE
                                                        CHANGE-AN-ENTRY
                                                        PURGE-A-GROUP
                                                        RETURN-FROM-CHANGE-ETC
                                                        PRINT-OPTIONS-WARNING
                                            Called by:  Main
                                            Nests:      PRINT-CHANGE-OPTIONS
                                                        QUERY-YES-NO-AND-DONE
                                                        CHANGE-AN-ENTRY
                                                        DELETE-ENTRY
                                                        PURGE-A-GROUP
                                                        HELP-WITH-CHANGE
                                                        RETURN-FROM-CHANGE-ETC
                                            Nested w/i: Main

                                                   *)

VAR 
    RETURN : BOOLEAN;

PROCEDURE PRINT_CHANGE_OPTIONS;






                                                   (*

     Procedure PRINT-CHANGE-OPTIONS displays the options available for user selection at this level.

                                            Calls:      SET-UP-THE-FORE-GROUND
                                                        GOTOXY
                                                        SET-UP-THE-BACK-GROUND
                                                        PRINT-DEFAULT-DATES
                                            Called by:  THEN-CHANGE-MAIN-DATAFILE
                                                        CHANGE-ENTRY
                                                        DELETE-AN-ENTRY
                                                        PURGE-A-GROUP
                                                        HELP-WITH-CHANGE
                                            Nests:      None
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)
BEGIN  (* PRINT_CHANGE_OPTIONS *)
   SET_UP_THE_FORE_GROUND(30,7);
   WRITELN('C');
   GOTOXY(30,8);
   WRITELN('D');
   GOTOXY(30,9);
   WRITELN('P');
   GOTOXY(30,10);
   WRITELN('R');
   GOTOXY(30,11);
   WRITELN('HELP');
   GOTOXY(57,9);
   WRITELN('(____)');
   SET_UP_THE_BACK_GROUND(31,7);
   WRITELN(')hange an entry');
   GOTOXY(31,8);
   WRITELN(')elete an entry');
   GOTOXY(31,9);
   WRITELN(')urge a group of entries');
   GOTOXY(31,10);
   WRITELN(')eturn to program');
   PRINT_DEFAULT_DATES;
   GOTOXY(58,9)
END;  (* PRINT_CHANGE_OPTIONS *)

PROCEDURE QUERY_YES_NO_AND_DONE (VAR LOGIC,LOGIC2 : BOOLEAN);






                                                   (*

     Procedure QUERY-YES-NO-OR-DONE allows the user to enter DONE and finish the current  procedure.
     This  is done in this manner because of the repetition that might occur with changing or delet-
     ing.

                                            Calls:      BELL
                                                        PROPER-ENTRY
                                            Called by:  CHANGE-ENTRY
                                                        DELETE-ENTRY
                                            Nests:      PROPER-ENTRY
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)

VAR 
    ANSWER : CHAR;

PROCEDURE PROPER_ENTRY;






                                                   (*

     Procedure PROPER-ENTRY insures that the user has entered an allowed response  to  any  question
     requiring a reply involving yes, no, or done.

                                            Calls:      CLEAR-THE-END-OF-LINE
                                                        SET-UP-THE-FORE-GROUND
                                                        BELL
                                            Called by:  QUERY-YES-NO-AND-DONE
                                            Nests:      None
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)
BEGIN  (* PROPER ENTRY *)
   WHILE (ANSWER <> 'Y') AND (ANSWER <> 'N')
         AND (ANSWER <> 'y') AND (ANSWER <> 'n')
         AND (ANSWER <> 'D') AND (ANSWER <> 'd') DO
      BEGIN  (* FORCE USER TO ENTER PROPER ENTRY *)
         BELL;
         SET_UP_THE_FORE_GROUND(21,15);
         WRITELN('You must enter a <Y>, <N>, or <DONE>!! >');
         READLN(ANSWER);
         CLEAR_TO_END_OF_LINE(21,15);
      END; (* WHILE IMPROPER ENTRY *)
END; (* PROPER_ENTRY *)





BEGIN  (* QUERY_YES_NO_AND_DONE *)
   BELL;
   READLN(ANSWER);
   PROPER_ENTRY;
   IF (ANSWER = 'Y') OR (ANSWER = 'y')
      THEN
         LOGIC := TRUE
      ELSE
         LOGIC := FALSE;
   IF (ANSWER = 'D') OR (ANSWER = 'd')
      THEN  (* USER HAS COMPLETED CHANGING DATA *)
         LOGIC2 := TRUE
      ELSE
         LOGIC2 := FALSE;
END; (* QUERY_YES_NO_AND_DONE *)

PROCEDURE CHANGE_AN_ENTRY;






                                                   (*

     Procedure CHANGE-AN-ENTRY will prompt the user for the date of  the  entry  he  would  like  to
     change.   It  will  then search for a match and if found, will prompt the user as to whether or
     not he would like to change this entry.  All entries on the  date  are  available  for  change.
     Once  the  user  has decided to make a change, this procedure will prompt prompt the user for a
     new time and message.  It will then MAKE-CHANGE.

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CLEAR-THE-SCREEN
                                                        EXIT-INSTRUCTIONS
                                                        PRINT-DEFAULT-DATES
                                                        ENTER-MONTH
                                                        ENTER-DAY
                                                        ENTER-YEAR
                                                        CORRECT-MAX-DAYS
                                                        CLEAR-TO-END-OF-LINE
                                                        ENTER-TIME
                                                        ENTER-MESSAGE
                                                        MAKE-CHANGE
                                                        QUERY
                                                        PRINT-CHANGE-OPTIONS
                                            Called by:  THEN-CHANGE-MAIN-DATAFILE
                                            Nests:      MAKE-CHANGE
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)

VAR 
    EMPTY,
    DONE,
    DONE2,
    REPLY : BOOLEAN;
    ONE_CHANGE_ENTRY : DATAREC;
    CHANGE_MONTH,
    CHANGE_DAY : STRING2;
    CHANGE_YEAR : STRING4;

PROCEDURE MAKE_CHANGE;






                                                   (*

     Procedure MAKE-CHANGE compares the record count to the record count of the item that  the  user
     desires  to  change.   If  the counts match then this procedure writes the changed entry to the
     scratch file.  If the counts do not match then this procedure writes the current (old) entry to
     the scratch file.  Once completed, the scratch file is rewritten to the main datafile.

                                            Calls:      CLEAR-TO-END-OF-LINE
                                            Called by:  CHANGE-AN-ENTRY
                                            Nests:      None
                                            Nested w/i: CHANGE-AN-ENTRY

                                                   *)

VAR 
    TEMPFILE : FILE OF DATAREC;
    ONE_TEST_ENTRY : DATAREC;
BEGIN  (* MAKE_CHANGE *)
   CLEAR_TO_END_OF_LINE(11,17);
   RESET(MAINDATA);
   rewrite(TEMPFILE);
   WHILE NOT EOF(MAINDATA) DO
      BEGIN  (* TO GET ENTRIES FOR COMPARISON *)
         ONE_TEST_ENTRY := MAINDATA^;
         GET(MAINDATA);
         IF (ONE_TEST_ENTRY.COUNT <> ONE_CHANGE_ENTRY.COUNT)
            THEN  (* PUT INTO TEMPFILE ALL ENTRIES BUT THE CHANGED ONE *)
               BEGIN
                  TEMPFILE^ := ONE_TEST_ENTRY;
                  PUT(TEMPFILE);
               END  (* THEN *)
            ELSE
               BEGIN  (* PUT INTO TEMPFILE THE CHANGED ENTRY *)
                  TEMPFILE^ := ONE_CHANGE_ENTRY;
                  PUT(TEMPFILE);
               END;  (* ELSE *)
      END;  (* WHILE NOT EOF MAINDATA *)
   RESET(TEMPFILE);
   rewrite(MAINDATA);
   WHILE NOT EOF(TEMPFILE) DO
      BEGIN  (* MOVE VALUES TO MAINDATA FILE *)
         MAINDATA^ := TEMPFILE^;
         GET(TEMPFILE);
         PUT(MAINDATA);
      END;  (* WHILE NOT EOF TEMPFILE *)
END;  (* MAKE CHANGE *)





BEGIN  (* CHANGE_AN_ENTRY *)
   RESET(MAINDATA);
   CLEAR_THE_SCREEN;
   REPEAT
      EMPTY := FALSE;
      DONE := FALSE;
      DONE2 := FALSE;
      REPLY := TRUE;
      EXIT_INSTRUCTIONS;
      PRINT_DEFAULT_DATES;
      ENTER_MONTH(CHANGE_MONTH,DONE);
      IF NOT DONE
         THEN
            ENTER_DAY(CHANGE_DAY,DONE);
      IF NOT DONE
         THEN
            ENTER_YEAR(CHANGE_YEAR,DONE);
      IF NOT DONE
         THEN
            CORRECT_MAX_DAYS(CHANGE_MONTH,CHANGE_DAY,CHANGE_YEAR,DONE);
      WITH ONE_CHANGE_ENTRY DO
         BEGIN  (* TO SEARCH FOR MATCH *)
            IF NOT DONE
               THEN
                  REPEAT
                     IF NOT EOF(MAINDATA)  (* PREVENT PROGRAM CRASH DUE TO EOF *)
                        THEN  (* OK TO LOOK FOR MATCH *)
                           REPEAT
                              ONE_CHANGE_ENTRY := MAINDATA^;
                              GET(MAINDATA);
                           UNTIL (MONTH = CHANGE_MONTH)
                                 AND (DAY = CHANGE_DAY)
                                 AND (YEAR = CHANGE_YEAR)
                                 OR EOF(MAINDATA);
                     IF (MONTH = CHANGE_MONTH)
                        AND (DAY = CHANGE_DAY)
                        AND (YEAR = CHANGE_YEAR)
                        THEN  (* A MATCH HAS BEEN FOUND *)
                           BEGIN  (* ASK IF THIS IS THE ENTRY *)
                              EXIT_INSTRUCTIONS;
                              SET_UP_THE_BACK_GROUND(17,5);
                              WRITELN('(',MONTH,'/',DAY,'/',YEAR,' at ',TIME,' ',MESSAGE,')');
                              CLEAR_TO_END_OF_LINE(0,6);
                              GOTOXY(16,6);
                              WRITELN('Would you like to change this entry? <Y> or <N>');
                              QUERY_YES_NO_AND_DONE(REPLY,DONE2);
                              IF REPLY
                                 THEN  (* ALLOW CHANGE *)
                                    BEGIN
                                       ENTER_TIME(TIME,DONE);
                                       IF NOT DONE
                                          THEN
                                             BEGIN  (* TO CHANGE MESSAGE AND MAKE THE CHANGE *)
                                                ENTER_MESSAGE(MESSAGE);
                                                MAKE_CHANGE;
                                             END;  (* IF NOT DONE *)
                                    END;  (* IF REPLY *)
                           END  (* IF THIS WAS A MATCH *)
                        ELSE
                           EMPTY := TRUE;
                  UNTIL EOF(MAINDATA) OR DONE2;
         END;  (* WITH ONE_CHANGE_ENTRY *)
      CLEAR_THE_SCREEN;
      SET_UP_THE_BACK_GROUND(0,0);
      IF EMPTY
         THEN  (* INFORM USER THAT THERE IS NO MORE ENTRIES *)
            WRITELN('The program is finished with entries for ',CHANGE_MONTH,'/',CHANGE_DAY,'/',CHANGE_YEAR);
      WRITELN('Are you finished changing entries? <Y> or <N>');
      QUERY(REPLY);
      RESET(MAINDATA);
      CLEAR_THE_SCREEN;
   UNTIL REPLY;
   PRINT_CHANGE_OPTIONS;
END; (* CHANGE_ENTRY *)

PROCEDURE DELETE_ENTRY;






                                                   (*

     Procedure DELETE-ENTRY will prompt the user for the date of the entry he would like to  delete.
     It  will  then  search  for  a match and if found, will prompt the user as to whether or not he
     would like to delete this entry.  All entries on the date are available for deleting.  Once the
     user  has decided to make a deletion, this procedure will prompt prompt for a yes or no answer.
     It will then TEST-FOR-DELETION and delete the entry.  

                                            Calls:      SET-UP-THE-BACK-GROUND
                                                        CLEAR-THE-SCREEN
                                                        EXIT-INSTRUCTIONS
                                                        PRINT-DEFAULT-DATES
                                                        ENTER-MONTH
                                                        ENTER-DAY
                                                        ENTER-YEAR
                                                        CORRECT-MAX-DAYS
                                                        CLEAR-TO-END-OF-LINE
                                                        TEST-FOR-DELETION
                                                        QUERY
                                                        PRINT-CHANGE-OPTIONS
                                            Called by:  THEN-CHANGE-MAIN-DATAFILE
                                            Nests:      TEST-FOR-DELETION
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)

VAR 
    DELETE_MONTH,
    DELETE_DAY : STRING2;
    DELETE_YEAR : STRING4;
    ONE_DELETE_ENTRY : DATAREC;
    TEMPFILE : FILE OF DATAREC;
    EMPTY,
    DONE,
    DONE2,
    REPLY : BOOLEAN;

PROCEDURE TEST_FOR_DELETION;
                                                   (*







     Procedure TEST-FOR-DELETION compares the record entry count of the item  choosen  for  deletion
     against  the  main datafile.  As long as a match is not found, the items will be written to the
     scratch file for later rewriting to the main datafile.  This is  one  of  the  procedures  that
     ONE-BOGUS-ENTRY  was  created  for.  The logic of this procedure prevents the last entry of the
     datafile from being accessed.

                                            Calls:      None
                                            Called by:  DELETE-ENTRY
                                            Nests:      None
                                            Nested w/i: DELETE-ENTRY

                                                   *)

VAR 
    HOLDFILE : FILE OF DATAREC;
    ONE_TEST_ENTRY : DATAREC;
BEGIN (* TEST_FOR_DELETION *)
   CLEAR_TO_END_OF_LINE(11,17);
   RESET(TEMPFILE);
   WHILE NOT EOF(TEMPFILE) DO
      BEGIN  (* TO SEARCH FOR MATCH *)
         rewrite(HOLDFILE);
         ONE_DELETE_ENTRY := TEMPFILE^;
         GET(TEMPFILE);
         RESET(MAINDATA);
         WHILE NOT EOF(MAINDATA) DO
            BEGIN  (* SEARCH *)
               ONE_TEST_ENTRY := MAINDATA^;
               GET(MAINDATA);
               IF (ONE_TEST_ENTRY.COUNT <> ONE_DELETE_ENTRY.COUNT)
                  THEN  (* SAVE THIS ENTRY *)
                     BEGIN
                        HOLDFILE^ := ONE_TEST_ENTRY;
                        PUT(HOLDFILE);
                     END; (* IF *)
            END;  (* WHILE NOT EOF TEMPFILE *)
         RESET(HOLDFILE);
         rewrite(MAINDATA);
         WHILE NOT EOF(HOLDFILE) DO
            BEGIN  (* MOVE HOLDFILE TO MAINDATA *)
               MAINDATA^ := HOLDFILE^;
               GET(HOLDFILE);
               PUT(MAINDATA);
            END;  (* WHILE NOT EOF HOLDFILE *)
      END;  (* WHILE NOT EOF TEMPFILE *)
END;  (* TEST_FOR_DELETION *)





BEGIN  (* DELETE_ENTRY *)
   RESET(MAINDATA);
   rewrite(TEMPFILE);
   CLEAR_THE_SCREEN;
   REPEAT
      EMPTY := FALSE;
      DONE := FALSE;
      DONE2 := FALSE;
      REPLY := TRUE;
      EXIT_INSTRUCTIONS;
      PRINT_DEFAULT_DATES;
      ENTER_MONTH(DELETE_MONTH,DONE);
      IF NOT DONE
         THEN
            ENTER_DAY(DELETE_DAY,DONE);
      IF NOT DONE
         THEN
            ENTER_YEAR(DELETE_YEAR,DONE);
      IF NOT DONE
         THEN
            CORRECT_MAX_DAYS(DELETE_MONTH,DELETE_DAY,DELETE_YEAR,DONE);
      WITH ONE_DELETE_ENTRY DO
         BEGIN  (* THE SEARCH *)
            IF NOT DONE
               THEN  (* SEARCH *)
                  REPEAT
                     IF NOT EOF(MAINDATA)  (* PREVENTS PROGRAM CRASH *)
                        THEN  (* MOVE MAINDATA TO ENTRY FOR TEST *)
                           REPEAT
                              ONE_DELETE_ENTRY := MAINDATA^;
                              GET(MAINDATA);
                           UNTIL (MONTH = DELETE_MONTH)
                                 AND (DAY = DELETE_DAY)
                                 AND (YEAR = DELETE_YEAR)
                                 OR EOF(MAINDATA);
                     IF (MONTH = DELETE_MONTH)
                        AND (DAY = DELETE_DAY)
                        AND (YEAR = DELETE_YEAR)
                        THEN  (* A MATCH HAS BEEN FOUND *)
                           BEGIN  (* TO ASK USER IF THIS IS THE ONE *)
                              EXIT_INSTRUCTIONS;
                              SET_UP_THE_BACK_GROUND(17,5);
                              WRITELN('(',MONTH,'/',DAY,'/',YEAR,' at ',TIME,' ',MESSAGE,')');
                              CLEAR_TO_END_OF_LINE(0,6);
                              GOTOXY(16,6);
                              WRITELN('Would you like to delete this entry? <Y> or <N>');
                              QUERY_YES_NO_AND_DONE(REPLY,DONE2);
                              IF REPLY
                                 THEN (* WRITE TO TEMPFILE FOR LATER DELETION *)
                                    BEGIN
                                       TEMPFILE^ := ONE_DELETE_ENTRY;
                                       PUT(TEMPFILE);
                                    END;  (* THEN *)
                           END  (* IF THIS WAS A MATCH *)
                        ELSE  (* NO MATCH *)
                           EMPTY := TRUE;
                  UNTIL EOF(MAINDATA) OR DONE2;
         END;  (* WITH ONE_DELETE_ENTRY *)
      CLEAR_THE_SCREEN;
      SET_UP_THE_BACK_GROUND(0,0);
      IF EMPTY
         THEN
            WRITELN('The program is finished with entries for ',DELETE_MONTH,'/',DELETE_DAY,'/',DELETE_YEAR);
      WRITELN('Are you finished deleting entries? <Y> or <N>');
      QUERY(REPLY);
      TEST_FOR_DELETION;
      RESET(MAINDATA);
      rewrite(TEMPFILE);
      CLEAR_THE_SCREEN;
   UNTIL REPLY;
   PRINT_CHANGE_OPTIONS;
END; (* DELETE_ENTRY *)

PROCEDURE PURGE_A_GROUP;






                                                   (*

     Procedure PURGE-A-GROUP is similiar to CHANGE and DELETE but the code must be expanded to allow
     the  user  to  enter a stop and a start date.  This procedure will delete all entries from 0001
     hours of the requested start day to 2400 hours of the requested stop day.  Once  the  user  has
     indicated  that  the  dates he has entered are the dates he would like to have entries deleted;
     TEST-FOR-DELETIONS is called to erase the entries from the datafile.

                                            Calls:      CLEAR-THE-SCREEN
                                                        EXIT-INSTRUCTIONS
                                                        PRINT-DEFAULT-DATES
                                                        SET-UP-THE-BACK-GROUND
                                                        ENTER-MONTH
                                                        ENTER-DAY
                                                        ENTER-YEAR
                                                        CORRECT-MAX-DAYS
                                                        CONVERT-YEAR
                                                        CONVERT-MONTH
                                                        CONVERT-DAY
                                                        CLEAR-A-LOCAL-AREA
                                                        GOTOXY
                                                        QUERY
                                                        TEST-FOR-DELETIONS
                                                        PRINT-CHANGE-OPTIONS
                                            Called by:  THEN-CHANGE-MAIN-DATAFILE
                                            Nests:      TEST-FOR-DELETIONS
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)

VAR 
    START_DATE,
    START,
    STOP_DATE,
    STOP,
    DATE : INTEGER;
    START_MONTH,
    START_DAY,
    STOP_MONTH,
    STOP_DAY : STRING2;
    START_YEAR,
    STOP_YEAR : STRING4;
    ONE_ENTRY : DATAREC;
    DONE,
    REPLY : BOOLEAN;

PROCEDURE TEST_FOR_DELETIONS(START,STOP : INTEGER);






                                                   (*

     Procedure TEST-FOR-DELETIONS compares the record count against those record counts of the  main
     datafile.   If the item is not within the range of the desired deletions, then it is written to
     a scratch file for later rewriting to the main datafile.

                                            Calls:      CLEAR-THE-SCREEN
                                            Called by:  PURGE-A-GROUP
                                            Nests:      None
                                            Nested w/i: PURGE-A-GROUP

                                                   *)

VAR 
    HOLDFILE : FILE OF DATAREC;
    ONE_TEST_ENTRY : DATAREC;
BEGIN (* TEST_FOR_DELETIONS *)
   CLEAR_THE_SCREEN;
   RESET(MAINDATA);
   rewrite(HOLDFILE);
   WHILE NOT EOF(MAINDATA) DO
      BEGIN  (* TO TEST FOR DELETION *)
         ONE_TEST_ENTRY := MAINDATA^;
         GET(MAINDATA);
         IF (ONE_TEST_ENTRY.COUNT < START) OR (ONE_TEST_ENTRY.COUNT > STOP)
            THEN  (* SAVE THIS ENTRY *)
               BEGIN
                  HOLDFILE^ := ONE_TEST_ENTRY;
                  PUT(HOLDFILE);
               END;  (* IF *)
      END; (* WHILE NOT EOF MAINDATA *)
   RESET(HOLDFILE);
   rewrite(MAINDATA);
   WHILE NOT EOF(HOLDFILE) DO
      BEGIN  (* MOVE HOLDFILE TO MAINDATA *)
         MAINDATA^ := HOLDFILE^;
         GET(HOLDFILE);
         PUT(MAINDATA);
      END;  (* WHILE NOT EOF HOLDFILE *)
END;  (* TEST_FOR_DELETION *)





BEGIN  (* PURGE_A_GROUP *)
   CLEAR_THE_SCREEN;
   REPEAT
      START := 0;
      STOP  := 0;
      DONE := FALSE;
      REPLY := TRUE;
      EXIT_INSTRUCTIONS;
      PRINT_DEFAULT_DATES;
      SET_UP_THE_BACK_GROUND(0,0);
      WRITELN('You will now enter the start date.');
      ENTER_MONTH(START_MONTH,DONE);
      IF NOT DONE
         THEN
            ENTER_DAY(START_DAY,DONE);
      IF NOT DONE
         THEN
            ENTER_YEAR(START_YEAR,DONE);
      IF NOT DONE
         THEN
            CORRECT_MAX_DAYS(START_MONTH,START_DAY,START_YEAR,DONE);
      IF NOT DONE
         THEN
            BEGIN
               START_DATE := CONVERT_YEAR(START_YEAR) * 10000
                             + CONVERT_MONTH(START_MONTH) *100
                             + CONVERT_DAY(START_DAY);
               CLEAR_A_LOCAL_AREA(0,0,0,1);
               SET_UP_THE_BACK_GROUND(0,0);
               WRITELN('You will now enter the stop date.');
            END;  (* IF *)
      IF NOT DONE
         THEN
            ENTER_MONTH(STOP_MONTH,DONE);
      IF NOT DONE
         THEN
            ENTER_DAY(STOP_DAY,DONE);
      IF NOT DONE
         THEN
            ENTER_YEAR(STOP_YEAR,DONE);
      IF NOT DONE
         THEN
            CORRECT_MAX_DAYS(STOP_MONTH,STOP_DAY,STOP_YEAR,DONE);
      IF NOT DONE
         THEN
            BEGIN
               STOP_DATE := CONVERT_YEAR(STOP_YEAR) * 10000
                            + CONVERT_MONTH(STOP_MONTH) * 100
                            + CONVERT_DAY(STOP_DAY);
               CLEAR_THE_SCREEN;
               SET_UP_THE_BACK_GROUND(0,0);
               WRITELN('You have elected to purge all entries');
               GOTOXY(4,1);
               WRITELN('FROM: 0001 hours on ',START_MONTH,'/',START_DAY,'/',START_YEAR);
               GOTOXY(4,2);
               WRITELN('  TO: 2400 hours on ',STOP_MONTH,'/',STOP_DAY,'/',STOP_YEAR);
               GOTOXY(0,3);
               WRITELN('Are these the dates you want? <Y> or <N>');
               QUERY(REPLY);
               IF REPLY
                  THEN  (* SEARCH FOR MATCH *)
                     WITH ONE_ENTRY DO
                        BEGIN  (* SEARCH *)
                           RESET(MAINDATA);
                           REPEAT
                              IF NOT EOF(MAINDATA)  (* PREVENT PROGRAM CRASH *)
                                 THEN  (* ASSIGN A VALUE TO TEST FOR MATCH *)
                                    BEGIN  (* TO FIND MATCH *)
                                       ONE_ENTRY := MAINDATA^;
                                       GET(MAINDATA);
                                       DATE := CONVERT_YEAR(YEAR) * 10000
                                               + CONVERT_MONTH(MONTH) *100
                                               + CONVERT_DAY(DAY);
                                       START := COUNT;
                                    END;  (* IF NOT EOF *)
                           UNTIL (DATE >= START_DATE) OR EOF(MAINDATA);
                           RESET(MAINDATA);
                           IF NOT EOF(MAINDATA)  (* PREVENT PROGRAM CRASH *)
                              THEN  (* FIND MATCH FOR STOP COUNT *)
                                 REPEAT
                                    ONE_ENTRY := MAINDATA^;
                                    GET(MAINDATA);
                                    DATE := CONVERT_YEAR(YEAR) * 10000
                                            + CONVERT_MONTH(MONTH) *100
                                            + CONVERT_DAY(DAY);
                                    STOP := COUNT - 1;
                                 UNTIL EOF(MAINDATA) OR (DATE > STOP_DATE);
                           IF (STOP >= START)
                              THEN
                                 BEGIN  (* PURGE THE ENTRIES *)
                                    TEST_FOR_DELETIONS(START,STOP);
                                    CLEAR_THE_SCREEN;
                                    SET_UP_THE_BACK_GROUND(0,0);
                                 END  (* THEN *)
                              ELSE
                                 WRITELN('The dates you have entered are not in your datafile.');
                        END;  (* IF NOT EOF MAINDATA *)
            END;  (* IF REPLY *)
      IF DONE
         THEN
            BEGIN
               GOTOXY(0,5);
               CLEAR_THE_SCREEN;
            END;  (* IF DONE *)
      WRITELN('Do you want to purge any more entries? <Y> or <N>');
      QUERY(REPLY);
      CLEAR_THE_SCREEN;
   UNTIL NOT REPLY;
   PRINT_CHANGE_OPTIONS;
END;  (* PURGE_A_GROUP *)

PROCEDURE HELP_WITH_CHANGE;






                                                   (*

     Procedure HELP-WITH-CHANGE allows access to the procedure HELP at this level.

                                            Calls:      HELP
                                                        PRINT-CHANGE-OPTIONS
                                            Called by:  THEN-CHANGE-MAIN-DATAFILE
                                            Nests:      None
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)

VAR 
    MORE : BOOLEAN;
BEGIN  (* HELP_WITH_CHANGE *)
   MORE := TRUE;
   REPEAT
      HELP(MORE,2);
   UNTIL NOT MORE;
   PRINT_CHANGE_OPTIONS;
END;  (* HELP_WITH_CHANGE *)

PROCEDURE RETURN_FROM_CHANGE_TO_MAIN_PROGRAM;






                                                   (*

     Procedure THEN-RETURN-FROM-CHANGE-TO-MAIN-PROGRAM is a long way to say that the  user  is  done
     with  the change option and would like to do something else.  This procedure assigns a value of
     TRUE to RETURN, which allows exit from the REPEAT statement.

                                            Calls:      RETURN-TO-MAIN-PROGRAM
                                            Called by:  THEN-CHANGE-MAIN-DATAFILE
                                            Nests:      None
                                            Nested w/i: THEN-CHANGE-MAIN-DATAFILE

                                                   *)
BEGIN  (* RETURN_FROM_CHANGE_TO_MAIN_PROGRAM *)
   RETURN := TRUE;
   RETURN_TO_MAIN_PROGRAM;
END;  (* RETURN_FROM_CHANGE_TO_MAIN_PROGRAM *)










BEGIN  (* THEN_CHANGE_MAIN_DATAFILE *)
   RETURN := FALSE;
   CLEAR_THE_SCREEN;
   PRINT_CHANGE_OPTIONS;
   REPEAT
      READLN(SELECTION);
      REQUEST := TRANSLATE(SELECTION);
      CASE REQUEST OF
         2 : DELETE_ENTRY;
         4 : HELP_WITH_CHANGE;
         6 : CHANGE_AN_ENTRY;
         7 : PURGE_A_GROUP;
         11 : RETURN_FROM_CHANGE_TO_MAIN_PROGRAM
              OTHERWISE PRINT_OPTIONS_WARNING(SELECTION,30,18,58,9);
      END;  (* CASE *)
   UNTIL RETURN;
END;  (* THEN_CHANGE_MAIN_DATAFILE *)
(**)
                                                   (*

                         $$$$$$$$$$$$$$$$$$$$ MAIN PROGRAM $$$$$$$$$$$$$$$$$$$$

                                                   *)










BEGIN (* MAIN PROGRAM *)
   rewrite(HARDCOPY);  (* THE ONLY TIME EXTERNAL FILE HARDCOPY IS REWRITTEN IS HERE *)
   LINELIMIT(OUTPUT,MAXINT);
   GETDATE;
   INTRODUCTION_TO_DATE_BOOK;
   PRINT_MAIN_OPTIONS;
   COMPLETE := FALSE;
   REPEAT  (* PROGRAM EXECUTION *)
      READLN(SELECTION);
      REQUEST := TRANSLATE(SELECTION);
      CASE REQUEST OF  (* VALUE OF REQUEST DETERMINES LEVEL TO BE USED *)
         1 : THEN_DATA_ENTRY;
         2 : THEN_DISPLAY_DAY_CALENDAR;
         3 : THEN_DISPLAY_MONTH_CALENDAR;
         4 : THEN_HELP;
         6 : THEN_CHANGE_MAIN_DATAFILE;
         9 : THEN_STOP_PROGRAM_EXECUTION
            OTHERWISE PRINT_OPTIONS_WARNING(SELECTION,30,18,51,9);
      END;  (* CASE REQUEST OF *)
   UNTIL COMPLETE  (* USER HAS FINISHED WITH PROGRAM *)
END. (* PROGRAM DATEBOOK *)
