$ SAVE_VERIFY := 'F$VERIFY(0)'
$ !
$ !  Command file to set up new user accounts
$ !
$ !  Author:	Capt Randall Rushe
$ !		USAF Weapons Lab/ARLB
$ !		Kirtland AFB, NM  87117
$ !		(505) 844-2496
$ !
$ SAVE_DIR := 'F$DIRECTORY()'
$ SET DEF DISK$SYSTEM:[SYSEXE]
$ LOOP:
$ !
$ !  Get new user's parameters
$ !
$ INQUIRE USER "New username (or LIST, or EXIT)"
$ IF USER.EQS."" THEN GOTO EXIT
$ IF USER.EQS."LIST" THEN GOTO LIST
$ IF USER.EQS."EXIT" THEN GOTO EXIT
$ INQUIRE OWN "Owner's full name"
$ INQUIRE UIC "Owner's UIC"
$!     Password is set to NEW for all new users; they can change it when
$!	   they log in.
$ PASS := "NEW"
$ WRITE SYS$OUTPUT "Password defaulted to ''PASS'"
$ INQUIRE ACC "Account identifier"
$ INQUIRE DISK "Default disk (CR=DISK$USER:)"
$ IF DISK.EQS."" THEN DISK := DISK$USER:	! default the default disk
$ DIRECTORY := 'F$EXTRACT(0,9,USER)'		! directory is first 9
$						!   characters of username
$ !
$ !  Write temporary command file to make UAF and disk quota entries, 
$ !	then execute it.
$ !
$ OPEN/WRITE UAFCOM NEWUSER.TMP
$ WRITE UAFCOM "$ RUN AUTHORIZE"
$ WRITE UAFCOM "ADD ",USER,"/OWN=""",OWN,"""/UIC=[''UIC']","-"
$ WRITE UAFCOM "/DIR=[",DIRECTORY,"]/PASS=",PASS,"/ACC=",ACC,"/DEV=",DISK
$ WRITE UAFCOM "SHO ",USER
$ WRITE UAFCOM "EXIT"
$ WRITE UAFCOM "$ RUN DISKQUOTA"
$ WRITE UAFCOM "USE ''DISK'"
$ WRITE UAFCOM "ADD [''UIC']"
$ WRITE UAFCOM "SHOW [''UIC']"
$ WRITE UAFCOM "EXIT"
$ CLOSE UAFCOM
$ @NEWUSER.TMP			! execute temporary procedure
$ DELETE NEWUSER.TMP;*		! delete it
$ !
$ !  Create user's directory, protect against group write,
$ !	set version limit to 10, and copy template LOGIN.COM
$ !
$ CREATE/DIR/VERSION=10/OWN=['UIC'] 'DISK'['DIRECTORY']
$ SET PROT=(GR:RE) 'DISK'[0,0]'DIRECTORY'.DIR
$ COPY SYS$MANAGER:TEMPLATE.COM 'DISK'['DIRECTORY']LOGIN.COM
$ SET PROT=W:RWED 'DISK'['DIRECTORY']LOGIN.COM
$ GOTO LOOP
$ LIST:
$ !
$ !  Genterate a sorted uaf listing, spool 2 copies
$ !
$ RUN AUTHORIZE
LIST
EXIT
$ SORT SYSUAF.LIS SYSUAF.LIS/KEY=(POS:36,SIZ:3)/KEY=(POS:40,SIZ:3)-
/KEY=(POS:22,SIZ:13)
$ PRINT SYSUAF.LIS/COPIES=3
$ PURGE SYSUAF.LIS/LOG
$ EXIT:
$ SET DEF 'SAVE_DIR'
$ IF SAVE_VERIFY THEN $SET VERIFY
$ EXIT
