$ SAVE_VERIFY = 'F$VERIFY(0)'
$ !
$ !  Command file to allow a system user to change his UIC and default
$ !	directory to match any user on system.  It will read the latest
$ !	normal [SYSEXE]SYSUAF.LIS file to find the required info.
$ !	This is invaluable for switching to a user's context to check
$ !	problems, show examples, or just snoop around. Any files edited
$ !	or created will belong to the user so he can alter or delete 
$ !	them. A more sophisticated command procedure might use a full
$ !	SYSUAF listing and change all process privileges to those of
$ !	the user for debugging system programs.
$ !
$ !	Usage is:   @CH USER FLAG
$ !
$ !	    where USER is username to which to match process
$ !		characteristics.
$ !	    where FLAG, if non-null, suppresses process information
$ !
$ !  The process name is changed to the target user's name  preceded by
$ !	an underscore for easy identification of which processes are
$ !	running under an alias for another user. (Uses unsupported
$ !	SETNAME program)
$ !
$ !  The user name can be changed (this is currently commented out) so
$ !	that the target user's MAIL can be read or so batch jobs can be
$ !	submitted on his behalf.  NOTE: logging out while running under
$ !	another username will write accounting data to his account. (Uses
$ !	unsupported SETUSER program)
$ !
$ !  Author: Capt Randall Rushe 	 5/24/80, Revised: 10/80 for V2
$ !	     USAF Weapons Lab/ARLB
$ !          Kirtland AFB, NM  87117
$ !	     (505) 844-2496
$ !
$ SET NOON
$ SET PROCESS/PRIORITY=5	! Run fast (searching long SYSUAF's is slow!)
$ USER := 'P1'
$ FLAG := 'P2'
$ SETUSER := $SYS$SYSTEM:SETUSER
$ SETNAME := $SYS$SYSTEM:SETNAME
$CHK_USER:
$ IF USER.NES."" THEN GOTO CONT
$ INQUIRE USER "$_User"
$ GOTO CHK_USER
$CONT:
$ !
$ !  Process "SYSTEM" specially
$ !
$ IF USER.NES."SYSTEM" THEN GOTO SYSMGR
$ SET UIC [1,4]
!$ SETUSER SYSTEM
$ SETNAME _SYSTEM
$ SET DEF DISK$SYSTEM:[SYSEXE]
$ GOTO SHOW
$ !
$ ! Process "SYSMGR" specially
$ !
$SYSMGR:
$ IF USER.NES."SYSMGR" THEN GOTO SYSUSER
$ SET UIC [1,4]
!$ SETUSER SYSTEM
$ SETNAME _SYSMGR
$ SET DEF DISK$SYSTEM:[SYSMGR]
$ GOTO SHOW
$ !
$ ! Process "SYSUSER" specially
$ !
$SYSUSER:
$ IF USER.NES."SYSUSER" THEN GOTO UAF
$ SET UIC [1,4]
!$ SETUSER SYSTEM
$ SETNAME .SYSUSER
$ SET DEF DISK$SYSTEM:[SYSUSER]
$ GOTO SHOW
$ !
$ !  Process entries in SYSUAF
$ !
$UAF:
$ ON CONTROL_Y THEN GOTO UAF_ABORT
$ OPEN/READ/ERROR=NOFILE SYSUAF SYS$SYSTEM:SYSUAF.LIS
$ READ/END=EOF SYSUAF DATA			! skip header
$READ_LOOP:
$ READ/END=EOF SYSUAF DATA
$ UAFUSER := 'F$EXTRACT(21,12,DATA)'		! get username
$ UAFUIC := 'F$EXTRACT(34,10,DATA)'		! get UIC
$ UAFDIR := 'F$EXTRACT(63,30,DATA)'		! get base directory
$ IF UAFUSER.NES.USER THEN GOTO READ_LOOP
$ CLOSE SYSUAF
$ SET UIC 'UAFUIC'				! change to user's UIC
$ SET DEF 'UAFDIR'				! change to his directory
!$ SETUSER 'UAFUSER'				! change to his username
$ SETNAME _'UAFUSER'				! tag process name
$SHOW:
$ IF FLAG.NES."" THEN GOTO EXIT
$ SHOW PROCESS					! display new process info
$ GOTO EXIT
$UAF_ABORT:
$ CLOSE SYSUAF
$ WRITE SYS$OUTPUT "%CH-I-ABORT, change aborted"
$ GOTO EXIT
$EOF:
$ WRITE SYS$OUTPUT "%CH-E-NOUSER, no matching username ''USER' in SYSUAF.LIS"
$ CLOSE SYSUAF
$ GOTO EXIT
$NOFILE:
$ WRITE SYS$OUTPUT "%CH-F-NOFILE, no current SYSUAF.LIS file accessable"
$EXIT:
$ SET PROCESS/PRIORITY=4			! go slow again
$ IF SAVE_VERIFY THEN SET VERIFY
$ EXIT
