$!
$!	N E W U S E R . C O M
$!
$ SET NOVERIFY
$!
$! This command procedure is designed to assist in entering new accounts
$! into the System Authorization File. It also enters the user's UIC into
$! the appropriate disk quota file, and creates the user's directory.
$!
$! The following conventions are in use within this file:
$!
$! There are both "personal" and "group" accounts. The difference is that
$! "personal" accounts take on the Owner's last name as the Username, while
$! "group" accounts take on the name of the group. "Group" accounts also
$! automatically get their LOCKPWD flag set.
$!
$! The account's default directory is named after the account Username.
$!
$! The Cost Center is an entity along which accounting will be done.
$!
$! With the exception of the LOCKPWD flag, users receive the default
$! privileges and quotas.
$!
$! As written this procedure assigns the default disk quota.
$!
$! This procedure modified 5/1/81 to assign a version limit to directories.
$!
$ SAVE_DEF := 'F$LOGICAL("SYS$DISK")''F$DIRECTORY()'
$START:
$ INQUIRE OWNER "Owner's name"
$ IF 'F$LENGTH(OWNER)' .EQ. 0 THEN EXIT
$ USER := 'OWNER'
$ OWNER := 'F$EXTRACT(0,32,OWNER)'
$ PARSE:
$ IF 'F$LOCATE(" ",USER)' .EQ. 'F$LENGTH(USER)' THEN GOTO CONT
$ NONBLANK = 'F$LOCATE(" ",USER)' + 1
$ USER := 'F$EXTRACT(NONBLANK,64,USER)'
$ GOTO PARSE
$ CONT:
$ FLAGS := " "
$ INQUIRE PERSONAL "Personal Account?"
$ IF PERSONAL THEN GOTO REST
$ FLAGS := "/FLAGS=LOCKPWD"
$ INQUIRE USER "Group Name"
$ REST:
$ USER := 'F$EXTRACT(0,12,USER)
$ DIR := ['F$EXTRACT(0,9,USER)']
$ INQUIRE ACC "Cost Center"
$ ACC := 'F$EXTRACT(0,8,ACC)'
$ INQUIRE UIC "UIC"
$ IF 'F$LOCATE("[",UIC)' .EQ. 'F$LENGTH(UIC)' THEN UIC := ['UIC'
$ IF 'F$LOCATE("]",UIC)' .EQ. 'F$LENGTH(UIC)' THEN UIC := 'UIC']
$ PTR = 'F$LOCATE(",",UIC)'
$ MCR WHO SHOW 'F$EXTRACT(0,PTR,UIC)',*]
$ MCR WHO SHOW [*'F$EXTRACT(PTR,9,UIC)'
$ INQUIRE DEV "Default Device"
$ IF 'F$LOCATE(":",DEV)' .EQ. 'F$LENGTH(DEV)' THEN DEV := 'DEV':
$ INQUIRE PASS "Password"
$ PASS := 'F$EXTRACT(0,31,PASS)'
$ OPEN/WRITE COMAND TEMP.XXX;1
$ WRITE COMAND "$ SET DEFAULT SYS$SYSTEM:"
$ WRITE COMAND "$ RUN DISKQUOTA"
$ WRITE COMAND "USE ",DEV
$ WRITE COMAND "ADD ",UIC
$ WRITE COMAND "$ CREATE/DIR/VERSION=3/OWNER=",UIC," ",DEV,DIR
$ WRITE COMAND "$ RUN AUTHORIZE"
$ WRITE COMAND "ADD ",USER,"/OWNER=""",OWNER,"""/ACC=",ACC,"/UIC=",UIC,"-"
$ WRITE COMAND "/DEV=",DEV,"/DIR=",DIR,"/PASSWORD=",PASS,FLAGS
$ WRITE COMAND "SHOW ",USER
$ CLOSE COMAND
$ @TEMP.XXX;1
$ SET DEF 'SAVE_DEF'
$ DELETE TEMP.XXX;1
$ GOTO START
