$!
$!	Start of [DECUS.COPYING]LIST.COM
$!
$!	Written by:  J. L. Bingham
$!                   Mantech International
$!                   2320 Mill Road
$!                   Alexandria, VA 22314
$!                   Telephone (703) 960-8900
$!
$! This procedure finds the subdirectories in a directory
$!   structure and writes their names and a name to be
$!   used for a container file in the file DIRLIS.DAT.
$!   DIRLIS.DAT must be opened in the calling command
$!   procedure and must have the logical name DIRLIS.
$!   The procedure is called recursively as it traverses
$!   the directory tree.
$!
$! Status is returned as follows:
$!   $STATUS=1 -> P1 is a directory containing no valid subdirectories.
$!   $STATUS=3 -> P1 is a directory containing one or more subdirectories.
$!                  It may also contain files.
$!   $STATUS=5 -> Execution is being interupted by CONTROL Y
$!
$	ON ERROR THEN $EXIT 3
$	DIRECTORY/COLUMNS=1/NOTRAILING/OUTPUT='P2'.DAT ['P1']*.DIR
$!
$	ON ERROR THEN $GOTO EXIT5
$	ON CONTROL_Y THEN $GOTO EXIT5
$	INODE := " "
$	OPEN 'P2' 'P2'.DAT
$	READ 'P2' LINE
$	IF "''LINE'" .NES. "" THEN $GOTO NOSUBS
$!
$	READ 'P2' LINE
$	READ 'P2' LINE
$!
$	SEQ = 1
$	GOODDIR = 3
$!
$READ:
$	READ/END_OF_FILE=EOF 'P2' LINE
$!
$		CHARSEQ := 'SEQ'
$		IF SEQ .LT. 10 THEN CHARSEQ := 0'CHARSEQ'
$		NAME := 'P2''CHARSEQ'
$		DOT = 'F$LOCATE(".DIR;",LINE)
$		LINE := 'F$EXTRACT(0,DOT,LINE)
$!
$!		Make the recursive call
$!
$		@LIST 'P1'.'LINE' 'NAME' 'P3'
$!
$		IF $STATUS .EQ. 1 THEN $GOODDIR = 1
$		IF $STATUS .EQ. 3 THEN $GOTO READ
$		IF $STATUS .EQ. 5 THEN $GOTO EXIT5
$		SEQ = SEQ+1
$		GOTO READ
$!
$EOF:
$	INODE := NODE
$!
$NOSUBS:
$	NUM = 0
$	IF .NOT. SFLAG THEN $GOTO ADDBLOCKS
$	MCR PIP BLOCKS.TMP=['P1'] /TB
$	OPEN/READ B BLOCKS.TMP
$	READ/END=NO_SUCH_FILES B RECORD
$REREAD:
$	READ/END=NO_SUCH_FILES B RECORD
$	O1='F$LOCATE("/",RECORD)+1
$	O2='F$LOCATE(". ",RECORD)
$	L1=O2-O1
$		IF L1 .NE. -1 THEN $GOTO XNUM
$		WRITE SYS$OUTPUT "*********************************************ERROR USING PIP/TB"
$		GOTO REREAD
$XNUM:
$	NUM='F$EXTRAC(O1,L1,RECORD)
$	CLOSE B
$	DEL BLOCKS.TMP.*
$	GOTO ADDBLOCKS
$
$NO_SUCH_FILES:
$	CLOSE B
$	DELETE BLOCKS.TMP.*
$	NUM = 0
$ADDBLOCKS:
$		TOTSIZE == TOTSIZE + NUM
$		IF VER THEN $WRITE SYS$OUTPUT "[''P1']    Size = ''NUM'"
$		WRITE DIRLIS "[''P1']    Size =  ''NUM'"
$!
$!		Remove the fixed portion of P1--P1 will then be the name of
$!		the subdirectory under the directory specified in MAKETAPE.COM
$!
$		MAIN_LEN = 'F$LENGTH(P3)
$		SUB_LEN = 'F$LENGTH(P1) - MAIN_LEN
$		P1 := 'F$EXTRACT(MAIN_LEN,SUB_LEN,P1)
$		IF VER THEN $WRITE SYS$OUTPUT "[''P1']"
$		WRITE DIRLIS "[''P1']    "
$		IF VER THEN $WRITE SYS$OUTPUT "''P2'.CON"
$		WRITE DIRLIS "''P2'.CON"
$		IF VER THEN $WRITE SYS$OUTPUT "''INODE'"
$		WRITE DIRLIS "''INODE'"
$		GOODDIR = 1
$		CLOSE 'P2'
$		DELETE 'P2'.DAT.*
$		EXIT 1
$!
$EXIT5:
$	CLOSE 'P2'
$	DELETE 'P2'.DAT.*
$	EXIT 5
$!
$!		End of [DECUS]LIST.COM
$!
