$	VER == 'F$VERIFY(0)
$!
$!		Start of [DECUS.COPYING]MAKETAPE.COM
$!
$!	Written by:  J. L. Bingham
$!                   Mantech International
$!                   2320 Mill Road
$!                   Alexandria, VA 22314
$!                   Telephone (703) 960-8900
$!
$! USAGE:  This procedure copies directory trees to tape.  The trees can be
$!   recovered with the COPYTAPE.COM procedure.  Set default to the directory
$!   containing this procedure and LIST.COM.  Initiate the procedure and
$!   respond to the prompts.
$!
$	DEFDIR := 'F$LOGICAL("SYS$DISK")''F$DIRECTORY()'
$	ON CONTROL_Y THEN $GOTO CTLY
$	INQUIRE/NOPUNC ANS "Do you want to build a new list of directories(DIRLIS.DAT)? "
$	IF .NOT. ANS THEN $GOTO DOIT
$	INQUIRE/NOPUNC SCALC "Do you want the list to include directory sizes? "
$!
$	OPEN/WRITE DIRLIS DIRLIS.DAT
$	WRITE DIRLIS "Original name and, optionally, size (in 512 byte blocks), name for use"
$	WRITE DIRLIS " copying back to disk and the associated container file name."
$	WRITE DIRLIS " "
$!
$	SEQ = 1
$	TOTSIZE == 0
$	SFLAG == SCALC
$!
$GETDIR:
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT "Enter the name of the root directory of the next tree to be copied"
$	INQUIRE DIR "or a null line to indicate no more trees"
$	WRITE SYS$OUTPUT " "
$	IF "''DIR'" .EQS. "" THEN $GOTO LASTDIR
$!
$	@LIST 'DIR' 'SEQ' 'DIR'
$	IF $STATUS .EQ. 5 THEN $GOTO CTLY
$	SEQ = SEQ + 1
$	WRITE SYS$OUTPUT "Total size of selected directories is ''TOTSIZE'"
$	GOTO GETDIR
$!
$LASTDIR:
$	WRITE DIRLIS "A total of ''TOTSIZE' blocks."
$	CLOSE DIRLIS
$!
$DOIT:
$	ON CONTROL_Y THEN $GOTO ABORT
$	ON ERROR THEN $GOTO ABORT
$	INQUIRE/NOPUNC ANS "Do you want to see the directory/container file list? "
$	WRITE SYS$OUTPUT " "
$	IF ANS THEN $TYPE DIRLIS.DAT
$!
$	INQUIRE DRIVE "Enter the name of the tape drive"
$	INQUIRE DENS "Enter the desired recording density, 800 or 1600"
$	INQUIRE LABEL "Enter the tape label"
$	WRITE SYS$OUTPUT " "
$	IF VER THEN $SET VERIFY
$!
$!		Allocate, initialize and mount the tape
$!
$	ALLOCATE 'DRIVE' TAPE
$	INITIALIZE/DENSITY='DENS' TAPE 'LABEL
$	MOUNT TAPE 'LABEL' TAPE
$	SET NOON
$!
$!		Copy 0README.DOC, COPYTAPE.COM, MAKETAPE.COM, LIST.COM and
$!		DIRLIS.DAT, creating a dummp 0README.COM if necessary
$!
$DOC:
$	COPY 0README.DOC TAPE
$	IF $STATUS .NE. %X1067109A THEN $GOTO DOCOK !Unable to open as input
$		CREATE 0README.DOC
		DUMMY FILE FOR 0README.DOC
$		WRITE SYS$OUTPUT "Created dummy 0README.DOC"
$		SET ON
$		GOTO DOC
$DOCOK:
$	SET ON
$	COPY MAKETAPE.COM TAPE
$	COPY LIST.COM TAPE
$	COPY COPYTAPE.COM TAPE
$	COPY DIRLIS.DAT TAPE
$	OPEN DIRLIS DIRLIS.DAT
$	READ DIRLIS LINE
$	READ DIRLIS LINE
$	READ DIRLIS LINE
$!
$!		Copy the directories using the BCK utility.  (These files must be
$!		read with the RST utility)
$!
$LOOP:
$	READ/END_OF_FILE=EXIT DIRLIS ORIGDIR
$	READ/END_OF_FILE=EXIT DIRLIS SUBDIR
$	READ/END_OF_FILE=EXIT DIRLIS FILE
$	READ/END_OF_FILE=EXIT DIRLIS LINE
$	SPACE = 'F$LOCATE("  ",ORIGDIR)
$	ORIGDIR := 'F$EXTRACT(0,SPACE,ORIGDIR) !Strip off the size garbage.
$!
$	SET VERIFY
$	SET DEFAULT 'ORIGDIR'
$!
$RETRY:
$	MCR BCK TAPE:'FILE'/RC=*.*;*
$!
$	DUMMY = 'F$VERIFY(VER)
$	WRITE SYS$OUTPUT " "
$	GOTO LOOP
$!
$!		Normal and error exits
$!
$ABORT:
$	IF $STATUS .NE. %X10068642 THEN $GOTO CANT_FIX
$		ON ERROR THEN $GOTO CANT_FIX
$		CREATE DUMMY.ONE
$		GOTO RETRY
$CANT_FIX:
$	ON CONTROL_Y THEN $CONTINUE
$	ON ERROR THEN $CONTINUE
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT "**** Aborted by control y or by an error ****"
$	GOTO EXIT2
$!
$EXIT:
$!		Make a redundant copy of the .COM's and DIRLIS.DAT
$!
$	SET DEFAULT 'DEFDIR'
$	COPY MAKETAPE.COM TAPE
$	COPY LIST.COM TAPE
$	COPY COPYTAPE.COM TAPE
$	COPY DIRLIS.DAT TAPE
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT "  *** Tape complete ***"
$!
$EXIT2:
$	DISMOUNT/NOUNLOAD TAPE
$	DEALLOCATE TAPE
$!
$CTLY:
$	CLOSE/ERROR=NOTOPEN DIRLIS
$NOTOPEN:
$	SET DEFAULT 'DEFDIR'
$	DUMMY = 'F$VERIFY(VER)
$	DELETE/SYMBOL/GLOBAL VER
$!
$!		End of [DECUS.COPYING]MAKETAPE.COM
$!
