C	VPLOT.FOR:
C	The main file of the VPLOT plotter package for the VAX-11/780
C	and the PRINTRONIX 300 line matrix printer.
C	Language: VAX-11 FORTRAN, version 2.0.
C	Copyright (C) 1981 by M. Gooley.  This software is distributed
C	without cost, and may be reproduced only with the inclusion of
C	this copyright statement.  The author assumes no responsibility
C	for the performance of this software.
C
C	Address all inquiries to:
C
C	M. Gooley
C	c/o Millikin University Computer Center
C	1184 West Main Street
C	Decatur, Illinois 62522
C
C	This is version 2.0 of VPLOT, released 1 MAY 1981.  It has, of
C	course, been tested, and is believed to be free of errors. Most
C	differences between VPLOT and the CalComp plotter routines that
C	it emulates are described in the "The VPLOT Combination User's,
C	Installation, and Reference Manual," a somewhat fragmented guide
C	to VPLOT.  Please report the errors or ambiguities that you find.
C	I apologise for the paucity of comment lines.	--M. Gooley.
C
C************************************************************************
C	PLOTS is the initialisation subroutine.  It sets certain 
C	variables to initial values, creates various COMMONs for implicit
C	passing of variables between routines, and calls the MACRO
C	routine INITIAL.
	SUBROUTINE PLOTS (XLONG,YWIDE,LDEV)
	CHARACTER*135 STRING
	LOGICAL*1 FNREAD,NLAST
	COMMON /COORDS/ USERX,USERY, XORG,YORG,XOLD,YOLD,FACT,FNREAD
	1/AUX/DELTAX,DELTAY
	NDEV=LDEV
	NLAST=.TRUE.
	KWIDE=JINT(YWIDE*2.5+1.)
	IF (KWIDE.GT.33) KWIDE=33
	LONG=JINT(XLONG*1.8+1.)
	CALL INITIAL(%VAL(KWIDE),%VAL(LONG),%REF(NLAST),%REF(LASTEL),
	1 %DESCR(STRING))
C	The call to INITIAL gives the MACRO routines the addresses of
C	certain variables and strings so that data may be passed to and
C	from MACRO routines implicitly, after the fashion of a FORTRAN
C	COMMON; it also sets up a table of base-addresses for the blocks
C	of memory that simulate the main matrix (see the manual for more
C	about this technique.
	USERX=0.
	USERY=0.
	XORG=0.
	YORG=0.
	XOLD=0.
	YOLD=0.
	FACT=1.
	DELTAX=0.
	DELTAY=0.
C		USERX & USERY are the user's x- and y-coordinates in
C	inches, XORG & YORG the dot-coordinates of the user's origin,
C	XOLD & YOLD the dot-coordinates of the "pen's" last position,
C	and FACT is the plot-size scaling factor.
	RETURN
C	this entry, DUMP0, fills the output file FORnnn.DAT, where 'nnn'
C	equals LDEV (0<LDEV<999, with certain numbers reserved [such as
C	5 and 6] for system files, and 1 reserved for CHARGEN.DAT).
C
	ENTRY DUMP0
10	CALL DUMP
	IF (LASTEL.GT.132) THEN
		LASTEL=132
		STRING(132:132)=CHAR(5)
	END IF	! slapdash measure...belongs in MACRO routine DUMP
1	WRITE(NDEV,2),STRING(1:LASTEL)
2	FORMAT(1X,A<LASTEL>)
	IF(NLAST) GO TO 10
	RETURN
	END
C
	SUBROUTINE SKETCH (X1,Y1,X2,Y2)
	I1=JINT(X1)
	J1=JINT(Y1)
	I2=JINT(X2)
	J2=JINT(Y2)
	IF (I1.EQ.I2) THEN
		CALL KTRIV (I1,J1,J2,.TRUE.)
	ELSE IF (J1.EQ.J2) THEN
		CALL KTRIV (J1,I1,I2,.FALSE.)
	ELSE IF (JIABS(I1-I2).GT.JIABS(J1-J2)) THEN
		CALL PROFND (I1,I2,J1,J2,.TRUE.)
	ELSE
		CALL PROFND (J1,J2,I1,I2,.FALSE.)
	END IF
	RETURN
	END
C	service subroutines for SKETCH:
C
C	KTRIV handles the plotting of vertical and horizontal lines...
	SUBROUTINE KTRIV (KON,K1,K2,SW)
	LOGICAL SW
	IF (K1.GT.K2) THEN
		INC=-1
	ELSE
		INC=1
	END IF
	I=K1
	J=K2+INC
	IF (SW) THEN
1		CALL LOAD (%VAL(I),%VAL(KON))
		I=I+INC
		IF (I.NE.J) GO TO 1
	ELSE
2		CALL LOAD (%VAL(KON),%VAL(I))
		I=I+INC
		IF (I.NE.J) GO TO 2
	END IF
	RETURN
	END
C
C	PROFND plots lines with a slope...
	SUBROUTINE PROFND (I1,I2,J1,J2,SW)
	LOGICAL SW
	SLOPE=FLOATJ(J1-J2)/FLOATJ(I1-I2)
	IF (I1.GT.I2) THEN
		INC=-1
	ELSE
		INC=1
	END IF
	I=I1
	J=I2+INC
	IF (SW) THEN
1		KDELT=JNINT((I-I1)*SLOPE)
		KTEMP=J1+KDELT
		CALL LOAD (%VAL(KTEMP),%VAL(I))
		I=I+INC
		IF (I.NE.J) GO TO 1
	ELSE
2		KDELT=JNINT((I-I1)*SLOPE)
		KTEMP=J1+KDELT
		CALL LOAD (%VAL(I),%VAL(KTEMP))
		I=I+INC
		IF (I.NE.J) GO TO 2
	END IF
	RETURN
	END
C	the following subroutine combines the Calcomp PLOT, FACTOR,
C	and WHERE functions...
C
	SUBROUTINE PLOT (XPAGE, YPAGE, IPEN)
	COMMON /COORDS/ USERX,USERY,XORG,YORG,XOLD,YOLD,FACT,FNREAD
	LOGICAL*1 FNREAD
	IF (IPEN.EQ.999) THEN
		CALL DUMP0
	ELSE
		XX=XORG+XPAGE*FACT*72.
		YY=YORG+YPAGE*FACT*60.
		IF (JIABS(IPEN).EQ.2)  CALL SKETCH (XOLD,YOLD,XX,YY)
		XOLD=XX
		YOLD=YY
		IF (IPEN.LT.0) THEN
			XORG=XX
			YORG=YY
			USERX=0.
			USERY=0.
		ELSE
			USERX=XPAGE
			USERY=YPAGE
		END IF
	END IF
	RETURN
	ENTRY FACTOR (RFACT)
	IF (RFACT.EQ.1) THEN
		FACT=1.
	ELSE
		FACT=FACT*RFACT
	END IF
	RETURN
	ENTRY WHERE (RXPAGE,RYPAGE,RFACT)
	RXPAGE=USERX
	RYPAGE=USERY
	RFACT=FACT
	RETURN
	END
C	And now, subroutine SYMBOL. I make no claims for programming 
C	elegance in this routine. The computed GO TO statements are 
C	straight out of the S. J. Gumby school of FORTRAN.  Anyone who
C	can figure out how it works (and frankly, I'm not too certain
C	myself) and has clever suggestions for improving it should
C	write me.
C
	SUBROUTINE SYMBOL (XPAGE, YPAGE, HEIGHT, IBCD, ANGLE, NCHAR)
	CHARACTER IBCD*(*)
C	Note that since IBCD is a character string, plotting of 
C	centred symbols requires a call using "CHAR(n)" for IBCD.
C	This doesn't help the user much but makes things easier for
C	me...
	DIMENSION POINT(129),LINES(580,4)
	BYTE J,K,L,M,LINES
	INTEGER*2 POINT
	LOGICAL*1 FNREAD
	COMMON /COORDS/ USERX,USERY,XORG,YORG,XOLD,YOLD,FACT,FNREAD,
	1/AUX/ DELTAX,DELTAY
C	The following data are the locations of the records within
C	CHARGEN.DAT for the 128 symbols (some of them equivalent to the
C	blank) that SYMBOL can plot.  Note how cleverly I introduce the
C	name of one of DEC's competitors into the FORTRAN code.
C
	DATA POINT /1,6,15,19,21,23,28,32,35,39,42,50,54,58,59,60,63,66,
	1 15*0,69,77,85,89,97,106,116,120,125,130,133,135,140,141,145,
	2 146,155,158,164,173,177,185,194,198,213,222,230,239,241,243,
	3 245,251,261,266,276,283,289,293,296,304,307,310,314,318,320,
	4 324,327,335,341,350,357,368,370,375,377,381,387,392,397,400,
	5 401,404,407,410,411,419,427,432,440,448,452,462,466,473,481,
	6 484,487,494,499,507,515,523,526,533,536,541,543,547,549,555,
	7 558,564,566,572,575,581/
C	And now we take care of the '999' continuation feature...
	IF (XPAGE.EQ.999) THEN
		XNEW=XOLD
	ELSE
		XNEW=XORG+XPAGE*FACT*72.
	END IF
	IF (YPAGE.EQ.999) THEN
		YNEW=YOLD
	ELSE
		YNEW=YORG+YPAGE*FACT*60.
	END IF
C	This loads the array LINES with the "character-generator" data
C	on the first call to SYMBOL.  Note that FNREAD is reset to 
C	prevent unecessary repeated calls.
	IF (.NOT.FNREAD) THEN
C************************************************************************
C************************************************************************
C*****THE FOLLOWING 'OPEN' STATEMENT WILL HAVE TO BE MODIFIED IF THE*****
C*****DATA FILE 'CHARGEN.DAT' IS IN A DIRECTORY OTHER THAN THAT IN*******
C*****WHICH THE MAIN PROGRAM IS BEING RUN. SEE SECTION VI. OF THE********
C*****MANUAL FOR FURTHER DETAILS....................................*****
C************************************************************************
		OPEN (UNIT=1,NAME='CHARGEN.DAT',TYPE='OLD',READONLY)
C************************************************************************
C************************************************************************
		READ (1,1),((LINES(I,II),II=1,4),I=1,580)
1		FORMAT (1X,72I1)
		DO 2 I=1,580
		DO 2 II=1,4
2		LINES(I,II)=LINES(I,II)-6
		FNREAD=.TRUE.
	END IF
C	This next bit ensures a positive angle...
3	IF (ANGLE.GE.0) GO TO 4
	ANGLE=ANGLE+360.
	GO TO 3
C	...and this a small enough angle...
4	IF (ANGLE.LT.360) GO TO 5
	ANGLE=ANGLE-360.
	GO TO 4
5	FTH=FACT*HEIGHT
	IF (AMOD(ANGLE,90.).EQ.0.OR.ANGLE.EQ.0) THEN
		DELTAX=0.
		DELTAY=0.
		GO TO (10,20,30,40),JNINT(ANGLE/90.)+1
C	Crude, this...
10		DELTAX=FTH*72.
		INDIC=1
		GO TO 50
20		DELTAY=FTH*60.
		INDIC=2
		GO TO 50
30		DELTAX=-FTH*72.
		INDIC=3
		GO TO 50
40		DELTAY=-FTH*60.
		INDIC=4
50		CONTINUE
		ELSE
		INDIC=5
		RANGLE=ANGLE*3.14159265/180.
		DELTAX=COS(RANGLE)*FTH*72.
		DELTAY=SIN(RANGLE)*FTH*60.
	END IF
C	if NCHAR=-2, then a line is drawn from the last position...
	IF (NCHAR.LT.-1) THEN
		CALL SKETCH (XOLD,YOLD,XNEW,YNEW)
		LENGTH=1
	ELSE
		LENGTH=LEN(IBCD)
	END IF
	FACT2=10.*FTH
	DO 130 I=1,LENGTH
	INDEX=ICHAR(IBCD(I:I))+1
	KSTART=POINT(INDEX)
	IF (KSTART.EQ.0) GO TO 120
	KEND=POINT(INDEX+1)-1
	IF (KEND.LT.0) KEND=68
	DO 115	KS=KSTART,KEND
	J=LINES(KS,1)
	K=LINES(KS,2)
	L=LINES(KS,3)
	M=LINES(KS,4)
C	I hate doing this...
	GO TO (60,70,80,90,100), INDIC
60	A=J
	B=K
	C=L
	D=M
	GO TO 110
70	A=-K
	B=J
	C=-M
	D=L
	GO TO 110
80	A=-J
	B=-K
	C=-L
	D=-M
	GO TO 110
90	A=K
	B=-J
	C=M
	D=-L
	GO TO 110
100	CALL ROTATE (J,K,A,B,RANGLE)
	CALL ROTATE (L,M,C,D,RANGLE) !ROTATE does the dirty work...
110	CALL SKETCH(XNEW+FACT2*1.2*A,YNEW+FACT2*B,XNEW+FACT2*1.2*C,YNEW
	1+FACT2*D)
115	CONTINUE
120	XNEW=XNEW+DELTAX
	YNEW=YNEW+DELTAY
130	CONTINUE
C	Now some general mopping up...
	IF (NCHAR.GE.0) THEN
		XOLD=XNEW
		YOLD=YNEW
		USERX=(XOLD-XORG)/(FACT*72.)
		USERY=(YOLD-YORG)/(FACT*60.)
	END IF
	RETURN
	END
C	A service routine for SYMBOL...
	SUBROUTINE ROTATE (X,Y,XP,YP,ANGLE)
	BYTE X,Y
C	this routine converts Cartesian to polar coordinates, adds the
C	angle of rotation to THETA, then converts back to Cartesians...
	IF (X.EQ.0) THEN !got to prevent an error w/"ATAN2"...
		RHO=Y
		THETA=1.5707963 !or pi/2...
	ELSE IF (Y.EQ.0) THEN   !trivial case...
		RHO=X
		THETA=0
	ELSE
		X1=X
		Y1=Y
		RHO=SQRT(X1*X1+Y1*Y1)
		THETA=ATAN2(Y1,X1)
	END IF
	ANGLE2=THETA+ANGLE
	XP=RHO*COS(ANGLE2)
	YP=RHO*SIN(ANGLE2)
	RETURN
	END
C	NUMBER, another Calcomp routine, uses SYMBOL to plot numbers
C	in floating-point format...
C
C	This is the new version 2.0 NUMBER that uses Run-Time routines...
C
	SUBROUTINE NUMBER (XPAGE,YPAGE,HEIGHT,FPN,ANGLE,NDEC)
	CHARACTER*20 ITS
	DIMENSION TRUNK(9)
	DATA TRUNK /10.,100.,1000.,10000.,100000.,1000000.,10000000.,
	1 100000000.,1000000000./
	IF (NDEC.GT.0) THEN
		IF (NDEC.GT.10) NDEC=10
		L=FOR$CVT_D_TF (FPN,ITS,%VAL(NDEC))
		IF (ITS(1:1).EQ.'*') THEN
			ISTART=11
		ELSE
			ISTART=LIB$SKPC (' ',ITS)
		END IF
	ELSE
		IF (NDEC.LT.-1) THEN
			NT=-NDEC-1
			IF (NT.GT.9) NT=9
			TEMP=FPN/TRUNK(NT)
		ELSE
			TEMP=FPN
		END IF
		IF(ABS(TEMP).GT.2147483647) THEN
			ITS(11:20)='**********'
			ISTART=11
		ELSE
			NUM=JNINT(TEMP)
			L=OTS$CVT_L_TI (NUM,ITS)
			ISTART=LIB$SKPC (' ',ITS)
			IF (NDEC.EQ.0) THEN
				ITS(ISTART-1:19)=ITS(ISTART:20)
				ITS(20:20)='.'
				ISTART=ISTART-1
			END IF
		END IF
	END IF
	CALL SYMBOL(XPAGE,YPAGE,HEIGHT,ITS(ISTART:20),ANGLE,0)
	RETURN
	END
C	The next routine scales data in an array to an axis of given 
C	size. The IF-ELSE IF trees are more Gumby programming...
C
	SUBROUTINE SCALE (ARRAY,AXLEN,NPTS,INC)
	DIMENSION ARRAY ((NPTS+1)*JIABS(INC)+1)
	INC2=JIABS(INC)
	ZMAX=ARRAY(1)
	ZMIN=ZMAX
	LASTP=NPTS*INC2
	DO 1 I=1+INC2,LASTP,INC2
	TEMP=ARRAY(I)
	ZMAX=AMAX1(ZMAX,TEMP)
1	ZMIN=AMIN1(ZMIN,TEMP)
	UPI=(ZMAX-ZMIN)/AXLEN
	LENGTH=JINT(ALOG10(UPI))
	SL=10.**LENGTH
	IF (INC.LT.0) SL=-SL
	PRLMDT=UPI/ABS(SL)
2	IF (PRLMDT.EQ.1) THEN
		DELTAV=SL
	ELSE IF (PRLMDT.LE.2) THEN
		DELTAV=2.*SL
	ELSE IF (PRLMDT.LE.4) THEN
		DELTAV=4.*SL
	ELSE IF (PRLMDT.LE.5) THEN
		DELTAV=5.*SL
	ELSE IF (PRLMDT.LE.8) THEN
		DELTAV=8.*SL
	ELSE
		DELTAV=10.*SL
	END IF  ! 'Strewth.
	FIRSTV=0.
	IF (INC.GT.0) THEN
		IF (ZMIN.LE.0) THEN
3			FIRSTV=FIRSTV-DELTAV
			IF (FIRSTV.GT.ZMIN) GO TO 3
		ELSE
			FIRSTV=-DELTAV
4			FIRSTV=FIRSTV+DELTAV
			IF (FIRSTV+DELTAV.LT.ZMIN) GO TO 4
		END IF
		XLASTV=AXLEN*DELTAV+FIRSTV
		IF (XLASTV.GE.ZMAX) GO TO 7
	ELSE
		IF (ZMAX.LE.0) THEN
			FIRSTV=-DELTAV
5			FIRSTV=FIRSTV+DELTAV
			IF (FIRSTV+DELTAV.LT.ZMAX) GO TO 5
		ELSE
6			FIRSTV=FIRSTV-DELTAV
			IF (FIRSTV.LT.ZMAX) GO TO 6
		END IF
		XLASTV=AXLEN*DELTAV+FIRSTV
		IF (XLASTV.LE.ZMIN) GO TO 7
	END IF
	PRLMDT=DELTAV*1.1/SL
	GO TO 2
7	ARRAY(LASTP+1)=FIRSTV
	ARRAY(LASTP+INC2+1)=DELTAV
	RETURN
	END
C	the following routine draws an axis w/annotation & tic marks
C	every inch...
C
	SUBROUTINE AXIS(XPAGE,YPAGE,IBCD,NCHAR,AXLEN,ANGLE,FIRSTV,
	1DELTAV)
	CHARACTER IBCD*(*) ! again, string length is passed implicitly.
	RANGLE=ANGLE/57.29578
	XDISP=COS(RANGLE)
	YDISP=SIN(RANGLE)  !a bit slower but cleaner than in SYMBOL...
	IF (AMOD(ANGLE,90.).EQ.0) THEN  !ensures solid axes...
		XDISP=ANINT(XDISP)
		YDISP=ANINT(YDISP)
	END IF
	CALL PLOT (XPAGE,YPAGE,3) !easier in this case to call PLOT...
	CALL PLOT (XPAGE+AXLEN*XDISP,YPAGE+AXLEN*YDISP,2)
	DV=DELTAV
	N=0
1	IF (ABS(DV).GT.(0.01)) GO TO 2
	DV=DV*10.
	N=N-1
	GO TO 1
2	IF (ABS(DV).LT.100) GO TO 3
	DV=DV/10.
	N=N+1
	GO TO 2
3	SFCT=10.**N  ! ech.
	FV=FIRSTV/SFCT
	XL=XPAGE
	YL=YPAGE
	XTIC=YDISP/16.
	Q=FLOATJ(ISIGN(1,NCHAR))
	YTIC=XDISP/16. !not an error since tics are perp. to the line
	DO 4 I=0,JINT(AXLEN)
	CALL PLOT (XL,YL,3)
	CALL PLOT (XL-Q*XTIC,YL+Q*YTIC,2)
	CALL NUMBER (XL-2.*Q*XTIC,YL+2.*Q*YTIC,.1,FV,ANGLE,2)
	XL=XL+XDISP
	YL=YL+YDISP
4	FV=FV+DV
	STRLEN=LEN(IBCD)
	IF (N.NE.0) STRLEN=STRLEN+5.
	XS=XPAGE+XDISP*(AXLEN/2.-.1*STRLEN)
	YS=YPAGE+YDISP*(AXLEN/2.-.1*STRLEN)
	CALL SYMBOL (XS-.3*Q*YDISP,YS+.3*Q*XDISP,.2,IBCD,ANGLE,STRLEN)
	IF (N.NE.0) THEN !repeating myself...
		CALL SYMBOL (999.,999.,.2,'  *10',ANGLE,5)
		XS1=XPAGE+XDISP*(AXLEN/2.+.1*STRLEN)
		YS1=YPAGE+YDISP*(AXLEN/2.+.1*STRLEN)
		IF (NCHAR.LT.0) THEN
			CALL NUMBER (XS1+.25*YDISP,YS1-.25*XDISP,.1,
	1		FLOATJ(N),ANGLE,-1)
		ELSE
			CALL NUMBER (XS1-.35*YDISP,YS1+.35*XDISP,.1,
	1		FLOATJ(N),ANGLE,-1)
		END IF
	END IF
	RETURN
	END
C	The following routine plots a line, with or without plot 
C	symbols, between points with x- and y-coordinates in two arrays
C
	SUBROUTINE LINE (XARRAY,YARRAY,NPTS,INC,LINTYP,INTEQ)
	DIMENSION XARRAY((NPTS+1)*JIABS(INC)+1), YARRAY((NPTS+1)*JIABS
	1(INC)+1)
	INC2=JIABS(INC)
	LASTP=NPTS*INC2
	N1=LASTP+1
	N2=LASTP+INC+1
	XFRSTV=XARRAY(N1)
	XDELTV=XARRAY(N2)
	YFRSTV=YARRAY(N1)
	YDELTV=YARRAY(N2)
	ILT=JIABS(LINTYP)
	N=ILT-1
	DO 1 I=1,LASTP,INC2
	X=(XARRAY(I)-XFRSTV)/XDELTV
	Y=(YARRAY(I)-YFRSTV)/YDELTV
	N=N+1
	IF (I.EQ.1) THEN
		IF (LINTYP.NE.0) CALL SYMBOL(X,Y,.1,CHAR(INTEQ),0.,-1)
	CALL PLOT (X,Y,3)
	ELSE
		IF (LINTYP.GE.0) THEN
			CALL PLOT (X,Y,2)
		ELSE
			CALL PLOT (X,Y,3)
		END IF
		IF(ILT.NE.0.AND.JMOD(N,ILT).EQ.0) CALL SYMBOL(X,Y,.1,CHAR
	1(INTEQ),0.,-1)
	END IF
1	CONTINUE
	RETURN
	END
C
C
	SUBROUTINE CIRCL(XPAGE,YPAGE,THO,THF,RO,RF,DI)
	COMMON /COORDS/USERX,USERY,XORG,YORG,XOLD,YOLD,FACT,FNR
	1 /DASH1/ DASHT,LENDSH,INCR
	LOGICAL*1 FNR,DASHAL,DASHT,POS
	IF (THO.EQ.THF) THEN
		CALL PLOT (XPAGE,YPAGE,3)	! perhaps not best way
		GO TO 4
	END IF
	IF (DI.EQ.0.5) THEN
		DASHAL=.TRUE.
		DASHT=.TRUE.
		LENDSH=6
		INCR=0
	ELSE
		DASHAL=.FALSE.
	END IF
	THETA0=THO/57.29578
	THETAF=THF/57.29578
	XS=XORG+XPAGE*FACT*72.
	YS=YORG+YPAGE*FACT*60.
	CALL LOAD (%VAL(JNINT(YS)),%VAL(JNINT(XS)))
	R0=RO*FACT*60.
	R1=RF*FACT*60.
	XC=XS-1.2*R0*COS(THETA0)
	YC=YS-R0*SIN(THETA0)
	IF (THO.LT.THF) THEN
		DIR=1.
		POS=.TRUE.
	ELSE
		DIR=-1.
		POS=.FALSE.
	END IF
	THETA=THETA0
	IF (RO.EQ.RF) THEN
		IF (RO.EQ.0) GO TO 3
		DTHETA=1./(R0*1.2)
1		THETA=THETA+DIR*DTHETA
		J=JNINT(XC+1.2*R0*COS(THETA))
		K=JNINT(YC+R0*SIN(THETA))
		IF (DASHAL) THEN
			CALL OHDASH(J,K)
		ELSE
			CALL LOAD(%VAL(K),%VAL(J))
		END IF
		IF ((THETA.LT.THETAF.AND.POS).OR.(THETA.GT.THETAF.AND.
	1(.NOT.POS))) GO TO 1
	ELSE
		A=(R1-R0)/(THETAF-THETA0)
		T00=THETA0-R0/A
		CTF=THETAF-T00
2		CT0=THETA-T00
		CT2=CT0*CT0
		CURVTR=(CT2+2.)/(ABS(A)*(CT2+1.)*SQRT(CT2+1.)*1.2)
		THETA=THETA+DIR*CURVTR
		R=A*CT0
		J=JNINT(XC+1.2*R*COS(THETA))
		K=JNINT(YC+R*SIN(THETA))
		IF (DASHAL) THEN
			CALL OHDASH(J,K)
		ELSE
			CALL LOAD(%VAL(K),%VAL(J))
		END IF
		IF ((THETA.LT.THETAF.AND.POS).OR.(THETA.GT.THETAF.AND.
	1(.NOT.POS))) GO TO 2
	END IF
3	XC=XC+1.2*R1*COS(THETAF)
	YC=YC+R1*SIN(THETAF)
	USERX=(XC-XORG)/(FACT*72.)
	USERY=(YC-YORG)/(FACT*60.)
	XOLD=XC
	YOLD=YC
4	RETURN
	END
C
C
	SUBROUTINE OHDASH(J,K)
	COMMON /DASH1/ DASHT,LENDSH,INCR
	LOGICAL*1 DASHT
	INCR=INCR+1
	IF (INCR.GT.LENDSH) THEN
		INCR=0
		DASHT=.NOT.DASHT
	END IF
	IF(DASHT) CALL LOAD (%VAL(K),%VAL(J))
	RETURN
	END
C
C
	SUBROUTINE ELIPS(XPAGE,YPAGE,RMAJ,RMIN,ANGLE,THO,THF,IPEN)
	COMMON /COORDS/USERX,USERY,XORG,YORG,XOLD,YOLD,FACT,FNR
	PARAMETER DEGRAD=57.29578
	LOGICAL*1 FNR,POS
	IF (RMAJ.EQ.RMIN) THEN
		CALL CIRCL (XPAGE,YPAGE,THO+ANGLE,THF+ANGLE,RMAJ,RMAJ,0.)
		GO TO 2
	END IF
	CALL PLOT (XPAGE,YPAGE,IPEN)
	IF (THO.EQ.THF) GO TO 2
	THETA0=THO/DEGRAD
	THETAF=THF/DEGRAD
	RANGL=ANGLE/DEGRAD
	ANG2=THETA0+RANGL
	ZMAJ=RMAJ*FACT*60.
	ZMIN=RMIN*FACT*60.
	IF (THO.LT.THF) THEN
		DIR=1.
		POS=.TRUE.
	ELSE
		DIR=-1.
		POS=.FALSE.
	END IF
	THETA=THETA0
	C=SQRT(ZMAJ*ZMAJ-ZMIN*ZMIN)
	E=C/ZMAJ
	D=ZMAJ/E-ZMAJ*E
	C2=ZMAJ-C
	XC=XOLD-1.2*C2*COS(ANG2)
	YC=YOLD-C2*SIN(ANG2)
	E2=E*E
	ED=E*D
1	Z=E*COS(THETA)
	ZP1=Z+1.
	Q=1+Z*(2.+3.*Z)+E2
	CURVTR=ZP1*ZP1*ABS(Q-Z)/(ED*Q*SQRT(Q)*1.2)
	THETA=THETA+DIR*CURVTR
	R=ED/(1.+E*COS(THETA))
	ANG2=THETA+RANGL
	J=JNINT(XC+1.2*R*COS(ANG2))
	K=JNINT(YC+R*SIN(ANG2))
	CALL LOAD(%VAL(K),%VAL(J))
		IF ((THETA.LT.THETAF.AND.POS).OR.(THETA.GT.THETAF.AND.
	1(.NOT.POS))) GO TO 1
	XC=XC+1.2*R*COS(THETA)
	YC=YC+R*SIN(THETA)
	USERX=(XC-XORG)/(FACT*72.)
	USERY=(YC-YORG)/(FACT*60.)
	XOLD=XC
	YOLD=YC
2	RETURN
	END
C
C
	SUBROUTINE GRID (XPAGE,YPAGE,DELTAX,DELTAY,NXSP,NYSP)
	X=XPAGE
	Y2=YPAGE+DELTAY*NYSP
	DO 1 I=0,NXSP
	CALL PLOT (X,YPAGE,3)
	CALL PLOT (X,Y2,2)
1	X=X+DELTAX
	Y=YPAGE
	X2=XPAGE+DELTAX*NXSP
	DO 2 I=0,NYSP
	CALL PLOT (XPAGE,Y,3)
	CALL PLOT (X2,Y,2)
2	Y=Y+DELTAY
	RETURN
	END
C
C
	SUBROUTINE POLY (XPAGE,YPAGE,SLEN,SN,ANGLE)
	PARAMETER PI=3.14159265, PIV2=1.5707963
	CALL PLOT (XPAGE,YPAGE,3)
	SMINC=PI/SN
	BIGINC=SMINC*2.
	RANG=ANGLE/57.29578
	N=JNINT(ABS(SN))
	IF (SN.GT.0) THEN	! convex polygon of SN sides
		ANG=RANG-PIV2-SMINC
		R=SLEN/2./SIN(PI/SN)
		ANG0=PIV2-SMINC+RANG
		XC=XPAGE+R*COS(ANG0)
		YC=YPAGE+R*SIN(ANG0)
		DO 1 I=1,N
		ANG=ANG+BIGINC
		CALL PLOT (XC+R*COS(ANG),YC+R*SIN(ANG),2)
1		CONTINUE
	ELSE
		ANG=RANG+PIV2-BIGINC
		RATIO=SLEN/SIN(-SMINC)
		VSANG=PIV2+BIGINC
		R=RATIO*SIN(VSANG)
		RBIG=RATIO*SIN(PIV2-SMINC)
		ANG0=RANG-VSANG
		XC=XPAGE+RBIG*COS(ANG0)
		YC=YPAGE+RBIG*SIN(ANG0)
		DO 2 I=1,N
		ANG=ANG+SMINC
		CALL PLOT (XC+R*COS(ANG),YC+R*SIN(ANG),2)
		ANG=ANG+SMINC
		CALL PLOT (XC+RBIG*COS(ANG),YC+RBIG*SIN(ANG),2)
2		CONTINUE
	END IF
	RETURN
	END
C
C
C
C	Special thanks to J. Westcot for spotting an error in the
C	following routine:
	SUBROUTINE DASHP (XPAGE, YPAGE, DASH)
	COMMON /COORDS/ USERX,USERY,XORG,YORG,XOLD,YOLD,FACT,FNREAD
	LOGICAL*1 FNREAD,HIC
	DELX=XPAGE-USERX
	DELY=YPAGE-USERY
	TLEN=SQRT(DELX*DELX+DELY*DELY)
	IF (DASH.GE.TLEN/2.)THEN
		RATIO=2.
		N=2
	ELSE
		RATIO=TLEN/DASH
		N=JINT(RATIO)
	END IF
	CHX=DELX/RATIO
	CHY=DELY/RATIO
	HIC=.FALSE.
	X=USERX
	Y=USERY
	DO 1 I=1,N
	HIC=.NOT.HIC
	X=X+CHX
	Y=Y+CHY
	IF (HIC) THEN
		CALL PLOT (X,Y,2)
	ELSE
		CALL PLOT (X,Y,3)
	END IF
1	CONTINUE
	CALL PLOT (XPAGE,YPAGE,2)
	RETURN
	END
C
C
	SUBROUTINE DASHL (XARRAY,YARRAY,NPTS,INC)
	DIMENSION XARRAY((NPTS+1)*JIABS(INC)+1), YARRAY((NPTS+1)*JIABS
	1(INC)+1)
	N1=NPTS*INC+1
	N2=NPTS*INC+INC+1
	XFRSTV=XARRAY(N1)
	XDELTV=XARRAY(N2)
	YFRSTV=YARRAY(N1)
	YDELTV=YARRAY(N2)
	DO 1 I=1,NPTS,INC
	X=(XARRAY(I)-XFRSTV)/XDELTV
	Y=(YARRAY(I)-YFRSTV)/YDELTV
	CALL DASHP (X,Y,.1)
1	CONTINUE
	RETURN
	END
C
C
	SUBROUTINE RECT (XPAGE,YPAGE,HEIGHT,WIDTH,ANGLE,IPEN)
	DIMENSION FOUR (4,2)
	RANG=ANGLE/57.29578
	CALL PLOT (XPAGE,YPAGE,IPEN)
	SINE=SIN(RANG)
	COSINE=COS(RANG)
	FOUR(4,1)=XPAGE
	FOUR(4,2)=YPAGE
	CW=COSINE*WIDTH
	SW=SINE*WIDTH
	FOUR(1,1)=XPAGE+CW
	FOUR(1,2)=YPAGE+SW
	FOUR(2,1)=FOUR(1,1)-SINE*HEIGHT
	FOUR(2,2)=FOUR(1,2)+COSINE*HEIGHT
	FOUR(3,1)=FOUR(2,1)-CW
	FOUR(3,2)=FOUR(2,2)-SW
	DO 1 I=1,4
	CALL PLOT (FOUR(I,1),FOUR(I,2),2)
1	CONTINUE
	RETURN
	END
	SUBROUTINE POLAR(RADAR,ANGAR,NPTS,INC,LINTYP,INTEQ,RMAX,DR)
	DIMENSION RADAR(NPTS),ANGAR(NPTS)
	INC2=JIABS(INC)
	LASTP=NPTS*INC2
	IF (RMAX.GT.0) THEN
		ZMAX=ABS(RADAR(1))
		DO 1 I=INC2+1,LASTP,INC2
1		ZMAX=AMAX1(ZMAX,ABS(RADAR(I)))
		D=ZMAX/RMAX
	ELSE
		D=DR
	END IF
	ILT=JIABS(LINTYP)
	N=ILT-1
	DO 2 I=1,LASTP,INC2
	RHO=RADAR(I)/D
	X=COS(ANGAR(I))*RHO
	Y=SIN(ANGAR(I))*RHO
	N=N+1
	IF (I.EQ.1) THEN
		IF (LINTYP.NE.0) CALL SYMBOL (X,Y,.1,CHAR(INTEQ),0.,-1)
		CALL PLOT (X,Y,3)
	ELSE
		IF (LINTYP.GE.0) THEN
			CALL PLOT (X,Y,2)
		ELSE
			CALL PLOT (X,Y,3)
		END IF
		IF (ILT.NE.0.AND.JMOD(N,ILT).EQ.0) CALL SYMBOL (X,Y,.1,
	1CHAR(INTEQ),0.,-1)
	END IF
2	CONTINUE
	RETURN
	END
